///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 4nd order in time
// 10th order in space
// with expontential tapering boundary condition
//mod: veldtinvdx2, epsf, deltaf
//veldtinvdx2: (v*dt/vx)^2
//epsf: (1+2*eps)*(v*dt/vx)^2
//deltaf: sqrt(1+2*delta)*(v*dt/vx)^2
int XC2dVTIWaveprop_1step4t10spacetest1opt(float *mod, \
	                                      float *wvp1, float *wvp2, float *wvp3, float *wvtmpp, \
                                              float *wvr1, float *wvr2, float *wvr3, float *wvtmpr, \
                                              int izmin, int izmax)
{
  int fat,fat2,curidx,curidx1;
  int ix,iz;
  int iz1,iz2;
  fat=5;
  fat2=5;

  float tmpp, tmpr;
  /*float *wvt1,*wvt2,*wvt3;
  wvt1=XC2dVTIWaveprop_wavet1;
  wvt2=XC2dVTIWaveprop_wavet2;
  wvt3=XC2dVTIWaveprop_wavet3;
  */
  int nx,nz;
  nx=XC2dWaveprop_nx;
  nz=XC2dWaveprop_nz;
  int nxtape,nztape;
  nxtape=XC2dWaveprop_nxtape;
  nztape=XC2dWaveprop_nztape;

  iz1=max(0+fat,izmin);
  iz2=min(nz-fat,izmax);

  iz1=0+fat; 
  iz2=nz-fat; 

  float a5=1./3150.;
  float a4=-5./1008.;
  float a3=5./126.;
  float a2=-5./21.;
  float a1=5./3.;
  float a0=a1+a2+a3+a4+a5;

  
  float curv,scurv;
  float curval,outval;
  float outval1,outval2;
  float tpwht=0.25f;
     //#pragma omp parallel for private(izbegpad,izendpad,whtzbegpad,whtzendpad,ixbegpad,ixendpad,whtxbegpad,whtxendpad,curidx,curval,temp1,outval) schedule(dynamic,8)
  float *veldtinvdx2, *epsf, *deltaf;
  veldtinvdx2=&mod[0]; 
  epsf=&mod[nx*nz]; 
  deltaf=&mod[2*nx*nz]; 
  
  #pragma omp parallel for private(curidx,tmpr,tmpp,ix,iz) schedule(dynamic,8)
  for (ix=0+fat;ix<nx-fat;ix++)
  {
     //#pragma omp parallel for private(curidx,tmpr,tmpp,iz) schedule(dynamic,8)
     for (iz=iz1;iz<iz2;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       //curidx1=Wpxzloc(iz,ix);
 
       tmpr = a5*wvr2[ curidx-5 ] + a4*wvr2[ curidx-4 ] + a3*wvr2[ curidx-3 ] + a2*wvr2[ curidx-2 ] + a1*wvr2[ curidx-1 ] - 2.0*a0*wvr2[curidx] + a1*wvr2[ curidx+1 ] + a2*wvr2[ curidx+2 ] + a3*wvr2[ curidx+3 ] + a4*wvr2[ curidx+4 ] + a5*wvr2[ curidx+5 ] ;
       //tmpr = a5*(wvr2[ curidx-5 ]+wvr2[ curidx+5 ]) + a4*(wvr2[ curidx-4 ]+wvr2[ curidx+4 ]) + a3*(wvr2[ curidx-3 ]+wvr2[ curidx+3]) + a2*(wvr2[ curidx-2 ]+wvr2[ curidx+2 ]) + a1*(wvr2[ curidx-1 ]+wvr2[ curidx+1 ]) -2.0*a0*wvr2[ curidx ];
       tmpp = a5*wvp2[ curidx-5*nz ] + a4*wvp2[ curidx-4*nz ] + a3*wvp2[ curidx-3*nz ] + a2*wvp2[ curidx-2*nz ] + a1*wvp2[ curidx-1*nz ] -2.*a0*wvp2[ curidx ] + a1*wvp2[ curidx+1*nz ] + a2*wvp2[ curidx+2*nz ] + a3*wvp2[ curidx+3*nz ] + a4*wvp2[ curidx+4*nz ] + a5*wvp2[ curidx+5*nz ] ;
       //tmpp = a5*(wvp2[ curidx-5*nz ]+wvp2[ curidx+5*nz ]) + a4*(wvp2[ curidx-4*nz ]+wvp2[ curidx+4*nz ]) + a3*(wvp2[ curidx-3*nz ]+wvp2[ curidx+3*nz ]) + a2*(wvp2[ curidx-2*nz ]+wvp2[ curidx+2*nz ]) + a1*(wvp2[ curidx-1*nz ]+wvp2[ curidx+1*nz ]) -2.*a0*wvp2[ curidx ] ;
       
       //tmpr= a5*wvr2[ Wpzxloc(iz-5,ix) ] +   a4*wvr2[ Wpzxloc(iz-4,ix) ] + a3*wvr2[ Wpzxloc(iz-3,ix) ] + a2*wvr2[ Wpzxloc(iz-2,ix) ] + a1*wvr2[ Wpzxloc(iz-1,ix) ] - 2.0*a0*wvr2[curidx] + a1*wvr2[ Wpzxloc(iz+1,ix) ] + a2*wvr2[ Wpzxloc(iz+2,ix) ] + a3*wvr2[ Wpzxloc(iz+3,ix) ] + a4*wvr2[ Wpzxloc(iz+4,ix) ] + a5*wvr2[ Wpzxloc(iz+5,ix) ] ;
       //tmpp = a5*wvp2[ Wpxzloc(iz,ix-5) ] + a5*wvp2[ Wpxzloc(iz,ix+5) ]+a4*wvp2[ Wpxzloc(iz,ix-4) ] + a4*wvp2[ Wpxzloc(iz,ix+4) ] + a3*wvp2[ Wpxzloc(iz,ix-3) ] + a3*wvp2[ Wpxzloc(iz,ix+3) ] + a2*wvp2[ Wpxzloc(iz,ix-2) ] + a2*wvp2[ Wpxzloc(iz,ix+2) ] + a1*wvp2[ Wpxzloc(iz,ix-1) ] + a1*wvp2[ Wpxzloc(iz,ix+1) ] - 2.0*a0*wvp2[curidx1] ;
       
       wvtmpp[curidx] = tmpp*epsf[curidx]+tmpr*deltaf[curidx];
       wvtmpr[curidx] = tmpp*deltaf[curidx]+tmpr*veldtinvdx2[curidx];

     } 
  } 

  a2=-1./12.;
  a1=4./3.;
  a0=a1+a2;
  #pragma omp parallel for private(curidx,tmpp,tmpr,ix,iz) schedule(dynamic,8)
  for (ix=0+fat;ix<nx-fat;ix++)
  {
     //#pragma omp parallel for private(curidx,curidx1,tmpp,tmpr,iz) schedule(dynamic,8)
     for (iz=iz1;iz<iz2;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       //curidx1=Wpxzloc(iz,ix);
 
       tmpr=  a2*wvtmpr[ curidx-2 ] + a1*wvtmpr[ curidx-1 ] - 2.0*a0*wvtmpr[curidx] + a1*wvtmpr[ curidx+1 ] + a2*wvtmpr[ curidx+2 ] ;
       //tmpp = a2*wvtmpp[ curidx1-2 ] + a1*wvtmpp[ curidx1-1 ] -2.0*a0*wvtmpp[ curidx1 ] + a1*wvtmpp[ curidx1+1 ] + a2*wvtmpp[curidx1+2] ;
       tmpp = a2*wvtmpp[ curidx-2*nz ] + a1*wvtmpp[ curidx-1*nz ] -2.0*a0*wvtmpp[ curidx ] + a1*wvtmpp[ curidx+1*nz ] + a2*wvtmpp[curidx+2*nz] ;

       wvp3[curidx] = 2.0*wvp2[curidx]- wvp1[curidx] + wvtmpp[curidx] - a2*(tmpp*epsf[curidx]+tmpr*deltaf[curidx]) ;
       wvr3[curidx] = 2.0*wvr2[curidx]- wvr1[curidx] + wvtmpr[curidx] - a2*(tmpp*deltaf[curidx]+tmpr*veldtinvdx2[curidx]) ;
    }
  }
  /*
  ////////////////////////////////////////////////////
  //boundary condition
  #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=nxtape;ix<nx-nxtape;ix++)
  {
     //beg z boundary

     for (iz=nztape-1;iz>=0+fat;iz--)
     {
       curidx=Wpzxloc(iz,ix);
       wvr3[curidx] *= exp((tpwht*(iz-nztape))/(nztape-1));
       wvp3[curidx] *= exp((tpwht*(iz-nztape))/(nztape-1));
     }
     //end z boundary
     for (iz=nz-nztape;iz<nz-fat;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       wvr3[curidx] *= exp((tpwht*(nz-nztape-iz))/(nztape-1));
       wvp3[curidx] *= exp((tpwht*(nz-nztape-iz))/(nztape-1));
     }
  }
  //beg x boundary
  #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=nxtape-1;ix>0+fat;ix--)
  {
     for (iz=0+fat;iz<nz-fat;iz++)
    {
         curidx=Wpzxloc(iz,ix);
         wvr3[curidx] *= exp((tpwht*(ix-nxtape))/(nxtape-1));
         wvp3[curidx] *= exp((tpwht*(ix-nxtape))/(nxtape-1));
     }
  }
  //end x boundary
  #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=nx-nxtape;ix<nx-fat;ix++)
  {
     for (iz=0+fat;iz<nz-fat;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       wvr3[curidx] *= exp((tpwht*(nx-nxtape-ix))/(nxtape-1));
       wvp3[curidx] *= exp((tpwht*(nx-nxtape-ix))/(nxtape-1));
     }
  }
  */
  
  ////////////////////////////////////////////////////
  //boundary condition
  #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=nxtape;ix<nx-nxtape;ix++)
  {
     //beg z boundary

     for (iz=nztape-1;iz>=0+fat+fat2;iz--)
     {
       curidx=Wpzxloc(iz,ix);
       outval=wvr3[ curidx ];
       curval=wvr2[ curidx ];
       //curv=veldtinvdx2[curidx];
       curv=deltaf[curidx];
       scurv=sqrtf(curv);
       //outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-curval)+curv*(wvr2[Wpzxloc(iz-1,ix)]-curval));
       outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-curval)+curv*(wvr2[curidx-1]-curval));
       wvr3[curidx] = outval;
       //curidx1=Wpxzloc(iz,ix);
       wvp3[curidx] = outval;
     }
     for (iz=0+fat+fat2;iz>=0+fat;iz--)
     {
       curidx=Wpzxloc(iz,ix);
       curval=wvr2[ curidx ];
       //curv=veldtinvdx2[curidx];
       curv=deltaf[curidx];
       scurv=sqrtf(curv)*1.2;
       //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvr1[Wpzxloc(iz+1,ix)]))+wvr2[Wpzxloc(iz+1,ix)];
       outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvr3[curidx+1]))+wvr2[curidx+1];
       wvr3[curidx] = outval;
       //curidx1=Wpxzloc(iz,ix);
       wvp3[curidx] = outval;
     }
     //end z boundary
     for (iz=nz-nztape;iz<nz-fat-fat2;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       outval=wvr3[ curidx ];
       curval=wvr2[ curidx ];
       //curv=veldtinvdx2[curidx];
       curv=deltaf[curidx];
       scurv=sqrtf(curv);
       //outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-curval)+curv*(wvr2[Wpzxloc(iz+1,ix)]-curval));
       outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-curval)+curv*(wvr2[curidx+1]-curval));
       wvr3[curidx] = outval;
       //curidx1=Wpxzloc(iz,ix);
       wvp3[curidx] = outval;
     }
     for (iz=nz-fat-fat2;iz<nz-fat;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       curval=wvr2[ curidx ];
       //curv=veldtinvdx2[curidx];
       curv=deltaf[curidx];
       scurv=sqrtf(curv)*1.2;
       //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvr1[Wpzxloc(iz-1,ix)]))+wvr2[Wpzxloc(iz-1,ix)];
       outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvr3[curidx-1]))+wvr2[curidx-1];
       wvr3[curidx] = outval;
       //curidx1=Wpxzloc(iz,ix);
       wvp3[curidx] = outval;
     }
  }
  //beg x boundary
  #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=nxtape-1;ix>0+fat+fat2;ix--)
  {
     for (iz=0+fat;iz<nz-fat;iz++)
    {
         curidx=Wpzxloc(iz,ix);
         outval=wvr3[ curidx ];
         curval=wvr2[ curidx ];
         //curv=veldtinvdx2[curidx];
         curv=epsf[curidx];
         scurv=sqrtf(curv);
         //outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-curval)+curv*(wvr2[Wpzxloc(iz,ix-1)]-curval));
         outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-curval)+curv*(wvr2[curidx-nz]-curval));
         wvr3[curidx] = outval;
         //curidx1=Wpxzloc(iz,ix);
         wvp3[curidx] = outval;
     }
  }
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=0+fat+fat2;ix>=0+fat;ix--)
  {
     for (iz=0+fat;iz<nz-fat;iz++)
     {
        curidx=Wpzxloc(iz,ix);
        curval=wvr2[ curidx ];
        //curv=veldtinvdx2[curidx];
        curv=epsf[curidx];
        scurv=sqrtf(curv)*1.2;
        //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvr1[Wpzxloc(iz,ix+1)]))+wvr2[Wpzxloc(iz,ix+1)];
        outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvr3[curidx+nz]))+wvr2[curidx+nz];
        wvr3[curidx] = outval;
        //curidx1=Wpxzloc(iz,ix);
        wvp3[curidx] = outval;
     }
  }

  //end x boundary
  #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=nx-nxtape;ix<nx-fat-fat2;ix++)
  {
     for (iz=0+fat;iz<nz-fat;iz++)
     {
        curidx=Wpzxloc(iz,ix);
        outval=wvr3[ curidx ];
        curval=wvr2[ curidx ];
        //curv=veldtinvdx2[curidx];
        curv=epsf[curidx];
        scurv=sqrtf(curv);
        //outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-curval)+curv*(wvr2[Wpzxloc(iz,ix+1)]-curval));
        outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-curval)+curv*(wvr2[curidx+nz]-curval));
        wvr3[curidx] = outval;
        //curidx1=Wpxzloc(iz,ix);
        wvp3[curidx] = outval;
      }
   }
     //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
   for (ix=nx-fat-fat2;ix<nx-fat;ix++)
   {
      for (iz=0+fat;iz<nz-fat;iz++)
      {
         curidx=Wpzxloc(iz,ix);
         curval=wvr2[ curidx ];
         //curv=veldtinvdx2[curidx];
         curv=epsf[curidx];
         scurv=sqrtf(curv)*1.2;
         //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvr1[Wpzxloc(iz,ix-1)]))+wvr2[Wpzxloc(iz,ix-1)];
         outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvr3[curidx-nz]))+wvr2[curidx-nz];
         wvr3[curidx] = outval;
         //curidx1=Wpxzloc(iz,ix);
         wvp3[curidx] = outval;
       }
    }
  
  return 0; 
}
