program  X2dMakesrc
  use sep
  use billgen
  !use waveprop2d
  !use base_fftwfl_mod
  !use dottest1
  implicit none
  integer                           ::ndim,nx,nt,nsx
  real                              ::ox,ot,osx,dx,dt,dsx
  real                              ::fpeak,tdelay,sx,x,t
  integer,dimension(:),allocatable  ::nsrc 
  real,dimension(:),allocatable     ::osrc,dsrc 
  real,dimension(:),allocatable     ::src 
  integer                           ::ix,it,isx
  real                              ::pi,tmp,typ

  call initpar()
  !call sep_init(SOURCE)
  
  !ndim=sep_dimension()
  ndim=3
 
  call from_param("nt",nt,400)
  call from_param("ot",ot,0.)
  call from_param("dt",dt,0.004)
  call from_param("nx",nx,100)
  call from_param("ox",ox,0.)
  call from_param("dx",dx,4.)
  call from_param("fpeak",fpeak,30.)
  call from_param("tdelay",tdelay,-0.05)
  call from_param("nsx",nsx,10)
  call from_param("osx",osx,0.)
  call from_param("dsx",dsx,16.)
  call from_param("type",typ,2.)

  


  allocate ( nsrc(ndim), osrc(ndim), dsrc(ndim) )
  
  nsrc(1)=nt
  nsrc(2)=nx
  nsrc(3)=nsx

  osrc(1)=ot
  osrc(2)=ox
  osrc(3)=osx

  dsrc(1)=dt
  dsrc(2)=dx
  dsrc(3)=dsx

  allocate ( src(product(nsrc)) )

  pi=3.14159265
  do isx=1,nsx
     sx=osx+(isx-1)*dsx
     ix=(sx-ox)/dx + 1.
     do it=1,nt
        t = ot + (it-1)*dt
        tmp = pi*fpeak*(t+tdelay)
        if (typ.eq.2.) then
           src( it+nt*(ix-1)+nt*nx*(isx-1) ) = (1-2*tmp*tmp)*exp(-tmp*tmp) 
        else if (typ.eq.1.) then
           src( it+nt*(ix-1)+nt*nx*(isx-1) ) = 2*tmp*exp(-tmp*tmp) 
        end if
     end do
  end do

  call put_history(nsrc,osrc,dsrc,4)
  call srite("out",src,product(nsrc)*4)
 
end program X2dMakesrc 

