program  X2dSimpleEAWhttxin
  use sep
  use billgen
  implicit none
  integer                           ::ndim,nt,nx,ns,stat,nthreads
  real                              ::os,ds,ot,dt,ox,dx,otrep,thres,alpha,tmpddat,s,x,vel0
  integer,dimension(:),allocatable  ::nd
  real,dimension(:),allocatable     ::od,dd
  real,dimension(:,:,:),allocatable ::dat,eawht
  real,dimension(:),allocatable     ::surf,sdepth
  real                              ::t,t0,t0in,t00in,dct0begin, dct0endin, dct0in,dct01in,hx0,hx01,hx1
  integer                           ::it,ix,cnt,is,ixs,it0,it0in,it00in,dcit0in,dcit01in,it1,ihx0,ihx01,ihx1,itda,jx,jt,it11,it22,it33,typ
  integer, external                 :: omp_get_threads_num
  integer, external                 :: omp_set_num_threads
  integer, external                 :: omp_get_thread_num


  call initpar()
  call sep_init()


  !ndim=sep_dimension()
  ndim=2

  allocate ( od(3), dd(3), nd(3) )
  !! read in data & velocity infomation
  call from_history("n1",nd(1))
  call from_history("n2",nd(2))
  call from_history("n3",nd(3))
  call from_history("o1",od(1))
  call from_history("o2",od(2))
  call from_history("o3",od(3))
  call from_history("d1",dd(1))
  call from_history("d2",dd(2))
  call from_history("d3",dd(3))


  call from_param("thres",thres,1.)
  call from_param("type",typ,0)
  call from_param("t0",t0in,0.)
  call from_param("t00",t00in,0.)
  call from_param("dct0beg",dct0begin,0.)
  call from_param("dct0end",dct0endin,0.)
  call from_param("dct01",dct01in,0.)
  !! direct arrival velocity
  call from_param("vel0",vel0,100.)
  call from_param("hx0",hx0,100.0)
  call from_param("hx01",hx01,300.0)
  call from_param("hx1",hx1,99999.0)
  call from_param("alpha",alpha,0.2)
  call from_param("nthreads",nthreads,1)
  call from_param("jx",jx,1)
  call from_param("jt",jt,1)

  if (nthreads>15) then
     nthreads=15
  end if
  stat = omp_set_num_threads(nthreads)
  write(0,*),"number of threads now are",nthreads

  ns=nd(3); os=od(3); ds=dd(3)
  nx=nd(2); ox=od(2); dx=dd(2)
  nt=nd(1); ot=od(1); dt=dd(1)

  it0in=(t0in-ot)/(dt*jt)
  it00in=(t00in-ot)/(dt*jt)
  dcit01in=(dct01in-ot)/(dt*jt)

  ihx0=(hx0)/(dx*jx)
  ihx01=(hx01)/(dx*jx)
  ihx1=(hx1)/(dx*jx)

  write(0,*)"dx,dt,ds",dx,dt,ds
  allocate ( dat(nt,nx,ns), eawht(nt,nx,ns), surf(nx) )

  call sreed("in",dat,product(nd)*4)

  eawht=0.
  do is=1,ns
     dct0in=((is*dct0endin+(ns-is)*dct0begin))/(ns*1.)
     dcit0in=(dct0in-ot)/(dt*jt)
     s=os+(is-1)*ds
     ixs=(s-ox)/dx+1
     !!$OMP PARALLEL DO SCHEDULE(DYNAMIC,1) DEFAULT(SHARED) PRIVATE(it,ix,tmpddat,it1,x,itda,it0,it11)
     do ix=max(1,ixs-ihx1),min(nx,ixs+ihx1),jx
        x=ox+(ix-1)*dx
        itda=abs(s-x)/(vel0*dt)-dcit0in
        !it0=min(it0in,itda)
        it0=it0in
        it1=nt
        do it=dcit01in,nt-1
           tmpddat=(dat(it+1,ix,is)-dat(it,ix,is))/dt
           eawht(it,ix,is)=0.
           if ( abs(tmpddat).gt.thres) then
              it1=it-it00in
              exit
           end if
        end do
        do it=1,nt
           eawht(it,ix,is)=1.
        end do
        it11=min(it1,itda)
        if (typ.eq.0) then
           it11=min(itda,nt)
        else if (typ.eq.1) then
           it11=it11+it0
        else if (typ.eq.2) then
           it11=min((it11+it0),itda)
        end if
        do it=max(1,it11)+1,nt
           eawht(it,ix,is)=eawht(it,ix,is)*exp(-alpha*max(1,it-it11))
        end do
        do it=1,nt
           if( mod(it-1,jt).ne.0) then
              eawht(it,ix,is)=0.
           end if
        end do
     end do
  end do

  call put_history(nd,od,dd,4)
 call srite("out",eawht,product(nd)*4)

end program X2dSimpleEAWhttxin

