int XC2dCalsteplength_ns;
int   XC2dCalsteplength_nt,XC2dCalsteplength_nx,XC2dCalsteplength_nz;
float XC2dCalsteplength_dt,XC2dCalsteplength_dx,XC2dCalsteplength_dz;
float XC2dCalsteplength_mmin,XC2dCalsteplength_mmax;
int   XC2dCalsteplength_nxtape,XC2dCalsteplength_nztape;
int   XC2dCalsteplength_objtype;
int   XC2dCalsteplength_paramtype;
float XC2dCalsteplength_thresd;
int *XC2dCalsteplength_isdep, *XC2dCalsteplength_irdep; 


int XC2dCalsteplength_init( int ntin,  int nxin,  int nzin, int nsin,  \
                      float otin,float oxin,float ozin,          \
                      float dtin,float dxin,float dzin,          \
                      int nxtapein, int nztapein,             \
                      int *isdepin, int *irdepin, float mmin, float mmax, long *memcnt, \
                      int objtypein, int paramtypein, float thresdin  );

int XC2dCalsteplength_1pnt(float *mod, float *tmpmod, double *grad, float *dobs, float *dwht, float *dcal, float* dres, float *src, float *alphain, float *fvalout, int isdepmin, int isdepmax);
int XC2dCalsteplength_parabola_fit(float x0, float x1, float x2, float y0, float y1, float y2, float *xmin);


int XC2dCalsteplength_mpiop(float *mod, float *tmpmod, double *grad, float *dobs, float *dwht, float *dcal, float *dres, float *src, float fval, float *alphaout, float *alpha1out, float *fval1out, float *alpha2out, float *fval2out, int isdepmin, int isdepmax );
int XC2dWI_calalpha(float *mod, double *grad, float percent, float paramtype, float *alpha );
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
int XC2dCalsteplength_init( int ntin,  int nxin,  int nzin, int nsin,  \
                      float otin,float oxin,float ozin,          \
                      float dtin,float dxin,float dzin,          \
                      int nxtapein, int nztapein,             \
                      int *isdepin, int *irdepin, float mmin, float mmax, long *memcnt,  \
                      int objtypein, int paramtypein, float thresdin  )
{

    XC2dCalsteplength_ns=nsin;

    XC2dCalsteplength_nt=ntin;
    XC2dCalsteplength_nx=nxin;
    XC2dCalsteplength_nz=nzin;

    XC2dCalsteplength_dt=dtin;
    XC2dCalsteplength_dx=dxin;
    XC2dCalsteplength_dz=dzin;

    XC2dCalsteplength_nxtape=nxtapein;
    XC2dCalsteplength_nztape=nztapein;

    XC2dCalsteplength_mmin=mmin;
    XC2dCalsteplength_mmax=mmax;

    XC2dCalsteplength_objtype=objtypein;
    XC2dCalsteplength_paramtype=paramtypein;
    XC2dCalsteplength_thresd=thresdin;

    if (nxin<=2*nxtapein)
       WpErrmsg("Error, nx less or equal than twice of padded x reigon\n")
    if (nzin<=2*nztapein)
       WpErrmsg("Error, nz less or equal than twice of padded z reigon\n")

       // produce (vel*dt/dx)**2 and get vmax/izmax_inc on the way
    XC2dCalsteplength_ns=nsin;
    XC2dCalsteplength_isdep=isdepin;
    XC2dCalsteplength_irdep=irdepin;

    return 0;
}

int XC2dCalsteplength_1pnt(float *mod, float *tmpmod, double *grad, float *dobs, float *dwht, float *dcal, float* dres, float *src, float *alphain, float *fvalout, int isdepmin, int isdepmax)
{ 
   int stat,tsign,i,idx,ix,iz;
   int izmax_inc;
   int nx,nz,ns,nt,shotsz;
   int nxtape,nztape;
   int is;
   int *isdep,*irdep;
   float *shotsrc, *nullwvmv, *nullvsrc;
   int needvsrc,needwvmv,jtmv, is0;
   double fval;
   float alpha,maxv;
  //update velocity

   ns=XC2dCalsteplength_ns;
   nx=XC2dCalsteplength_nx;
   nz=XC2dCalsteplength_nz;
   nt=XC2dCalsteplength_nt;

   nxtape=XC2dCalsteplength_nxtape;
   nztape=XC2dCalsteplength_nztape;

   alpha=*alphain;
   VerbMsg("-----start updatemod in XC2dCalsteplength_1pnt in calsteplength_op \n")
   stat=XC2dWI_updatemod(mod, grad, alpha, tmpmod, nx*nz, XC2dCalsteplength_mmin, XC2dCalsteplength_mmax, XC2dCalsteplength_paramtype, XC2dCalsteplength_dt, XC2dCalsteplength_dx);
   VerbMsg2("isdepmin=%d,isdepmax=%d\n",isdepmin,isdepmax)
   stat=XC2dWI_equalepsdel(tmpmod, tmpmod, nz, nx, isdepmin, isdepmax, nztape, nxtape);
   /*for (ix=0;ix<nx;ix++)
      for (iz=nztape;iz<nztape+10;iz++)
      {
         idx=iz+ix*nz;
         tmpmod[idx+2*nz*nx]=tmpmod[idx+nz*nx]/sqrt(tmpmod[idx+nz*nx]/tmpmod[idx]);
      }*/
   maxv=1000.;
   for (i=0;i<nz*nx;i++)
      if (tmpmod[i]<maxv)
         maxv=tmpmod[i];

   izmax_inc=sqrt(1./maxv)+2;
   if (stat==1)
      WpErrmsg("Error calling XC2dWaveprop_setwvmv in XC2dCalsteplength_1pnt, program terminated\n");
  
   shotsz=nt*(nx-2*nxtape);
   fval=0.;
   is0=0;
   //for (is=is0;is<is0+1;is++)
   for (is=0;is<ns;is++)
   {
      tsign=1;
      isdep=&XC2dCalsteplength_isdep[is*(nx-2*nxtape)];
      irdep=&XC2dCalsteplength_irdep[is*(nx-2*nxtape)];
      shotsrc=&src[is*shotsz];

      //forward modeling
      VerbMsg("-----start Waveprop_op2 in XC2dCalsteplength_1pnt in calsteplength_op \n")
      stat=XC2dWaveprop_op2( tsign, isdep, irdep, shotsrc, tmpmod, izmax_inc, dcal, nullwvmv, nullwvmv );
      if (stat==1)
         WpErrmsg("Error calling XC2dWaveprop_op in XC2dCalsteplength_1pnt, program terminated!\n")

      //calculate data residual
      VerbMsg("-----start whtdat in XC2dCalsteplength_1pnt in calsteplength_op \n")
      stat=XC2dWI_whtdat(dcal, dcal, &dwht[is*shotsz], shotsz);
      if (stat==1)
         WpErrmsg("Error calling XC2dWI_whtdat in XC2dCalsteplength_1pnt, program terminated!\n")

      needvsrc=0;
      VerbMsg("-----start calresd in XC2dCalsteplength_1pnt in calsteplength_op \n")
      if (XC2dCalsteplength_objtype==0)
      {
         stat=XC2dWI_calresd_conv(&dobs[is*shotsz], dcal, dres, nullvsrc, needvsrc, XC2dCalsteplength_nt, shotsz/XC2dCalsteplength_nt);
         if (stat==1)
            WpErrmsg("Error in XC2dWI_calresd_conv, program terminated!\n")
      }
      else if (XC2dCalsteplength_objtype==1)
      {
         stat=XC2dWI_calresd_WT(&dobs[is*shotsz], dcal, dres, nullvsrc, needvsrc, XC2dCalsteplength_nt, shotsz/XC2dCalsteplength_nt, XC2dCalsteplength_thresd);
         if (stat==1)
            WpErrmsg("Error in XC2dWI_calresd_WT, program terminated!\n")
      }
      else if (XC2dCalsteplength_objtype==2)
      {
         stat=XC2dWI_calresd_NormAmp(&dobs[is*shotsz], dcal, dres, nullvsrc, needvsrc, XC2dCalsteplength_nt, shotsz/XC2dCalsteplength_nt, XC2dCalsteplength_thresd);
         if (stat==1)
            WpErrmsg("Error in XC2dWI_calresd_NormAmp, program terminated!\n")
      }

      //calculate objective function value from data residual
      VerbMsg("-----start calobjfunc in XC2dCalsteplength_1pnt in calsteplength_op \n")
      stat=XC2dWI_calobjfunc(&dwht[is*shotsz], dres, XC2dCalsteplength_nt, shotsz/XC2dCalsteplength_nt, &fval);
      if (stat==1)
         WpErrmsg("Error in XC2dWI_calobjfunc, program terminated!\n")
   }

   *fvalout=fval;

   return 0;
}

int XC2dCalsteplength_parabola_fit(float x0, float x1, float x2, float y0, float y1, float y2, float *xmin)
{

    double a,b,c,k;
    
    k=1./((((double)x0)-x1)*(x0-x2)*(x1-x2));
    a=k*(y0*(x1-x2)-y1*(x0-x2)+y2*(x0-x1));
    b=-k*(y0*(x1*x1-x2*x2)-y1*(x0*x0-x2*x2)+y2*(x0*x0-x1*x1));
    c=k*(y0*x1*x2*(x1-x2)-y1*x0*x2*(x0-x2)+y2*x0*x1*(x0-x1));
    
    fprintf(stderr,"x0=%e,x1=%e,x2=%e\n",x0,x1,x2);
    fprintf(stderr,"y0=%e,y1=%e,y2=%e\n",y0,y1,y2);
    fprintf(stderr,"a=%e,b=%e,c=%e, k=%e\n",a,b,c,k);
    if (x1>0 && x2>0)
    {
       if ( (a==0.) )
       {
          if ( b>0.) 
             *xmin=x2;
          else
          {
             *xmin=x0/1e5;
             WpErrmsg("Warning!!! Parabola fitting result in line fitting and b<=0, stop iterating\n")
          }
       }
       else if ( a>0. )
       {
          if ( (-b/(2.*a))<0) 
          {
             *xmin=x1/1e5;
             WpErrmsg("Warning!!! Parabola fitting result in steplength<0, stop iterating\n")
          }
          else if ( (-b/(2.*a)) < (x2/15.) )  
          {
             *xmin=-b/(2.*a);
             WpErrmsg("Warning!!! Parabola fitting result in steplength < x2/15, stop iterating\n")
          }
          else if ( (-b/(2.*a)) > x2 ) 
             *xmin=x2;
          else
             *xmin=-b/(2.*a); 
       }
       else if ( a<0. )  
       {

          if ( (-b/(2*a))< 0.5*(x0+x2) ) 
          {
             *xmin=x2;
             WpErrmsg("Warning!!! Parabola fitting result in a<0, but still have reasonable steplength\n")
          }
          if ( (-b/(2*a))> 0.5*(x0+x2) ) 
          {
             *xmin=x1/1e5;
             WpErrmsg("Warning!!! Parabola fitting result in a<0, and step length=0\n")
          }
       }
       fprintf(stderr,"xmin=%e\n",*xmin);
    }
    else 
    {
       *xmin=x1/1e5; 
       WpErrmsg("Warning!!! x1<0 ,x2 <0 step length=0\n")
    } 
    
    return 0;
}

int XC2dCalsteplength_mpiop(float *mod, float *tmpmod, double *grad, float *dobs, float *dwht, float *dcal, float *dres, float *src, float fval, float *alphaout, float *alpha1out, float *fval1out, float *alpha2out, float *fval2out, int isdepmin, int isdepmax )
{ 
   int stat;
   int nx,nz;
   float mmin,gradmax;
   float alpha1,alpha2,alpha3;
   float fval1 ,fval2, fval3;
   int i;
    
   nx=XC2dCalsteplength_nx;
   nz=XC2dCalsteplength_nz;

   //calculate temporary step length 
   if (XC2dCalsteplength_paramtype==1)
   {
      float percent=0.03;
      stat=XC2dWI_calalpha(mod, grad, percent, XC2dCalsteplength_paramtype, &alpha2 );
      percent=0.05;
      stat=XC2dWI_calalpha(mod, grad, percent, XC2dCalsteplength_paramtype, &alpha3 );
   }
   else if (XC2dCalsteplength_paramtype==2)
   {
      float percent=0.0006;
      stat=XC2dWI_calalpha(mod, grad, percent, XC2dCalsteplength_paramtype, &alpha2 );
      percent=0.0015;
      stat=XC2dWI_calalpha(mod, grad, percent, XC2dCalsteplength_paramtype, &alpha3 );
   }
   alpha1=0.;
   fval1=fval;

   ///
   //first  point calculation
   VerbMsg("-----start 1st point calculation in calsteplength_op \n")
   stat=XC2dCalsteplength_1pnt(mod, tmpmod, grad, dobs,  dwht, dcal, dres, src, &alpha2, &fval2, isdepmin, isdepmax);
   if (stat==1)
      WpErrmsg("Error calling XC2dCalsteplength_1pnt in XC2dCalsteplength_op, program terminated\n");
   //second point calculation
   VerbMsg("-----start 2nd point calculation in calsteplength_op \n")
   stat=XC2dCalsteplength_1pnt(mod, tmpmod, grad, dobs,  dwht, dcal, dres, src, &alpha3, &fval3, isdepmin, isdepmax);
   if (stat==1)
      WpErrmsg("Error calling XC2dCalsteplength_1pnt in XC2dCalsteplength_op, program terminated\n");
   //calculating step size
   //VerbMsg("-----start parabola fitting in calsteplength_op \n")
   //stat=XC2dCalsteplength_parabola_fit(alpha1, alpha2, alpha3, fval1, fval2, fval3, alphaout); 

   //VerbMsg1("-----done parabola fitting in calsteplength_op with alphaout equals to %f \n", *alphaout)

   *alpha1out=alpha2; *fval1out=fval2;
   *alpha2out=alpha3; *fval2out=fval3;

   return 0;
}

//steplength calculation based on the first model component
int XC2dWI_calalpha(float *mod, double *grad, float percent, float paramtype, float *alpha )
{
   int i;
   float mmin,gradmax;
   int idxmax,idxmin;
   float a;
   a=1.5;

   int nx,nz;
   nx=XC2dCalgrad_nx;
   nz=XC2dCalgrad_nz;
   float dt,dx;
   dt=XC2dCalsteplength_dt;
   dx=XC2dCalsteplength_dx;

   gradmax=0.;
   for (i=0;i<nx*nz;i++)
      if (gradmax<fabs(grad[i]))
      {
         gradmax=fabs(grad[i]);
         idxmax=i;
      }
   if(paramtype==1)
   {
      mmin=1e6;
      for (i=0;i<nx*nz;i++)
      {
         if (mmin>mod[i]);
         {
            mmin=mod[i];
            idxmin=i; 
         }
      }
      *alpha=fabs(mod[idxmin]/grad[idxmax]*percent);
      fprintf(stderr,"gradmax=%e, mmin=%e\n",grad[idxmax],mod[idxmin]);
   }
   else if(paramtype==2)
   {
      mmin=1e6;
      for (i=0;i<nx*nz;i++)
      {
         //transform back to vp^2, 1+2*eps, sqrt(1+2*delta)
         if (mmin>fabs(1./a*log(dt*dt/(dx*dx*mod[i]))))
         {
            mmin=fabs(1./a*log(dt*dt/(mod[i]*dx*dx)));
            idxmin=i; 
         }
      }
      *alpha=fabs(1./a*log(dt*dt/(mod[idxmin]*dx*dx))/grad[idxmax]*percent);
      fprintf(stderr,"gradmax=%e, mmin=%e\n",grad[idxmax],1./a*log(dt*dt/(mod[idxmin]*dx*dx)));
   }
   return 0;
}

