#include "XC2dWaveprop.c"
#include "XC2dWImisc.h"
#include "XC2dWIcalresd.h"
#include "XC2dCalgrad.c"
#include "XC2dCalsteplength.c"

int   XC2dMPISolver_inode, XC2dMPISolver_nnode;
int   XC2dMPISolver_ns, XC2dMPISolver_needprecond;
int   XC2dMPISolver_nt,XC2dMPISolver_nx,XC2dMPISolver_nz;
float XC2dMPISolver_ot,XC2dMPISolver_ox,XC2dMPISolver_oz;
float XC2dMPISolver_dt,XC2dMPISolver_dx,XC2dMPISolver_dz;
float XC2dMPISolver_dxspline,XC2dMPISolver_dzspline;
int   XC2dMPISolver_nxspline,XC2dMPISolver_nzspline;
int   XC2dMPISolver_needspline;
int   XC2dMPISolver_nxtape,XC2dMPISolver_nztape;
int   *XC2dMPISolver_isdep, *XC2dMPISolver_irdep;
float *XC2dMPISolver_dcal, *XC2dMPISolver_dres, *XC2dMPISolver_vsrc;
float XC2dMPISolver_mmin, XC2dMPISolver_mmax;
float *XC2dMPISolver_tmpmod;
double *XC2dMPISolver_grad, *XC2dMPISolver_prevgrad, *XC2dMPISolver_direcm, *XC2dMPISolver_precond;
float *XC2dMPISolver_frawgrad;
double *XC2dMPISolver_rawgrad, *XC2dMPISolver_rawdirecm, *XC2dMPISolver_rawprecond;
double *XC2dMPISolver_tmprawgrad, *XC2dMPISolver_tmprawprecond, *XC2dMPISolver_tmpprecond;
double *XC2dMPISolver_tmpsplinearray1, *XC2dMPISolver_tmpsplinearray2;
float XC2dMPISolver_sigma, XC2dMPISolver_alpha_mean, XC2dMPISolver_alpha_sigma, XC2dMPISolver_alpha_maxv;
int XC2dMPISolver_j_rndbnd;
int XC2dMPISolver_rndbnd_type;
int XC2dMPISolver_paramtype;
int XC2dMPISolver_jtmv;

int XC2dMPISolver_init( int ntin,  int nxin, int nzin, int nsin,   \
                      float otin,float oxin,float ozin,          \
                      float dtin,float dxin,float dzin,          \
                      int nxtapein, int nztapein,             \
                      float *sdepin, float *rdepin,                         \
                      int jtmvin, float mmin, float mmax, int needprecond,  \
                      int needspline, float dzsplinein, float dxsplinein, \
                      int inodein, int nnodein, long *memcnt, \ 
                      float sigmain, float alpha_meanin, float alpha_sigmain, float alpha_maxvin, int j_rndbndin, int rndbnd_typein, int freesurf, \
                      int objtypein, int paramtypein, float thresdin );

int XC2dMPISolver_op(float *mod , float *dobs, float *dwht, float *src, int niter, float *resd, char *rdfulpath, char *gradfulpath, int rcdmv, char* mvpath, int isdepmin, int isdepmax, char *vupd);

// processing raw gradient
int XC2dMPISolver_gradproc(double *denom);

int XC2dMPISolver_init( int ntin,  int nxin,  int nzin, int nsin,   \
                      float otin,float oxin,float ozin,          \
                      float dtin,float dxin,float dzin,          \
                      int nxtapein, int nztapein,             \
                      float *sdepin, float *rdepin,                         \
                      int jtmvin, float mmin, float  mmax, int needprecond, \
                      int needspline, float dzsplinein, float dxsplinein, \
                      int inodein, int nnodein, long *memcnt, \ 
                      float sigmain, float alpha_meanin, float alpha_sigmain, float alpha_maxvin, int j_rndbndin, int rndbnd_typein, int freesurf, \
                      int objtypein, int paramtypein, float thresdin )
{
    int sz,i; 
    int stat;
  
    // Init variables
    XC2dMPISolver_nt=ntin;
    XC2dMPISolver_nx=nxin;
    XC2dMPISolver_nz=nzin;

    XC2dMPISolver_ot=otin;
    XC2dMPISolver_ox=oxin;
    XC2dMPISolver_oz=ozin;

    XC2dMPISolver_dt=dtin;
    XC2dMPISolver_dx=dxin;
    XC2dMPISolver_dz=dzin;

    XC2dMPISolver_nxtape=nxtapein;
    XC2dMPISolver_nztape=nztapein;

    XC2dMPISolver_mmin=mmin;
    XC2dMPISolver_mmax=mmax;
    XC2dMPISolver_needprecond=needprecond;

    XC2dMPISolver_dzspline=dzsplinein;
    XC2dMPISolver_dxspline=dxsplinein;
    XC2dMPISolver_needspline=needspline;


    XC2dMPISolver_inode=inodein;
    XC2dMPISolver_nnode=nnodein;

    XC2dMPISolver_sigma=sigmain;
    XC2dMPISolver_alpha_mean=alpha_meanin;
    XC2dMPISolver_alpha_sigma=alpha_sigmain;
    XC2dMPISolver_alpha_maxv=alpha_maxvin;
    XC2dMPISolver_j_rndbnd=j_rndbndin;
    XC2dMPISolver_rndbnd_type=rndbnd_typein;
    XC2dMPISolver_paramtype=paramtypein;
    XC2dMPISolver_jtmv=jtmvin;
    /*
    if (needspline>0)
    {
       if (dzsplinein<=dzin)
          WpErrmsg("Error, dzspline less or equal than dz\n")
       if (dxsplinein<=dxin)
          WpErrmsg("Error, dxspline less or equal than dx\n")
       if (dysplinein<=dyin)
          WpErrmsg("Error, dyspline less or equal than dy\n")
    }
*/
    if (nxin<=2*nxtapein)
       WpErrmsg("Error, nx less or equal than twice of padded x reigon\n")
    if (nzin<=2*nztapein)
       WpErrmsg("Error, nz less or equal than twice of padded z reigon\n")

    // determine if dx==dy==dz
    if (  dzin!=dxin )
       WpErrmsg("ERROR in MPISolver_init , dz not equal to dx, exit!!!\n")
    else
    {
       // produce (vel*dt/dx)**2 and get vmax/izmax_inc on the way
       XC2dMPISolver_ns=nsin;
       sz=(nxin-2*nxtapein)*nsin;
       XC2dMPISolver_isdep=(int*)malloc(sz*sizeof(int));
       XC2dMPISolver_irdep=(int*)malloc(sz*sizeof(int));
       *memcnt+=sz*sizeof(int)*2;
       //XC2dCalgrad_1shotdcal=(float*)malloc(XC2dCalgrad_shotsz*sizeof(float));
       for (i=0;i<sz;i++)
          XC2dMPISolver_isdep[i]=(sdepin[i]-ozin)/dzin+nztapein;
           
       
       for (i=0;i<sz;i++)
          XC2dMPISolver_irdep[i]=(rdepin[i]-ozin)/dzin+nztapein;

       sz=(nxin-2*nxtapein)*ntin; 
       XC2dMPISolver_dcal=(float*)malloc(sz*sizeof(float));
       XC2dMPISolver_dres=(float*)malloc(sz*sizeof(float));
       XC2dMPISolver_vsrc=(float*)malloc(sz*sizeof(float));
       *memcnt+=sz*sizeof(float)*3;

       sz=nxin*nzin*2;
       XC2dMPISolver_rawgrad=(double*)malloc(sz*sizeof(double));
       XC2dMPISolver_tmprawgrad=(double*)malloc(sz*sizeof(double));
       XC2dMPISolver_rawdirecm=(double*)malloc(sz*sizeof(double));
       *memcnt+=sz*sizeof(double)*3;
       XC2dMPISolver_frawgrad=(float*)malloc(sz*sizeof(float));
       *memcnt+=sz*sizeof(float);
       if (needspline==0) 
       { 
          XC2dMPISolver_prevgrad=(double*)malloc(sz*sizeof(double));
          *memcnt+=sz*sizeof(double);
       }
       else
       {
          XC2dMPISolver_nzspline=(nzin-1)*dzin/dzsplinein+1;
          XC2dMPISolver_nxspline=(nxin-1)*dxin/dxsplinein+1;
          fprintf(stderr,"nxspline=%d nzspline=%d\n",XC2dMPISolver_nxspline,XC2dMPISolver_nzspline);
          sz=2*XC2dMPISolver_nxspline*XC2dMPISolver_nzspline;
          XC2dMPISolver_grad=(double*)malloc(sz*sizeof(double));
          XC2dMPISolver_prevgrad=(double*)malloc(sz*sizeof(double));
          XC2dMPISolver_direcm=(double*)malloc(sz*sizeof(double));
          *memcnt+=sz*sizeof(double)*3;
          //intermediate array after 1 dimensional spline operation;
          sz=2*XC2dMPISolver_nzspline*XC2dMPISolver_nx;
          XC2dMPISolver_tmpsplinearray1=(double*)malloc(sz*sizeof(double));
          *memcnt+=sz*sizeof(double);
          sz=2*XC2dMPISolver_nzspline*XC2dMPISolver_nxspline;
          XC2dMPISolver_tmpsplinearray2=(double*)malloc(sz*sizeof(double));
          *memcnt+=sz*sizeof(double);
       }
 

       sz=3*nxin*nzin;
       XC2dMPISolver_tmpmod=(float*)malloc(sz*sizeof(float));
       *memcnt+=sz*sizeof(float);

       sz=2*nxin*nzin;
       if (needprecond)
       {
          XC2dMPISolver_rawprecond=(double*)malloc(sz*sizeof(double));
          //if (inodein==0)
          XC2dMPISolver_tmprawprecond=(double*)malloc(sz*sizeof(double));
          *memcnt+=sz*sizeof(double)*2;
          if(needspline>0)
          {
             sz=2*XC2dMPISolver_nzspline*XC2dMPISolver_nxspline;
             XC2dMPISolver_precond=(double*)malloc(sz*sizeof(double));
             XC2dMPISolver_tmpprecond=(double*)malloc(sz*sizeof(double));
             *memcnt+=sz*sizeof(double)*2;

          }
       }
    }

    if (inodein>0)
    {

       // Init gradient module
       stat=XC2dCalgrad_init( ntin, nxin, nzin, nsin, otin, oxin, ozin, dtin, dxin, dzin,   \
                           nxtapein, nztapein, XC2dMPISolver_isdep, XC2dMPISolver_irdep, jtmvin, memcnt, objtypein, paramtypein, thresdin, rndbnd_typein );
       if (stat==1)
         fprintf(stderr,"Error calling XC2dCalgrad_init in XC2dMPISolver_init, program terminated\n");

       // Init calsteplength module
       stat=XC2dCalsteplength_init( ntin, nxin, nzin, nsin, otin, oxin, ozin, dtin, dxin, dzin,  \
                                 nxtapein, nztapein, XC2dMPISolver_isdep, XC2dMPISolver_irdep, mmin, mmax, memcnt, objtypein, paramtypein, thresdin );
       if (stat==1)
          fprintf(stderr,"Error calling XC2dCalsteplength_init in XC2dMPISolver_init, program terminated\n");

		///////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////
       // This part need to be modified, change file XC2dWaveprop.c to the form of XC2dVTIprop.c, all used functions needs to be changed.
       // Init waveprop module
       int needwvmvin;
       if (rndbnd_typein>0)
       {
          needwvmvin=0;
       }
       else
       {
          needwvmvin=2;
       }
       stat=XC2dWaveprop_Init( ntin, nxin, nzin, dtin, dxin, dzin, nxtapein, nztapein, needwvmvin, jtmvin, freesurf, memcnt );
		
		///////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////
       if (stat==1)
         fprintf(stderr,"Error calling XC2dWaveprop_init in XC2dMPISolver_init, program terminated\n");
    }


    return 0;
}



int XC2dMPISolver_op(float *mod , float *dobs, float *dwht, float *src, int niter, float *resd, char *rdfulpath, char *gradfulpath, int rcdmv, char *mvpath, int isdepmin, int isdepmax, char *vupd)
{
    int stat;
    int nx,nz,nt,ns,nxtape,nztape; 
    int ix,iz,it,is,i,ii,idx;
    int sz;
    int iter;
    float alphaout,alpha,fval;
    float alpha1,fval1,alpha2,fval2;
    float x0,x1,x2,y0,y1,y2;
    float sum,vmin,vmax;
    double denom[2];
    sep3d outfile,outfile1, outfile2;  
    int ndim;
    nx=XC2dMPISolver_nx;
    nz=XC2dMPISolver_nz;
    nt=XC2dMPISolver_nt;
    ns=XC2dMPISolver_ns;

    nxtape=XC2dMPISolver_nxtape;
    nztape=XC2dMPISolver_nztape;

    int inode=XC2dMPISolver_inode;
    int nnode=XC2dMPISolver_nnode;
    MPI_Status mpistat;
   
    denom[0]=0.;
    denom[1]=0.;
    // preprocessing dobs
    sz=(nx-2*nxtape)*nt*ns;
    vmin=XC2dMPISolver_dx/XC2dMPISolver_dt/sqrt(XC2dMPISolver_mmax);
    vmax=XC2dMPISolver_dx/XC2dMPISolver_dt/sqrt(XC2dMPISolver_mmin);
    VerbMsg("start whtdat in XC2dMPISolver_op\n")
    if (inode>0)
    { 
       stat=XC2dWI_whtdat( dobs, dobs, dwht, sz);
    }
  
    VerbMsg("start zero raw grad in XC2dMPISolver_op\n")
    sz=nx*nz*2;
    for (i=0;i<sz;i++)
       XC2dMPISolver_rawgrad[i]=0.;
  
    VerbMsg("start zero raw direcm in XC2dMPISolver_op\n")
    sz=nx*nz*2;
    for (i=0;i<sz;i++)
       XC2dMPISolver_rawdirecm[i]=0.;

    if (XC2dMPISolver_needprecond>0)
    { 
       VerbMsg("start zero rawprecond in XC2dMPISolver_op\n")
       sz=nx*nz*2; 
       for (i=0;i<sz;i++)
          XC2dMPISolver_rawprecond[i]=0.;
    }

    if (XC2dMPISolver_needspline==0) 
    {
       VerbMsg("start zero prevgrad in XC2dMPISolver_op\n")
       sz=nx*nz*2;
       for (i=0;i<sz;i++)
          XC2dMPISolver_prevgrad[i]=0.;
    } 
    else
    {
       VerbMsg("in spline mode, start zero prevgrad in XC2dMPISolver_op\n")
       sz=2*XC2dMPISolver_nzspline*XC2dMPISolver_nxspline;
       for (i=0;i<sz;i++)
          XC2dMPISolver_prevgrad[i]=0.;

       VerbMsg("in spline mode, start zero grad in XC2dMPISolver_op\n")
       for (i=0;i<sz;i++)
          XC2dMPISolver_grad[i]=0.;
       if (XC2dMPISolver_needprecond>0)
       {
          VerbMsg("in spline mode, start zero precond in XC2dMPISolver_op\n")
          for (i=0;i<sz;i++)
             XC2dMPISolver_precond[i]=0.;
       }

       VerbMsg("in spline mode, start zero direcm in XC2dMPISolver_op\n")
       for (i=0;i<sz;i++)
          XC2dMPISolver_direcm[i]=0.;
    }
   

    // write out full data residual and virtue source
    
    if (inode>0)
    {
       ndim=5;
       if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
          seperr("unable to write rdfulout file!\n");
       /*
       outfile.o[0]=0;
       outfile.d[0]=1;
       outfile.n[0]=XC2dMPISolver_nz-2*XC2dMPISolver_nztape;
       outfile.o[1]=XC2dMPISolver_ox+XC2dMPISolver_nxtape*XC2dMPISolver_dx;
       outfile.d[1]=XC2dMPISolver_dx;
       outfile.n[1]=XC2dMPISolver_nx-2*XC2dMPISolver_nxtape;
       outfile.n[2]=XC2dMPISolver_nt/XC2dMPISolver_jtmv;
       */
       outfile.o[0]=XC2dMPISolver_ot;
       outfile.d[0]=XC2dMPISolver_dt;
       outfile.n[0]=XC2dMPISolver_nt;
       outfile.o[1]=XC2dMPISolver_ox+XC2dMPISolver_nxtape*XC2dMPISolver_dx;
       outfile.d[1]=XC2dMPISolver_dx;
       outfile.n[1]=XC2dMPISolver_nx-2*XC2dMPISolver_nxtape;
       outfile.n[2]=2;
       outfile.n[3]=XC2dMPISolver_ns;
       outfile.n[4]=niter;
       sep3d_set_sep3d(&outfile);
       if(0!=sep3dc_write_description(rdfulpath,&outfile))
          seperr("unable to output parameters for rdfulout\n");

    }

    // write out gradient
    ndim=4;
    if(0!=init_sep3d_par(&outfile1,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write gradout file!\n");
    outfile1.o[0]=XC2dMPISolver_oz;
    outfile1.d[0]=XC2dMPISolver_dz;
    outfile1.n[0]=XC2dMPISolver_nz;
    outfile1.o[1]=XC2dMPISolver_ox;
    outfile1.d[1]=XC2dMPISolver_dx;
    outfile1.n[1]=XC2dMPISolver_nx;
    outfile1.n[2]=2;
    outfile1.n[3]=niter;
    sep3d_set_sep3d(&outfile1);
    if(0!=sep3dc_write_description(gradfulpath,&outfile1))
       seperr("unable to output parameters for gradfulout\n");

    // write out updated velocity
    if  (inode==0) 
    {
       ndim=4;
       if(0!=init_sep3d_par(&outfile2,"OUTPUT","FLOAT","REGULAR",ndim,0))
          seperr("unable to write mvout file!\n");
       outfile2.o[0]=XC2dMPISolver_oz;
       outfile2.d[0]=XC2dMPISolver_dz;
       outfile2.n[0]=XC2dMPISolver_nz;
       outfile2.o[1]=XC2dMPISolver_ox;
       outfile2.d[1]=XC2dMPISolver_dx;
       outfile2.n[1]=XC2dMPISolver_nx;
       outfile2.n[2]=3;
       outfile2.o[3]=0;
       outfile2.d[3]=1;
       outfile2.n[3]=niter;
       sep3d_set_sep3d(&outfile2);
       if(0!=sep3dc_write_description(vupd,&outfile2))
          seperr("unable to output parameters for mvout\n");
    } 
  // statrt iterating
    VerbMsg("start iterating in XC2dMPISolver_op\n")
    
    for (iter=0;iter<niter;iter++)
    {  
       ////////////////////////////recording info when necessary
       //calculate current gradient
       sz=nx*nz;
       fprintf(stderr,"start rawgrad calculation in iteration %d in XC2dMPISolver_op\n",iter);
       if (inode>0)
       {
          
          sz=nx*nz;
          //transform back to velocity/eps/delta 
          for (i=2*sz;i<3*sz;i++)
             XC2dMPISolver_tmpmod[i]=0.5*((mod[i]/mod[i-2*sz])*(mod[i]/mod[i-2*sz])-1);
          for (i=sz;i<2*sz;i++)
             XC2dMPISolver_tmpmod[i]=0.5*((mod[i]/mod[i-sz])-1);
          for (i=0;i<sz;i++)
             XC2dMPISolver_tmpmod[i]=sqrt(mod[i])*XC2dMPISolver_dx/XC2dMPISolver_dt;

          for (i=0;i<sz;i++)
             XC2dMPISolver_tmpmod[i]=mod[i];
          
          //do random boundary 
          if (XC2dMPISolver_rndbnd_type==1) 
             stat=XC2dWI_rndbndv1(XC2dMPISolver_tmpmod,nx,nz,nxtape,nztape,XC2dMPISolver_sigma, XC2dMPISolver_alpha_mean, XC2dMPISolver_alpha_sigma, XC2dMPISolver_alpha_maxv, XC2dMPISolver_j_rndbnd, vmin, vmax);
          else if (XC2dMPISolver_rndbnd_type==2) 
             stat=XC2dWI_rndbndv2(XC2dMPISolver_tmpmod,nx,nz,nxtape,nztape,XC2dMPISolver_sigma, XC2dMPISolver_alpha_mean, XC2dMPISolver_alpha_sigma, XC2dMPISolver_alpha_maxv, XC2dMPISolver_j_rndbnd, vmin, vmax);

          //transform back to mod
          for (i=0;i<sz;i++)
             XC2dMPISolver_tmpmod[i]=((XC2dMPISolver_dt*mod[i])/XC2dMPISolver_dx)*((XC2dMPISolver_dt*mod[i])/XC2dMPISolver_dx);
          for (i=sz;i<2*sz;i++)
             XC2dMPISolver_tmpmod[i]=(1+2*mod[i])*mod[i-sz];
          for (i=2*sz;i<3*sz;i++)
             XC2dMPISolver_tmpmod[i]=sqrt(1+2*mod[i])*mod[i-2*sz];
 
          ///
          ///
          /// need to double check for modification for VTI for random boudnary application
          sz=2*sz;
          stat=XC2dCalgrad_rawgrad(mod, XC2dMPISolver_tmpmod, dobs, dwht, XC2dMPISolver_dcal, XC2dMPISolver_dres, &fval, XC2dMPISolver_vsrc, src, XC2dMPISolver_rawgrad, sz, XC2dMPISolver_rawprecond, XC2dMPISolver_needprecond, XC2dMPISolver_nxspline, XC2dMPISolver_nzspline, XC2dMPISolver_dxspline, XC2dMPISolver_dzspline,XC2dMPISolver_precond, rdfulpath, inode, rcdmv, mvpath);
          if (stat==1)
             fprintf(stderr,"Error calling XC2dCalgrad_rawgrad in XC2dMPISolver_op, program terminated\n");

          resd[iter]=fval;
          ////////////////////////////recording info when necessary
          //calculate update direction from current/past gradient 
          //there are 2 gradient components for 2 model components
          sz=nx*nz*2;
          sum=0;
          for (i=0;i<sz;i++)
            if (abs(XC2dMPISolver_rawgrad[i])>sum)
               sum=abs(XC2dMPISolver_rawgrad[i]);
          fprintf(stderr,"maxval of grad in inode %d is %f \n",inode, sum);
          sz=nx*nz;
          VerbMsg("start padgrad calculation in iteration in XC2dMPISolver_op\n")
          stat=XC2dWI_padgrad(XC2dMPISolver_rawgrad, XC2dMPISolver_rawgrad, nx, nz, nxtape, nztape );
          stat=XC2dWI_padgrad(&XC2dMPISolver_rawgrad[sz], &XC2dMPISolver_rawgrad[sz], nx, nz, nxtape, nztape );
          if (stat==1)
             fprintf(stderr,"Error calling XC2dCalgrad_padgrad in XC2dMPISolver_op, program terminated\n");
          for (i=0;i<nx*nz*2;i++)
             XC2dMPISolver_frawgrad[i]=XC2dMPISolver_rawgrad[i];
          if (sz*2*4!=srite(gradfulpath,XC2dMPISolver_frawgrad,sz*2*4))      
             seperr("Error!can't write rawgrad out in slave node!\n");
          /*sz=nx*nz;
          sum=0;
          for (i=0;i<sz;i++)
            if (XC2dMPISolver_rawgrad[i]>sum)
               sum=XC2dMPISolver_rawgrad[i];
          fprintf(stderr,"maxval of grad in inode %d is %f \n",inode, sum);
          */sz=nx*nz;
          if (XC2dMPISolver_needprecond==1)
          {
             VerbMsg("start padgrad for preconditioner calculation in iteration in XC2dMPISolver_op\n")
             stat=XC2dWI_padgrad(XC2dMPISolver_rawprecond, XC2dMPISolver_rawprecond, nx, nz, nxtape, nztape );
             stat=XC2dWI_padgrad(&XC2dMPISolver_rawprecond[sz], &XC2dMPISolver_rawprecond[sz], nx, nz, nxtape, nztape );
             if (stat==1)
                fprintf(stderr,"Error calling XC2dCalgrad_padgrad for preconditioner in XC2dMPISolver_op, program terminated\n");
          }
       }
       else
       {
          for (i=0;i<nx*nz*2;i++)
                XC2dMPISolver_rawgrad[i]=0;

          if (XC2dMPISolver_needprecond==1)
          {
             for(i=0;i<nx*nz*2;i++)
                XC2dMPISolver_rawprecond[i]=0;
          }
          else if (XC2dMPISolver_needprecond==2)
          {
             for(i=0;i<2*XC2dMPISolver_nxspline*XC2dMPISolver_nzspline;i++)
                XC2dMPISolver_precond[i]=0;
          }

       }
       MPI_Barrier(MPI_COMM_WORLD);
       //////////////////////////////////////////////////////////////////////////////////////////////////////////
       //////////////////////////////// do something such as recording full data residual

       //////////////////////////////////////////////////////////////////////////////////////////////////////////

       //////////////////////////////////////////////////////////////////////////////////////////////////////////
       // reduction operation for gradient and preconditioner(when necessary)
       sz=nx*nz*2;
       MPI_Reduce(XC2dMPISolver_rawgrad,XC2dMPISolver_tmprawgrad,sz,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
      
       MPI_Barrier(MPI_COMM_WORLD);
       
       if (XC2dMPISolver_needprecond==1)
       {
          sz=2*nx*nz;
          MPI_Reduce(XC2dMPISolver_rawprecond,XC2dMPISolver_tmprawprecond,sz,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
       }
       else if (XC2dMPISolver_needprecond==2)
       {
          sz=2*XC2dMPISolver_nxspline*XC2dMPISolver_nzspline;
          MPI_Reduce(XC2dMPISolver_precond,XC2dMPISolver_tmpprecond,sz,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
       }
       //////////////////////////////////////////////////////////////////////////////////////////////////////////
       // in Master node, perform gradient processing
       if (inode==0)
       {
          sz=2*nx*nz;
          for(i=0;i<sz;i++)
             XC2dMPISolver_rawgrad[i]=XC2dMPISolver_tmprawgrad[i];

          sz=2*nx*nz;
          sum=0;
          for (i=0;i<sz;i++)
            if (XC2dMPISolver_tmprawgrad[i]>sum)
               sum=XC2dMPISolver_tmprawgrad[i];
          fprintf(stderr,"maxval of grad in inode %d is %f \n",inode, sum);
          if (XC2dMPISolver_needprecond==1)
             for(i=0;i<sz;i++)
                XC2dMPISolver_rawprecond[i]=XC2dMPISolver_tmprawprecond[i];
          else if (XC2dMPISolver_needprecond==2)
          {
             sz=2*XC2dMPISolver_nxspline*XC2dMPISolver_nzspline;
             for(i=0;i<sz;i++)
                XC2dMPISolver_precond[i]=XC2dMPISolver_tmpprecond[i];
          }
          stat=XC2dMPISolver_gradproc(denom);
          if (stat==1)
             fprintf(stderr,"Error calling XC2dMPISolver_gradproc in XC2dMPISolver_op, program terminated\n");
          sz=nx*nz;
   
          for (i=0;i<nx*nz*2;i++)
             XC2dMPISolver_frawgrad[i]=XC2dMPISolver_rawdirecm[i];
          if (sz*2*4!=srite(gradfulpath,XC2dMPISolver_frawgrad,sz*2*4))      
             seperr("Error!can't write rawgrad out in slave node!\n");
          sum=0;
          sz=2*nx*nz;
          for (i=0;i<sz;i++)
            if (XC2dMPISolver_rawdirecm[i]>sum)
               sum=XC2dMPISolver_rawdirecm[i];
          fprintf(stderr,"maxval of grad in inode %d is %f \n",inode, sum);
       }
        // Broadcast processed full gradient to all Slaver node
       sz=2*nx*nz;
       MPI_Bcast(XC2dMPISolver_rawdirecm,sz,MPI_DOUBLE,0,MPI_COMM_WORLD);

       ////////////////////////////recording info when necessary
       //calculate steplength
       if (inode>0) 
       {
          VerbMsg("start calsteplength_op calculation in iteration in XC2dMPISolver_op\n")
          ///
          ///
          /// need to double check for modification for VTI
          stat=XC2dCalsteplength_mpiop(mod, XC2dMPISolver_tmpmod, XC2dMPISolver_rawdirecm, dobs, dwht, XC2dMPISolver_dcal, XC2dMPISolver_dres, src, fval,  &alphaout, &alpha1, &fval1, &alpha2, &fval2, isdepmin, isdepmax);
          if (stat==1)
             fprintf(stderr,"Error calling XC2dCalgrad_rawgrad in XC2dMPISolver_op, program terminated\n");
       }
       else
       {
          alpha1=0;
          alpha2=0;
          fval=0;
          fval1=0;
          fval2=0;
       }
       MPI_Barrier(MPI_COMM_WORLD);
       MPI_Reduce(&alpha1,&x1,1,MPI_FLOAT,MPI_SUM,0,MPI_COMM_WORLD);
       MPI_Reduce(&alpha2,&x2,1,MPI_FLOAT,MPI_SUM,0,MPI_COMM_WORLD);
       MPI_Reduce(&fval,&y0,1,MPI_FLOAT,MPI_SUM,0,MPI_COMM_WORLD);
       MPI_Reduce(&fval1,&y1,1,MPI_FLOAT,MPI_SUM,0,MPI_COMM_WORLD);
       MPI_Reduce(&fval2,&y2,1,MPI_FLOAT,MPI_SUM,0,MPI_COMM_WORLD);
       if (inode==0)
       {
          resd[iter]=y0;
          x0=0.;
          x1=x1/(XC2dMPISolver_nnode-1);
          x2=x2/(XC2dMPISolver_nnode-1);
          stat=XC2dCalsteplength_parabola_fit(x0, x1, x2, y0, y1, y2, &alphaout);
          //alphaout=x1;
          //for (i=0;i<nx*nz*2;i++)
          //   XC2dMPISolver_frawgrad[i]=XC2dMPISolver_rawdirecm[i];

          //update model
          sz=nx*nz;
          VerbMsg("start updatev calculation in iteration in XC2dMPISolver_op\n")
          stat=XC2dWI_updatemod(mod, XC2dMPISolver_rawdirecm, alphaout, mod, sz, XC2dMPISolver_mmin, XC2dMPISolver_mmax, XC2dMPISolver_paramtype, XC2dMPISolver_dt, XC2dMPISolver_dx);
          stat=XC2dWI_equalepsdel(mod, mod, nz, nx, isdepmin, isdepmax, nztape, nxtape);

         /*for (ix=0;ix<nx;ix++)
             for (iz=nztape;iz<nztape+10;iz++)
             {   
                idx=iz+ix*nz;   
                mod[idx+2*nz*nx]=mod[idx+nz*nx]/sqrt(mod[idx+nz*nx]/mod[ix]);
             }
	*/
       }

       sz=nx*nz*3;
       MPI_Bcast(mod,sz,MPI_FLOAT,0,MPI_COMM_WORLD);
       MPI_Barrier(MPI_COMM_WORLD);

       ////////////////////////////recording info when necessary
       if (inode==0)
       {
          if (XC2dMPISolver_needspline==0)
          {
             for (i=0;i<2*nz*nx;i++)
                XC2dMPISolver_prevgrad[i]=XC2dMPISolver_rawgrad[i];
          }
          else
          {
             for (i=0;i<2*XC2dMPISolver_nzspline*XC2dMPISolver_nxspline;i++)
                XC2dMPISolver_prevgrad[i]=XC2dMPISolver_grad[i];
          }
          
          sz=nx*nz;
          //transform back to velocity/eps/delta 
          for (i=2*sz;i<3*sz;i++)
             mod[i]=0.5*((mod[i]/mod[i-2*sz])*(mod[i]/mod[i-2*sz])-1);
          for (i=sz;i<2*sz;i++)
             mod[i]=0.5*((mod[i]/mod[i-sz])-1);
          for (i=0;i<sz;i++)
             mod[i]=sqrt(mod[i])*XC2dMPISolver_dx/XC2dMPISolver_dt;
       
          sz=nx*nz;    
          if (sz*3*4!=srite(vupd,mod,sz*3*4))
             seperr("Error!can't write updated mod in head node!\n");

          //transform back to mod
          for (i=0;i<sz;i++)
             mod[i]=((XC2dMPISolver_dt*mod[i])/XC2dMPISolver_dx)*((XC2dMPISolver_dt*mod[i])/XC2dMPISolver_dx);
          for (i=sz;i<2*sz;i++)
             mod[i]=(1+2*mod[i])*mod[i-sz];
          for (i=2*sz;i<3*sz;i++)
             mod[i]=sqrt(1+2*mod[i])*mod[i-2*sz];
       }
    }
    
    if (inode==0)
    {
       sz=nx*nz;
       //transform back to velocity/eps/delta 
       for (i=2*sz;i<3*sz;i++)
          mod[i]=0.5*((mod[i]/mod[i-2*sz])*(mod[i]/mod[i-2*sz])-1);
       for (i=sz;i<2*sz;i++)
          mod[i]=0.5*((mod[i]/mod[i-sz])-1);
       for (i=0;i<sz;i++)
          mod[i]=sqrt(mod[i])*XC2dMPISolver_dx/XC2dMPISolver_dt;
       
        //do random boundary 
        if (XC2dMPISolver_rndbnd_type==1) 
           stat=XC2dWI_rndbndv1(mod,nx,nz,nxtape,nztape,XC2dMPISolver_sigma, XC2dMPISolver_alpha_mean, XC2dMPISolver_alpha_sigma, XC2dMPISolver_alpha_maxv, XC2dMPISolver_j_rndbnd, vmin, vmax);
        else if (XC2dMPISolver_rndbnd_type==2) 
           stat=XC2dWI_rndbndv2(mod,nx,nz,nxtape,nztape,XC2dMPISolver_sigma, XC2dMPISolver_alpha_mean, XC2dMPISolver_alpha_sigma, XC2dMPISolver_alpha_maxv, XC2dMPISolver_j_rndbnd, vmin, vmax);

        //transform back to mod
        for (i=0;i<sz;i++)
           mod[i]=((XC2dMPISolver_dt*mod[i])/XC2dMPISolver_dx)*((XC2dMPISolver_dt*mod[i])/XC2dMPISolver_dx);
        for (i=sz;i<2*sz;i++)
           mod[i]=(1+2*mod[i])*mod[i-sz];
        for (i=2*sz;i<3*sz;i++)
           mod[i]=sqrt(1+2*mod[i])*mod[i-2*sz];
    }
    return 0;
}


int XC2dMPISolver_gradproc(double *denom)
{
    double *rawgrad, *grad, *prevgrad, *rawprecond, *precond, *rawdirecm, *direcm, *tmpsplinearray1, *tmpsplinearray2;
   int nx, nz, sz;
   int stat;
   float gradmax,sum;

   rawgrad=XC2dMPISolver_rawgrad;
   grad=XC2dMPISolver_grad;
   prevgrad=XC2dMPISolver_prevgrad;
   rawprecond=XC2dMPISolver_rawprecond;
   precond=XC2dMPISolver_precond;
   rawdirecm=XC2dMPISolver_rawdirecm;
   direcm=XC2dMPISolver_direcm;
   tmpsplinearray1=XC2dMPISolver_tmpsplinearray1;
   tmpsplinearray2=XC2dMPISolver_tmpsplinearray2;

   nx=XC2dMPISolver_nx;
   nz=XC2dMPISolver_nz;

   if (XC2dMPISolver_needspline==0)
   {
      // If not use spline smoothing of graidnet
      sz=nx*nz;
      if (XC2dMPISolver_needprecond==1)
      {
         //calculate preconditioned gradient if needed
         stat=XC2dWI_caldirecmwithprecond(prevgrad, rawgrad, rawprecond, &denom[0], &denom[0], rawdirecm, rawdirecm, sz );
         //stat=XC2dWI_caldirecm(prevgrad, rawgrad, rawdirecm, rawdirecm, sz );
         stat=XC2dWI_caldirecmwithprecond(&prevgrad[sz], &rawgrad[sz], &rawprecond[sz], &denom[1], &denom[1], &rawdirecm[sz], &rawdirecm[sz], sz );
      if (stat==1)
         fprintf(stderr,"Error calling XC2dCalgrad_caldirecm in XC2dMPISolver_gradproc, program terminated\n");
      }
      else
      {
         //else just past gradient into direcm
         //stat=XC2dWI_caldirecm(prevgrad, rawgrad, rawdirecm, rawdirecm, sz );
         //stat=XC2dWI_caldirecm(&prevgrad[sz], &rawgrad[sz], &rawdirecm[sz], &rawdirecm[sz], sz );
         stat=XC2dWI_caldirecm(prevgrad, rawgrad, rawdirecm, rawdirecm, 2*sz );
         if (stat==1)
            fprintf(stderr,"Error calling XC2dCalgrad_caldirecm in XC2dMPISolver_gradproc, program terminated\n");
      }
   }
   else
   {
      // If use spline smoothing, modify graidnet correspondingly
      fprintf(stderr,"processing for the case needspline>0\n");
      int nxspline, nzspline, dx, dz, dxspline, dzspline;
      int n3, ny, idim;
      int i;
      dx=XC2dMPISolver_dx;
      dz=XC2dMPISolver_dz;
      nxspline=XC2dMPISolver_nxspline;
      nzspline=XC2dMPISolver_nzspline;
      dxspline=XC2dMPISolver_dxspline;
      dzspline=XC2dMPISolver_dzspline;
      ny=1;

      // adjoint spline operator on raw gradient, 1st component
      for (i=0;i<nzspline*nx;i++)
         tmpsplinearray1[i]=0;
      for (i=0;i<nzspline*nxspline;i++)
         tmpsplinearray2[i]=0;
      for (i=0;i<nzspline*nxspline;i++)
         grad[i]=0;
      idim=0;
      stat=XC2dWI_spline_adj(tmpsplinearray1, rawgrad, nzspline, nx, ny, idim, dzspline, nz, dz);
      idim=1;
      stat=XC2dWI_spline_adj(grad, tmpsplinearray1, nzspline, nxspline, ny, idim, dxspline, nx, dx);
      
      // adjoint spline operator on raw gradient, 2nd component
      for (i=0;i<nzspline*nx;i++)
         tmpsplinearray1[i]=0;
      for (i=0;i<nzspline*nxspline;i++)
         tmpsplinearray2[i]=0;
      for (i=0;i<nzspline*nxspline;i++)
         grad[i+nzspline*nxspline]=0;
      idim=0;
      stat=XC2dWI_spline_adj(tmpsplinearray1, &rawgrad[nz*nx], nzspline, nx, ny, idim, dzspline, nz, dz);
      idim=1;
      stat=XC2dWI_spline_adj(&grad[nzspline*nxspline], tmpsplinearray1, nzspline, nxspline, ny, idim, dxspline, nx, dx);

       sum=0;
       for (i=0;i<nzspline*nx;i++)
          sum+=fabsf(tmpsplinearray1[i]);
       VerbMsg2("tmpsplinearray1 of size %d with sum %f \n",nzspline*nx,sum)
       sum=0;
       for (i=0;i<nzspline*nxspline;i++)
          sum+=fabsf(grad[i]);
       VerbMsg2("grad of size %d with sum %f \n",nzspline*nxspline,sum)


      sz=nzspline*nxspline;
      if (XC2dMPISolver_needprecond==1)
      {
         // adjoint spline operator on zero-lag of auto-correlation of raw src wavefield, then calculate preconditioned gradient
         // 1st component of precond
         for (i=0;i<nzspline*nx;i++)
            tmpsplinearray1[i]=0;
         for (i=0;i<nzspline*nxspline;i++)
            tmpsplinearray2[i]=0;
         for (i=0;i<nzspline*nxspline;i++)
            precond[i]=0;
         idim=0;
         stat=XC2dWI_spline_adj(tmpsplinearray1, rawprecond, nzspline, nx, ny, idim, dzspline, nz, dz);
         idim=1;
         stat=XC2dWI_spline_adj(precond, tmpsplinearray1, nzspline, nxspline, ny, idim, dxspline, nx, dx);
         // 2nd component of precond
         for (i=0;i<nzspline*nx;i++)
            tmpsplinearray1[i]=0;
         for (i=0;i<nzspline*nxspline;i++)
            tmpsplinearray2[i]=0;
         for (i=0;i<nzspline*nxspline;i++)
            precond[i+nzspline*nxspline]=0;
         idim=0;
         stat=XC2dWI_spline_adj(tmpsplinearray1, &rawprecond[nz*nx], nzspline, nx, ny, idim, dzspline, nz, dz);
         idim=1;
         stat=XC2dWI_spline_adj(&precond[nzspline*nxspline], tmpsplinearray1, nzspline, nxspline, ny, idim, dxspline, nx, dx);

         stat=XC2dWI_caldirecmwithprecond(prevgrad, grad, precond, &denom[0], &denom[0], direcm, direcm, sz );
         stat=XC2dWI_caldirecmwithprecond(&prevgrad[nzspline*nxspline], &grad[nzspline*nxspline], &precond[nzspline*nxspline], &denom[1], &denom[1], &direcm[nzspline*nxspline], &direcm[nzspline*nxspline], sz );
         if (stat==1)
         {
            fprintf(stderr,"Error calling XC2dCalgrad_caldirecm in XC2dMPISolver_gradproc, program terminated\n");
            return 1;
         }
      }
      else if (XC2dMPISolver_needprecond==2)
      {
         // use zero-lag of auto-correlation of adjoint spline operated src wavefield, to calculate preconditioned gradient
         stat=XC2dWI_caldirecmwithprecond(prevgrad, grad, precond, &denom[0], &denom[0], direcm, direcm, sz );
         stat=XC2dWI_caldirecmwithprecond(&prevgrad[nzspline*nxspline], &grad[nzspline*nxspline], &precond[nzspline*nxspline], &denom[1], &denom[1], &direcm[nzspline*nxspline], &direcm[nzspline*nxspline], sz );
         if (stat==1)
         {
            fprintf(stderr,"Error calling XC2dCalgrad_caldirecm in XC2dMPISolver_gradproc, program terminated\n");
            return 1;
         }
      }
      else
      {
         //stat=XC2dWI_caldirecm(prevgrad, grad, direcm, direcm, sz );
         //stat=XC2dWI_caldirecm(&prevgrad[sz], &grad[sz], &direcm[sz], &direcm[sz], sz );
         stat=XC2dWI_caldirecm(prevgrad, grad, direcm, direcm, 2*sz );
         if (stat==1)
         {
            fprintf(stderr,"Error calling XC2dCalgrad_caldirecm in XC2dMPISolver_gradproc, program terminated\n");
            return 1;
         }
      }
      // forward operator to calculate direcm from spline represented gradient
      // 1st component
      for (i=0;i<nzspline*nx;i++)
         tmpsplinearray1[i]=0;
      for (i=0;i<nzspline*nxspline;i++)
         tmpsplinearray2[i]=0;
      for (i=0;i<nz*nx;i++)
         rawdirecm[i]=0;
      idim=1;
      stat=XC2dWI_spline_forward(direcm, tmpsplinearray1, nzspline, nxspline, ny, idim, dxspline, nx, dx);
      idim=0;
      stat=XC2dWI_spline_forward(tmpsplinearray1, rawdirecm, nzspline, nx, ny, idim, dzspline, nz, dz);
      // 2nd component
      for (i=0;i<nzspline*nx;i++)
         tmpsplinearray1[i]=0;
      for (i=0;i<nzspline*nxspline;i++)
         tmpsplinearray2[i]=0;
      for (i=0;i<nz*nx;i++)
         rawdirecm[i+nz*nx]=0;
      idim=1;
      stat=XC2dWI_spline_forward(&direcm[nzspline*nxspline], tmpsplinearray1, nzspline, nxspline, ny, idim, dxspline, nx, dx);
      idim=0;
      stat=XC2dWI_spline_forward(tmpsplinearray1, &rawdirecm[nz*nx], nzspline, nx, ny, idim, dzspline, nz, dz);

   }

   //stat=XC2dWI_mutedirecm(rawdirecm, rawdirecm, nz, nx, nz/3 );
   return 0;

}


void reverse(char s[])
{
   int i,j;
   char c;
   for (i=0,j=strlen(s)-1;i<j;i++,j--)
   {
      c=s[i];
      s[i]=s[j];
      s[j]=c;
   }
}

void itoa(int n, char s[])
{
   int i, sign;
   if ( (sign=n)<0 )
      n=-n;
   i=0;
   do {
      s [i++]=n%10+'0';
   } while ((n/=10)>0);
   if (sign<0)
     s[i++]='-';
     s[i]='\0'; 
   reverse(s);
}  
