int XC2dWI_calresd_conv(float *dobs, float *dcal, float *dres, float *vsrc, int needvsrc, int n1, int n2)
{
   int i1,i2,idx;
   for (i2=0;i2<n2;i2++)
      for (i1=0;i1<n1;i1++)
      {
         idx=i1+i2*n1; 
         dres[idx]=dobs[idx]-dcal[idx];
         //dres[idx]=dobs[idx];
         if (needvsrc>0)
            vsrc[idx]=dres[idx];
      }

   return 0; 
}


int XC2dWI_calresd_WT(float *dobs, float *dcal, float *dres, float *vsrc, int needvsrc, int n1, int n2, float thresd)
{
   int i1,i2,idx,itlag;
   float *tr1,*tr2, *xcorr;
   int ntlag;
   float maxval,alpha;
   double sum,pi,sum1;
   int maxidx;

   tr1=(float*)malloc(sizeof(float)*n1);
   tr2=(float*)malloc(sizeof(float)*n1);
   ntlag=10;
   xcorr=(float*)malloc(sizeof(float)*(2*ntlag+1));
   pi=3.14159265358979;
   for (i2=0;i2<n2;i2++)
   {
      for (i1=0;i1<2*ntlag+1;i1++)
         xcorr[i1]=0;
      for (i1=0;i1<n1;i1++)
         tr1[i1]=dcal[i1+i2*n1];
      for (itlag=-ntlag;itlag<1;itlag++)
      {
         for (i1=0;i1<n1;i1++)
            tr2[i1]=0;
         for (i1=0;i1<n1+itlag;i1++)
            tr2[i1]=dobs[i1-itlag+i2*n1];
         for (i1=0;i1<n1;i1++)
            xcorr[itlag+ntlag]+=tr1[i1]*tr2[i1];
      }
      for (itlag=1;itlag<ntlag;itlag++)
      {
         for (i1=0;i1<n1;i1++)
            tr2[i1]=0;
         for (i1=itlag;i1<n1;i1++)
            tr2[i1]=dobs[i1-itlag+i2*n1];
         for (i1=0;i1<n1;i1++)
            xcorr[itlag+ntlag]+=tr1[i1]*tr2[i1];
      }
      //for (itlag=0;itlag<2*ntlag+1;itlag++)
      //{
         //alpha=cos( pi*((1.*(itlag-(ntlag+1)))/ntlag) )+1.;
         //xcorr[itlag] *=alpha;
      //}
      maxval=0;
      maxidx=0;
      for (itlag=0;itlag<2*ntlag+1;itlag++)
      {
         if (xcorr[itlag]>maxval)
         {
            maxval=xcorr[itlag];
            maxidx=itlag-ntlag;
         }
      }

      for (i1=0;i1<n1-1;i1++)
         tr1[i1]=dcal[i1+1+i2*n1]-dcal[i1+i2*n1];
      tr1[n1-1]=0;

      for (i1=0;i1<n1;i1++)
         tr2[i1]=0;

      if (maxidx>0)
      {
         for (i1=maxidx;i1<n1-1;i1++)
            tr2[i1]=dobs[i1+1-maxidx+i2*n1]-dobs[i1-maxidx+i2*n1];
      }
      else
      {
         for (i1=0;i1<n1-1+maxidx;i1++)
            tr2[i1]=dobs[i1+1-maxidx+i2*n1]-dobs[i1-maxidx+i2*n1];
      }

      sum=0;
      for (i1=0;i1<n1;i1++)
         sum+=tr1[i1]*tr2[i1];

      sum1=0;
      for (i1=0;i1<n1;i1++)
         sum1+=fabsf(dobs[i1+i2*n1]);

      for (i1=0;i1<n1;i1++)
      {
         idx=i1+i2*n1;
         if (fabs(sum1)<thresd)
            dres[idx]=0;
         else
            dres[idx]=(float)((1.*maxidx)/n1);
         if (needvsrc>0)
         {
            if (fabs(sum1)<thresd)
               vsrc[idx]=0;
            else
               vsrc[idx]=(1./sum)*tr2[i1]*maxidx;
               //vsrc[idx]=(1./sum)*tr1[i1]*maxidx;
               //vsrc[idx]=tr2[i1]*maxidx;
               //vsrc[idx]=tr1[i1]*maxidx;
         }
      }
   }
   free(tr1);
   free(tr2);
   free(xcorr);
   return 0;

}

int XC2dWI_calresd_NormAmp(float *dobs, float *dcal, float *dres, float *vsrc, int needvsrc, int n1, int n2, float thresd)
{
   int i1,i2,idx;
   double dobsnrm, dcalnrm, xcorres;
   for (i2=0;i2<n2;i2++)
   {
      dobsnrm=0;
      dcalnrm=0;
      xcorres=0;
      for (i1=0;i1<n1;i1++)
      {
         idx=i1+i2*n1;
         dobsnrm+=dobs[idx]*dobs[idx];
         dcalnrm+=dcal[idx]*dcal[idx];
         xcorres+=dobs[idx]*dcal[idx];
      }
      dobsnrm=sqrt(dobsnrm);
      dcalnrm=sqrt(dcalnrm);
      if (dcalnrm<thresd)
      {
         for (i1=0;i1<n1;i1++)
         {
            idx=i1+i2*n1;
            dres[idx]=0;
            if (needvsrc>0)
               vsrc[idx]=0;
         }
      }
      else
      {
         xcorres=xcorres/dcalnrm-dobsnrm;
         for (i1=0;i1<n1;i1++)
         {
            idx=i1+i2*n1;
            //dres[idx]=(dobs[idx]-dcal[idx]*dobsnrm);
            //if (needvsrc>0)
            //   vsrc[idx]=(dres[idx]-dcal[idx]*xcorres)*dobsnrm;
            dres[idx]=(dobs[idx]-dcal[idx]*(dobsnrm/dcalnrm));
            if (needvsrc>0)
               vsrc[idx]=(dres[idx]-dcal[idx]*(xcorres/dcalnrm))*(dobsnrm/dcalnrm);
         }
      }
   }
   return 0;
}


int XC2dWI_calobjfunc(float *dwht, float *dres, int n1, int n2, double *fval)
{
   int i1,i2,idx;
   for (i2=0;i2<n2;i2++)
      for (i1=0;i1<n1;i1++)
      {
         idx=i1+i2*n1;
         *fval+=(((double)dres[idx])*dres[idx]);
      }

   return 0;


}

