#define Errmsg2(str,str1)  {fprintf(stderr,str,str1);return 1;}
#define Errmsg3(str,str1,str2)  {fprintf(stderr,str,str1,str2);return 1;}

#include "stdlib.h"
#include "stdio.h"
#include "math.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>
#include "mpi.h"
#include "fftw3.h"
#include "XC2dMPISolver.c"


int main(int argc, char** argv)
{
    VerbMsg("Start Main\n")	
    int ndim,i,n;
    float o,d;
    char temp_char[256];
    char rdfulpath[256],tmppath[256], mvpath[256];
    char gradfulpath[256],vupd[256];
    int   nt, nx, nz, ns, ns_each;
    float ot, ox, oz;
    float dt, dx, dz;
    int   it, ix, iz, is;
    int   nxtape,nztape;
    int   needwvmv,jtmv,needprecond,niter;
    float vmin, vmax, mmin, mmax,vmax1;
    int   sz,stat;
    float *mod, *src, *dobs, *dwht, *sdep, *rdep, *wvmv, *resd;
    sep3d outfile; 
    time_t time1,time2;
    MPI_Status mpistat;
    int inode, nnode;
    int needspline;
    float dxspline, dzspline;
    int jrdful, jnoderdful, ntlagth, objtype, paramtype, rcdmv;
    float thresd, eps; 
    char file[80];
    float sum;
    float sigma,alpha_mean,alpha_sigma,alpha_maxV;
    int j_rndbnd, rndbnd_type, freesurf;
    int i1,cnt,idx1,idx2; 
    long memcnt=0;

    initpar(argc,argv);

    stat=MPI_Init(&argc,&argv);
    VerbMsg("MPI_init done\n")
    stat=MPI_Comm_rank(MPI_COMM_WORLD, &inode);
    stat=MPI_Comm_size(MPI_COMM_WORLD, &nnode);
    VerbMsg("getting inode, nnode done\n")

    if (inode==0)
    {
       // readin other parameters
       if (0==getch("nxtape","i", &nxtape)) nxtape=50;
       if (0==getch("nztape","i", &nztape)) nztape=50;
       if (0==getch("jtmv","i", &jtmv)) jtmv=10;
       if (0==getch("vmin","f", &vmin)) vmin=1200;
       if (0==getch("vmax","f", &vmax)) vmax=2000;
       if (0==getch("needprecond","i", &needprecond)) needprecond=0;
       if (0==getch("niter","i", &niter)) niter=1;
       if (0==getch("rdfulpath","s", rdfulpath)) strcpy(rdfulpath,"./rdful-inode-");
       if (0==getch("gradfulpath","s", gradfulpath)) strcpy(gradfulpath,"./gradful-inode-");
       if (0==getch("sigma","f", &sigma)) sigma=100;
       if (0==getch("alpha_mean","f", &alpha_mean)) alpha_mean=0.1;
       if (0==getch("alpha_sigma","f", &alpha_sigma)) alpha_sigma=0.1;
       if (0==getch("alpha_maxV","f", &alpha_maxV)) alpha_maxV=0.0;
       if (0==getch("j_rndbnd","i", &j_rndbnd)) j_rndbnd=2;
       if (0==getch("rndbnd_type","i", &rndbnd_type)) rndbnd_type=1;
       if (0==getch("freesurf","i", &freesurf)) freesurf=0;
       if (0==getch("thresd","f", &thresd)) thresd=0.0000001;
       // 0 means L2 subtraction, 1 means WT, 2 means NormAmp 
       if (0==getch("objtype","i", &objtype)) objtype=0;
       // 1 means velocity parameterizaion, 2 means logarithmic velocity parameterization 
       if (0==getch("paramtype","i", &paramtype)) paramtype=1;
       if (0==getch("rcdmv","i", &rcdmv)) rcdmv=0;
       if (0==getch("vupd","s", vupd)) strcpy(vupd,"./vupd-");
       if (0==getch("jrdful","i", &jrdful)) jrdful=1;

       // read t,x,y from data file
       if(0!=sep_get_number_data_axes("in",&ndim))
          seperr("unable to get dimension from dat!\n");
    
       for(i=1;i<=ndim;i++)
       {
          if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
             seperr("unable to get parameters from dat!\n");
          if(i==1)
          {
             nt=n;
             dt=d;
             ot=o;
          }
          else if(i==2)
          {   
             nx=n+2*nxtape;
             dx=d;
             ox=o-d*nxtape;
          }
          if (ndim==2) 
             ns=1; 
          else if(i==3)
             ns=n;
       }

       if(0!=sep_get_number_data_axes("src",&ndim))
          seperr("unable to get dimension from src file!\n");
       for(i=1;i<=ndim;i++)
       {
          if(0!=sep_get_data_axis_par("src",&i,&n,&o,&d,temp_char))
             seperr("unable to get parameters from src file!\n");
          if(i==1)
          {
             if (nt!=n)
                Errmsg3("nt in data %d different from nt %d in src, program terminated!\n",nt,n)
             if (dt!=d)
                Errmsg3("dt in data %f different from dt %f in src, program terminated!\n",dt,d)
             if (ot!=o)
                Errmsg3("ot in data %f different from ot %f in src, program terminated!\n",ot,o)
          }
          else if(i==2)
          {
             if (nx!=n+2*nxtape)
                Errmsg3("nx in data %d different from nx %d in src, program terminated!\n",nx,n)
             if (dx!=d)
                Errmsg3("dx in data %f different from dx %f in src, program terminated!\n",dx,d)
             if (ox!=o-d*nxtape)
                Errmsg3("ox in data %f different from ox %f in src, program terminated!\n",ox,o)
          }
          if (ndim==2) 
             ns=1; 
          else if(i==3)
             if (ns!=n)
                Errmsg3("ns in dat %d different from ns %d in src, program terminated!\n",n,ns)
       }

       // read z info from mod
       // mod is of dimension nz*nx*3
       // input file consists of velocity/epsilon/delta
       // in the program, as far as forward/backward modeling are concerned, these three parameters are converted to (dt*v/dx)^2, (1+2eps)*(dt*v/dx)^2, sqrt(1+2delta)*(dt*v/dx)^2
       // in the inversion, different parameterizations will have different gradients, they will be calculated differently, however, after gradient and steplength calculation, the three parameters will be updated correspondingly 
       if(0!=sep_get_number_data_axes("mod",&ndim))
          seperr("unable to get dimension from mod file!\n");
       if (ndim!=3)
          seperr("wrong dimension of the input model parameters");
       for(i=1;i<=ndim;i++)
       {
          if(0!=sep_get_data_axis_par("mod",&i,&n,&o,&d,temp_char))
             seperr("unable to get parameters from mod file!\n");
          if(i==1)
          {
             nz=n;
             dz=d;
             oz=o;
          }
          else if(i==2)
          {
             if (nx!=n)
                Errmsg3("nx in mod %d different from nx %d in src, program terminated!\n",n,nx)
             if (dx!=d)
                Errmsg3("dx in mod %f different from dx %f in src, program terminated!\n",d,dx)
             if (ox!=o)
                Errmsg3("ox in mod %f different from ox %f in src, program terminated!\n",o,ox)
          }
          else if(i==3)
          {
             if (n!=3)
                Errmsg2("n in mod %d is different from 3 which is required for VTI modeling!\n",n)
          }
       }

       if (nx<=2*nxtape)
          Errmsg3("Error, nx %d less or equal than twice of padded x reigon %d \n",nx,nxtape);
       if (nz<=2*nztape)
          Errmsg3("Error, nz %d less or equal than twice of padded z reigon %d \n",nz,nztape);
    
          // whether use spline to represent gradient
       if (0==getch("needspline","i", &needspline)) needspline=0;
       // x smoothing length
       if (0==getch("dxspline","f", &dxspline)) dxspline=2*dx;
       // z smoothing length
       if (0==getch("dzspline","f", &dzspline)) dzspline=2*dz;


       // check how many shots for each node, the head node doesn't do any finite difference, only the rest nodes do.
       ns_each=ns/(nnode-1);
       if (ns_each*(nnode-1)!=ns)
           fprintf(stderr,"Warning! number of shots can not be dividely equally among nodes");

    }

     // distribute paramters into all nodes
    MPI_Bcast(&ot, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&oz, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&ox, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&dt, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&dz, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&dx, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&nt, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&nz, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&nx, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&ns_each, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&nztape, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&nxtape, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&jtmv, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&vmin, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&vmax, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&needprecond, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&niter, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&needspline, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&dzspline, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&dxspline, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&jrdful, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&jnoderdful, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&objtype, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&paramtype, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&eps, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&ntlagth, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&thresd, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(rdfulpath, 256, MPI_CHAR, 0, MPI_COMM_WORLD);
    MPI_Bcast(gradfulpath, 256, MPI_CHAR, 0, MPI_COMM_WORLD);
    MPI_Bcast(&j_rndbnd, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&rndbnd_type, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&freesurf, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&sigma, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&alpha_mean, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&alpha_sigma, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&alpha_maxV, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
    MPI_Bcast(&rcdmv, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(vupd, 256, MPI_CHAR, 0, MPI_COMM_WORLD);
    
    VerbMsg2("nxtape in node %d is %d \n",inode,nxtape)   
    VerbMsg2("nztape in node %d is %d \n",inode,nztape)   
    VerbMsg2("nx in node %d is %d \n",inode,nx)   
    VerbMsg2("nz in node %d is %d \n",inode,nz)   
    VerbMsg2("nt in node %d is %d \n",inode,nt)   
    VerbMsg2("dx in node %d is %f \n",inode,dx)   
    VerbMsg2("dz in node %d is %f \n",inode,dz)   
    VerbMsg2("dt in node %d is %f \n",inode,dt)   
    VerbMsg2("paramtype in node %d is %d \n",inode,paramtype)   

    // allocate memories

    mod=(float*)malloc(3*nx*nz*sizeof(float));
    memcnt+=nx*nz*sizeof(float);
    sz=(nx-2*nxtape)*nt*ns_each;
    VerbMsg1("----------sz of src is %d-------------\n",sz)
    src=(float*)malloc(sz*sizeof(float));
    dobs=(float*)malloc(sz*sizeof(float));
    dwht=(float*)malloc(sz*sizeof(float));
    memcnt+=sz*sizeof(float)*3;
    sz=(nx-2*nxtape)*ns_each;
    sdep=(float*)malloc(sz*sizeof(float));
    rdep=(float*)malloc(sz*sizeof(float));
    resd=(float*)malloc(niter*sizeof(float));
    for (i=0;i<niter;i++)
       resd[i]=0;
    memcnt+=sz*sizeof(float)*2+niter*sizeof(float);

    sz=(nx-2*nxtape)*nt;
     
    //VerbMsg2("after resd alloc dt in node %d is %f \n",inode,dt)   
    if ( inode==0)
    {
       // read in various data files into arrays
       for (i=1;i<nnode;i++)
       {
          for (is=0;is<ns_each;is++)
          {
             if ((sz*4)!=sreed("in",dobs,sz*4))
                Errmsg2("Error read in dat file of size %d \n",sz*4);
             MPI_Send(dobs,sz,MPI_FLOAT,i,1,MPI_COMM_WORLD);
          }
          //VerbMsg2("after send in node %d is %d \n",inode,i)   
       }
    }
    else
    {
       for (is=0;is<ns_each;is++)
          MPI_Recv(&dobs[is*sz],sz,MPI_FLOAT,0,1,MPI_COMM_WORLD, &mpistat);
    }
    
    //VerbMsg2("after dobs in node %d is %f \n",inode,dt)   
    MPI_Barrier(MPI_COMM_WORLD);
    //VerbMsg2("before src in node %d is %f \n",inode,dt)   
    
    if ( inode==0)
    {
       // read in various data files into arrays
       for (i=1;i<nnode;i++)
       {
          for (is=0;is<ns_each;is++)
          {
             if ((sz*4)!=sreed("src",src,sz*4))
                Errmsg2("Error read in src file of size %d \n",sz*4);
             MPI_Send(src,sz,MPI_FLOAT,i,1,MPI_COMM_WORLD);
          }
       }
    }
    else
    {
       for (is=0;is<ns_each;is++)
          MPI_Recv(&src[is*sz],sz,MPI_FLOAT,0,1,MPI_COMM_WORLD, &mpistat);
    }
    
    MPI_Barrier(MPI_COMM_WORLD);
    sz=nx*nz*3;
     // read in vel and distribute to all slave nodes
    if (inode==0)
    {
       if ((sz*4)!=sreed("mod",mod,sz*4))
          Errmsg2("Error read in mod file of size %d \n",sz*4);
       
       for (i=1;i<nnode;i++)
       {
          MPI_Send(mod,sz,MPI_FLOAT,i,1,MPI_COMM_WORLD);
       }
       fprintf(stderr,"getting mod data done\n");
    }
    else
    {
       MPI_Recv(mod,sz,MPI_FLOAT,0,1,MPI_COMM_WORLD, &mpistat);
    }
    vmax1=0;
    for (i=0;i<nx*nz;i++)
       if (mod[i]*sqrt(1+mod[i+nx*nz])>vmax1)
          vmax1=mod[i]*sqrt(mod[i+nx*nz]);
    if (vmax1*dt/dx>0.86)
       seperr("Error! Vmax exceed stability condition vmax1*dt/dx<=0.86, reduce vmax1(horizontal velocity)!\n");
    for (i=0;i<nx*nz;i++)
       if (mod[i+nx*nz]<mod[i+2*nx*nz])
          seperr("Error! epsilon < delta at certain locations, stability criterion violated!\n");
    MPI_Barrier(MPI_COMM_WORLD);
    // sdep is the depth of source from surface
    // read in sdep and distribute to all slave nodes
    // sdep exclude boundary region, dimension is (nx-2*nxtape)*(ny-2*nytape)*nshot
    
    VerbMsg("start reading sdep\n")
    sz=(nx-2*nxtape)*ns_each;
    float sdepmin,sdepmax;
    float isdepmin,isdepmax;
    sdepmin=1000;
    sdepmax=-20;
    if (inode==0)
    {
       if (0!=getch("sdep","s",file))
       {
          VerbMsg("sdep file found\n")
          for (i=1;i<nnode;i++)
          {
             if ((sz*4)!=sreed("sdep",sdep,sz*4))
                seperr("Error read in sdep file\n");
             MPI_Send(sdep,sz,MPI_FLOAT,i,1,MPI_COMM_WORLD);
             for (is=0;is<sz;is++)
             {
                if (sdep[is]<sdepmin)
                   sdepmin=sdep[is];
                if (sdep[is]>sdepmax)
                   sdepmax=sdep[is];
             }
             isdepmin=sdepmin/dz+nztape;    
             isdepmax=sdepmax/dz+nztape;    
          }
       }
       else
       {
          VerbMsg("sdep file not found, use default value\n")
          for (i=0;i<sz;i++)
             sdep[i]=2*dz;
          for (i=1;i<nnode;i++)
          {
             MPI_Send(sdep,sz,MPI_FLOAT,i,1,MPI_COMM_WORLD);
          }
          isdepmin=2+nztape;    
          isdepmax=2+nztape;    
       }
    }
    else
    {
       MPI_Recv(sdep,sz,MPI_FLOAT,0,1,MPI_COMM_WORLD, &mpistat);
    }
       MPI_Bcast(&isdepmin, 1, MPI_INT, 0, MPI_COMM_WORLD);
       MPI_Bcast(&isdepmax, 1, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Barrier(MPI_COMM_WORLD);
    // rdep is the depth of receiver from surface
    // read in rdep and distribute to all slave nodes
    // rdep exclude boundary region, dimension is (nx-2*nxtape)*(ny-2*nytape)*nshot
    VerbMsg("start reading rdep\n")
    if (inode==0)
    {
       if (0!=getch("rdep","s",file))
       {
          VerbMsg("rdep file found\n")
          for (i=1;i<nnode;i++)
          {
             if ((sz*4)!=sreed("rdep",rdep,sz*4))
                seperr("Error read in rdep file\n");
             MPI_Send(rdep,sz,MPI_FLOAT,i,1,MPI_COMM_WORLD);
          }
       }
       else
       {
          VerbMsg("rdep file not found, use default value\n")
          for (i=0;i<sz;i++)
             rdep[i]=2*dz;
          for (i=1;i<nnode;i++)
          {
             MPI_Send(rdep,sz,MPI_FLOAT,i,1,MPI_COMM_WORLD);
          }
       }
    }
    else
    {
       MPI_Recv(rdep,sz,MPI_FLOAT,0,1,MPI_COMM_WORLD, &mpistat);
    }
    MPI_Barrier(MPI_COMM_WORLD);

    // dwht is used to keep part of the data used for inversion, value range from 0~1
    // read in dwht and distribute to all slave nodes
    // dwht exclude boundary region, dimension is (nx-2*nxtape)*(ny-2*nytape)*nt*nshot
    sz=(nx-2*nxtape)*nt;
    if (inode==0)
    {
       VerbMsg("start initializing dwht\n")
       if (0!=getch("dwht","s",file))
       {
          VerbMsg("start reading dwht from file\n")
          for (i=1;i<nnode;i++)
          {
             for (is=0;is<ns_each;is++)
             {
                if ((sz*4)!=sreed("dwht",dwht,sz*4))
                   seperr("Error read in dwht file\n");
                MPI_Send(dwht,sz,MPI_FLOAT,i,1,MPI_COMM_WORLD);
             }
          }
       }
       else
       {
          VerbMsg("dwht file not found, use all data\n")
          for (i=0;i<sz;i++)
             dwht[i]=1;
          for (i=1;i<nnode;i++)
          {
             for (is=0;is<ns_each;is++)
                MPI_Send(dwht,sz,MPI_FLOAT,i,1,MPI_COMM_WORLD);
          }
       }
       fprintf(stderr,"getting dwht data done\n");
    }
    else
    {
       for (is=0;is<ns_each;is++)
          MPI_Recv(&dwht[is*sz],sz,MPI_FLOAT,0,1,MPI_COMM_WORLD, &mpistat);
    }
    
    MPI_Barrier(MPI_COMM_WORLD);
   
    
    // Initialize wave propagation 
    VerbMsg("start initialize XC2dMPISolver_init\n")
    //mmin=vmin;
    //mmax=vmax;
    mmin=(dt*vmin/dx)*(dt*vmin/dx);
    mmax=(dt*vmax/dx)*(dt*vmax/dx);
    VerbMsg3("mmin, mmax in node %d is %f, %f \n",inode,mmin,mmax)   
    stat=XC2dMPISolver_init( nt,nx,nz,ns_each,  \
                             ot,ox,oz,          \
                             dt,dx,dz,          \
                             nxtape,nztape, \
                             sdep, rdep, jtmv, mmin, mmax, needprecond, \
                             needspline, dzspline, dxspline, \
                             inode, nnode, &memcnt, \
                             sigma, alpha_mean, alpha_sigma, alpha_maxV, j_rndbnd, rndbnd_type, freesurf, \
                             objtype, paramtype, thresd  );

    if (stat==1)
       seperr("Error in XC2dMPISolver_init,program terminated!\n");

    fprintf(stderr,"total memory usage of node %d is %e GB\n",inode, (((double)memcnt)/1000000000.0));
    MPI_Barrier(MPI_COMM_WORLD); 

    sz=nx*nz;
    for (i=0;i<sz;i++)
       mod[i]=((dt*mod[i])/dx)*((dt*mod[i])/dx);  
    for (i=sz;i<2*sz;i++)
       mod[i]=(1+2*mod[i])*mod[i-sz];  
    for (i=2*sz;i<3*sz;i++)
       mod[i]=sqrt(1+2*mod[i])*mod[i-2*sz];  

    ///////////////////////////////////////////////////////////////
    // setup rdfulpath with suffix(index of the node) for each node   
    idx1=strlen(rdfulpath);
    itoa(inode,tmppath);
    idx2=strlen(tmppath);
    for (i1=0;i1<idx2;i1++)
        rdfulpath[idx1+i1]=tmppath[i1];
    rdfulpath[idx1+idx2]='\0';
    idx1=strlen(gradfulpath);
    for (i1=0;i1<idx2;i1++)
        gradfulpath[idx1+i1]=tmppath[i1];
    gradfulpath[idx1+idx2]='\0';
    fprintf(stderr,"rdfulpath=%s , gradfulpath=%s in inode %d\n",rdfulpath,gradfulpath,inode);
    ///////////////////////////////////////////////////////////////
    VerbMsg("start XC2dMPISolver_op\n")
    stat=XC2dMPISolver_op(mod, dobs, dwht, src, niter, resd, rdfulpath, gradfulpath, rcdmv, mvpath, isdepmin, isdepmax,vupd);
    //stat=XC2dMPISolver_op(vel, dobs, dwht, src, niter, resd, vupdate, rdful, rdful2, jrdful, jnoderdful);

    sz=nx*nz;
    for (i=2*sz;i<3*sz;i++)
       mod[i]=0.5*((mod[i]/mod[i-2*sz])*(mod[i]/mod[i-2*sz])-1);  
    for (i=sz;i<2*sz;i++)
       mod[i]=0.5*((mod[i]/mod[i-sz])-1);  
    for (i=0;i<sz;i++)
       mod[i]=sqrt(mod[i])*dx/dt;  

    MPI_Barrier(MPI_COMM_WORLD); 
    //output resd
    if (inode==0)
    {
       ndim=1;
       if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
          seperr("unable to write outfile!\n");
       outfile.o[0]=0;
       outfile.d[0]=1;
       outfile.n[0]=niter;
       sep3d_set_sep3d(&outfile);
       if(0!=sep3dc_write_description("resd",&outfile))
          seperr("unable to output parameters for resd\n");

       if( (niter*4)!=srite("resd",resd,4*niter) )
          seperr("trouble writing out resd\n");

       //output updated velocity
       ndim=3;
       if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
          seperr("unable to write outfile!\n");
       outfile.o[0]=oz;
       outfile.d[0]=dz;
       outfile.n[0]=nz;
       outfile.o[1]=ox;
       outfile.d[1]=dx;
       outfile.n[1]=nx;
       outfile.o[2]=0;
       outfile.d[2]=1;
       outfile.n[2]=3;
       sep3d_set_sep3d(&outfile);
       if(0!=sep3dc_write_description("modout",&outfile))
          seperr("unable to output parameters for modout\n");

       if( (3*nz*nx*4)!=srite("modout",mod,4*3*nz*nx) )
          seperr("trouble writing out modout\n");
    }
    MPI_Finalize(); 
    return 0;
}
