// dimensional information ( t,x,y,z, note that x,y,z info are after tapering/padding)
int XC2dWI_whtdat(float *din, float *dout, float *dwht, int n);
int XC2dWI_caldirecm(double *grad1in, double *grad2in, double *direcmin, double *direcmout, int sz );
int XC2dWI_caldirecmwithprecond(double *grad1in, double *grad2in, double *precond2in, double *denomin, double *denomout, double *direcmin, double *direcmout, int sz );
int XC2dWI_padgrad(double *gradin, double *gradout, int nx, int nz, int nxtape, int nztape );
int XC2dWI_updatev(float *v, double *dv, float alpha, float *newv, int n, float vmin, float vmax);
int XC2dWI_rndbndv(float *vel, int nx, int ny, int nz, int nxtape, int nytape, int nztape, float sigma, float alpha_mean, float alpha_sigma, float  alpha_maxV, int j_rndbnd, float minV, float maxV);
// cubic grains, minV is changing as a function of distance from inner region
int XC2dWI_rndbndv1(float *vel, int nx, int nz, int nxtape, int nztape, float sigma, float alpha_mean, float alpha_sigma, float  alpha_maxV, int j_rndbnd, float minV, float maxV);
// random shaped grains, minV is changing as a function of distance from inner region
int XC2dWI_rndbndv2(float *vel, int nx, int nz, int nxtape, int nztape, float sigma, float alpha_mean, float alpha_sigma, float  alpha_maxV, int j_rndbnd, float minV, float maxV);
int XC2dWI_m2v(float *m, float *v, int nm, int nv );
// forward spline interpolation with input/output being double,  
int XC2dWI_spline_forward(double *mod, double *dat, int n1, int n2, int n3, int idim, float dmod, int ndat, float ddat);

// adjoint spline interpolation with input/output being float,  
int XC2dWI_spline_fadj(float *mod, float *dat, int n1, int n2, int n3, int idim, float dmod, int ndat, float ddat);

// adjoint spline interpolation with input/output being double,  
int XC2dWI_spline_adj(double *mod, double *dat, int n1, int n2, int n3, int idim, float dmod, int ndat, float ddat);
//int XC3dWI_m2v_interp(float *m, float *v, int ndim, int* nm, float* dm, float *om, int* nv, float *dv, float *ov);
#include "XC2dWImisc/XC2dWIdproc.c"
#include "XC2dWImisc/XC2dWIupdate.c"
