
// dimensional information ( t,x,z, note that x,z info are after tapering/padding)
int   XC2dWaveprop_nt,XC2dWaveprop_nx,XC2dWaveprop_nz;
int   XC2dWaveprop_nxtape,XC2dWaveprop_nztape;
float *XC2dWaveprop_veldtinvdx2;
float *XC2dWaveprop_wavet1;
float *XC2dWaveprop_wavet2;
float *XC2dWaveprop_wavet3;
float *XC2dWaveprop_wavet4;
float *XC2dWaveprop_wavet5;
float *XC2dWaveprop_wavet6;
float *XC2dWaveprop_wavet11;
float *XC2dWaveprop_wavet12;
float *XC2dWaveprop_wavet13;
float *XC2dWaveprop_wvmv;
fftwf_plan XC2dWaveprop_srcftzfwd_plan, XC2dWaveprop_srcftzbkwd_plan;
fftwf_plan XC2dWaveprop_rcvftzfwd_plan, XC2dWaveprop_rcvftzbkwd_plan;
fftwf_complex *XC2dWaveprop_rcvftzin, *XC2dWaveprop_rcvftzout;
fftwf_complex *XC2dWaveprop_srcftzin, *XC2dWaveprop_srcftzout;
fftwf_plan XC2dWaveprop_srcftxfwd_plan, XC2dWaveprop_srcftxbkwd_plan;
fftwf_plan XC2dWaveprop_rcvftxfwd_plan, XC2dWaveprop_rcvftxbkwd_plan;
fftwf_complex *XC2dWaveprop_rcvftxin, *XC2dWaveprop_rcvftxout;
fftwf_complex *XC2dWaveprop_srcftxin, *XC2dWaveprop_srcftxout;
    // needwvmvin equals 1 means the waveprop operator is for forwarding modeling with recording wave movie, then recorded data/wvmv/isdep/irdep is with tapering zone
    // needwvmvin equals 2 means the waveprop operator is for waveform inversion, then recorded data/wvmv/isdep/irdep is without tapering zone
int  XC2dWaveprop_needwvmv,XC2dWaveprop_jtmv;
int  XC2dWaveprop_needdat;
int  XC2dWaveprop_freesurf;

#define Wpzxlocnopad(iz,ix) ((iz)+(ix)*(XC2dWaveprop_nz-2*XC2dWaveprop_nztape))
#define Wptxlocnopad(it,ix) ((it)+(ix)*XC2dWaveprop_nt)
#define Wpzxloc(iz,ix) ((iz)+(ix)*XC2dWaveprop_nz)
#define Wptxloc(it,ix) ((it)+(ix)*XC2dWaveprop_nt)
#define WpErrmsg(str)  {fprintf(stderr,(str));return 1;}
#define max(x,y) (((x)>(y))?(x):(y))
#define min(x,y) (((x)<(y))?(x):(y))
//#define VerbMsg(str) fprintf(stderr,str);
//#define WpVerbMsg(str) fprintf(stderr,str);
#define WpVerbMsg(str) ;
#define VerbMsg(str) fprintf(stderr,str);
//#define VerbMsg1(str,str1) fprintf(stderr,str,str1);
#define VerbMsg2(str,str1,str2) fprintf(stderr,str,str1,str2);
#define VerbMsg3(str,str1,str2,str3) fprintf(stderr,str,str1,str2,str3);
//#define VerbMsg4(str,str1,str2,str3,str4) fprintf(stderr,str,str1,str2,str3,str4);
//#define VerbMsg(str) ;
//#define VerbMsg2(str,str1,str2) ;
#define VerbMsg1(str,str1) ;

#include "2dstencil.h"

int XC2dWaveprop_Init(int ntin,  int nxin,  int nzin, \
                      int nxtapein, int nztapein,  \
                      int needwvmvin, int jtmvin, int freesurf, long *memcnt);
//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC2dWaveprop_op(int tsign, int *isdep, int *irdep, float *src, float *veldtinvdx2, int izmax_inc, float *data, float *wvmv );
int XC2dWaveprop_op2(int tsign, int *isdep, int *irdep, float *src, float *dxinvvelinvdt2, int izmax_inc, float *data, float *wvmv );
int XC2dWaveprop_setrcddat(int needdat);
int XC2dWaveprop_setwvmv(int needwvmvin);
int XC2dWaveprop_inject(int it, int *isdep, float *src);
int XC2dWaveprop_injectnopad(int it, int *isdep, float *src, float *wvt);
int XC2dWaveprop_injectderivnopad(int it, int *isdep, float *src, float *wvt);
int XC2dWaveprop_rcd(int it, int *irdep, float *data);
int XC2dWaveprop_rcdnopad(int it, int *irdep, float *data, float *wvt);
int XC2dWaveprop_rcdmv(int it, float *wvmv);
int XC2dWaveprop_rcdmvnopad(int it, float *wvmv, float *wvt);
int XC2dWaveprop_calgrad(float *srcwvt3, float *rcvwvt3, float dt, double *grad, double *precond, int needprecond );
int XC2dWaveprop_op2_rndbnd_withimag(int *isdep, int *irdep, float *src, float *dxinvvelinvdt2, int izmax_inc, float *data, double *grad, double *precond, int needprecond, float dt, int inode, int rcdmv, char* mvpath  );
int XC2dWaveprop_initfft ( int n, int sign, fftwf_complex *fin, fftwf_complex *fout, fftwf_plan *planfwd, fftwf_plan *planbkwd);
int XC2dWaveprop_calgrad_updown(float *srcwvt3, float *rcvwvt3, double *graddif, double *precond, int needprecond );
int XC2dWaveprop_calgrad_upup(float *srcwvt3, float *rcvwvt3, double *graddif, double *precond, int needprecond );
int XC2dWaveprop_calgrad_leftright(float *srcwvt3, float *rcvwvt3, double *graddif, double *precond, int needprecond );
int XC2dWaveprop_calgrad_leftleft(float *srcwvt3, float *rcvwvt3, double *graddif, double *precond, int needprecond );
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_Init(int ntin,  int nxin, int nzin, \
                      int nxtapein, int nztapein,  \
                      int needwvmvin, int jtmvin, int freesurf, long *memcnt )
{
   int sizet;
   XC2dWaveprop_nt=ntin;
   XC2dWaveprop_nx=nxin;
   XC2dWaveprop_nz=nzin;
   XC2dWaveprop_nxtape=nxtapein;
   XC2dWaveprop_nztape=nztapein;
   XC2dWaveprop_needdat=1;
   XC2dWaveprop_needwvmv=needwvmvin;
   XC2dWaveprop_jtmv=jtmvin;
   XC2dWaveprop_freesurf=freesurf;
 
   //VerbMsg1("needwvmv in Waveprop is %d\n",needwvmvin) 
   // determine if padded reigon is reasonable
   if (nxin<=2*nxtapein)
      WpErrmsg("Error, nx less or equal than twice of padded x reigon\n")
   if (nzin<=2*nztapein)
      WpErrmsg("Error, nz less or equal than twice of padded z reigon\n")


   sizet=nxin*nzin;
   XC2dWaveprop_wavet1=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_wavet2=(float*)malloc(sizet*sizeof(float));
   //XC2dWaveprop_wavet3=(float*)malloc(sizet*sizeof(float));
   //XC2dWaveprop_wavet4=(float*)malloc(sizet*sizeof(float));
   //XC2dWaveprop_wavet5=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_wavet6=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_wavet11=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_wavet12=(float*)malloc(sizet*sizeof(float));
   //XC2dWaveprop_wavet13=(float*)malloc(sizet*sizeof(float));
   *memcnt+=sizet*sizeof(float)*5;

  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 wavefield snapshot size=%d \n",sizet) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nx=%d \n",nxin) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nz=%d \n",nzin) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nxtape=%d \n",nxtapein) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nztape=%d \n",nztapein) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nt=%d \n",ntin) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 jt=%d \n",jtmvin) 
   //if (XC2dWaveprop_needwvmv>0)
   //   XC2dWaveprop_wvmv=(float*)malloc(sizet*sizeof(float)*(ntin/jtmvin));
  /* 
  XC2dWaveprop_rcvftzin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);
  XC2dWaveprop_rcvftzout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);
  XC2dWaveprop_srcftzin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);
  XC2dWaveprop_srcftzout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);

  XC2dWaveprop_rcvftxin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  XC2dWaveprop_rcvftxout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  XC2dWaveprop_srcftxin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  XC2dWaveprop_srcftxout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  int zsign=1;
  int xsign=1;
  int stat;

  stat=XC2dWaveprop_initfft ( nzin, zsign, XC2dWaveprop_srcftzin, XC2dWaveprop_srcftzout, &XC2dWaveprop_srcftzfwd_plan, &XC2dWaveprop_srcftzbkwd_plan);
  if (stat==1) 
      WpErrmsg("Error in XC2dWaveprop_initfft, program teminated!\n");

  stat=XC2dWaveprop_initfft ( nzin, zsign, XC2dWaveprop_rcvftzin, XC2dWaveprop_rcvftzout, &XC2dWaveprop_rcvftzfwd_plan, &XC2dWaveprop_rcvftzbkwd_plan);
  if (stat==1) 
      WpErrmsg("Error in XC2dWaveprop_initfft, program teminated!\n");

  stat=XC2dWaveprop_initfft ( nxin, xsign, XC2dWaveprop_srcftxin, XC2dWaveprop_srcftxout, &XC2dWaveprop_srcftxfwd_plan, &XC2dWaveprop_srcftxbkwd_plan);
  if (stat==1) 
      WpErrmsg("Error in XC2dWaveprop_initfft, program teminated!\n");

  stat=XC2dWaveprop_initfft ( nxin, xsign, XC2dWaveprop_rcvftxin, XC2dWaveprop_rcvftxout, &XC2dWaveprop_rcvftxfwd_plan, &XC2dWaveprop_rcvftxbkwd_plan);
  if (stat==1) 
      WpErrmsg("Error in XC2dWaveprop_initfft, program teminated!\n");
  
  if (XC2dWaveprop_srcftin==NULL)
  {
     fprintf (stderr,"allocation of srcftin failed!\n ");
     return 1;
  }
  if (XC2dWaveprop_srcftout==NULL)
  {
     fprintf (stderr,"allocation of srcftout failed!\n ");
     return 1;
  }
  if (XC2dWaveprop_rcvftin==NULL)
  {
     fprintf (stderr,"allocation of rcvftin failed!\n ");
     return 1;
  }
  if (XC2dWaveprop_rcvftout==NULL)
  {
     fprintf (stderr,"allocation of rcvftout failed!\n ");
     return 1;
  }*/
   return 0;
}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC2dWaveprop_op(int tsign, int *isdep, int *irdep, float *src, float *veldtinvdx2, int izmax_inc, float *data, float *wvmv )
{
  int ix,iz,it,jt;
  int nx,nz,nt;
  int stat;
  float *wvtmp;
  int izmin,izmax,tmpit;
  time_t time1,time2;
  nt=XC2dWaveprop_nt;
  jt=XC2dWaveprop_jtmv;
  nx=XC2dWaveprop_nx;
  nz=XC2dWaveprop_nz;
  // zero out all the wavefield
  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
        XC2dWaveprop_wavet1[ Wpzxloc(iz,ix) ]=0.;
  
  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
        XC2dWaveprop_wavet2[ Wpzxloc(iz,ix) ]=0.;

  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
        XC2dWaveprop_wavet6[ Wpzxloc(iz,ix) ]=0.;


  //VerbMsg("start propagation in Waveprop_op with \n") 
  // start propagation
  time1=time(NULL);
  // determine z range for wave propagation    
  izmin=nz;
  izmax=0; 
  for(ix=0;ix<nx;ix++)
  {
     iz=isdep[ix];
     if (iz>izmax)
        izmax=iz;
     if (iz<izmin)
        izmin=iz;
  }

  if (XC2dWaveprop_freesurf>0)
     izmin=XC2dWaveprop_nztape;

  for (it=0;it<nt;it++)
  {   
     // inject source  
     //VerbMsg("start inject source Waveprop_op\n") 
     if (tsign>0)  
        stat=XC2dWaveprop_inject(it,isdep,src);
     else
        stat=XC2dWaveprop_inject(nt-it-1,isdep,src);
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_inject, program teminated!\n");

     // record data  
     if (XC2dWaveprop_needdat>0)
     {
        //VerbMsg("start record data in Waveprop_op\n") 
        if (tsign>0)  
           stat=XC2dWaveprop_rcd(it,irdep,data);
        else  
           stat=XC2dWaveprop_rcd(nt-it-1,irdep,data);
        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcd, program teminated!\n");
     }

     // record wave movie if necessary  
     if ( (XC2dWaveprop_needwvmv>0) && (it%jt==0) && (tsign>0) ) 
     { 
           stat=XC2dWaveprop_rcdmv(it,wvmv);
        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcdmv, program teminated!\n");
     }
     if ( (XC2dWaveprop_needwvmv>0) && ((nt-1-it)%jt==0) && (tsign<0) ) 
     {
        tmpit=nt-1-it;  
           stat=XC2dWaveprop_rcdmv(tmpit,wvmv);
        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcdmv, program teminated!\n");
     }
     /*
     // determine z range for wave propagation    
     izmin=nz;
     izmax=0; 

     for(iy=1;iy<ny;iy++)
        for(ix=1;ix<nx;ix++)
        {
           iz=isdep[Wpxloc(ix)];
           if (iz>izmax)
              izmax=iz;
           if (iz<izmin)
              izmin=iz;
        }
     */
     if (XC2dWaveprop_freesurf==0)
        izmin=izmin-izmax_inc;
     izmax=izmax+izmax_inc;
   
     // 1 step propagation
     //VerbMsg("start 1 step propagation in Waveprop_op \n") 
     stat=XC2dWaveprop_1step4t10spacewithbnd1opt(veldtinvdx2, XC2dWaveprop_wavet1, XC2dWaveprop_wavet2, XC2dWaveprop_wavet6, izmin,izmax);
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_1step2t2space, program teminated!\n");

     // swap wavefield slices
     wvtmp=XC2dWaveprop_wavet1;
     XC2dWaveprop_wavet1=XC2dWaveprop_wavet2;
     XC2dWaveprop_wavet2=wvtmp;
     //XC2dWaveprop_wavet2=XC2dWaveprop_wavet3;
     //XC2dWaveprop_wavet3=wvtmp;
     
     if ( (it%(nt/10))==0 ) 
     {
        time2=time(NULL);
        //VerbMsg1("Finished %d percent of one shot modeling ",(it*100/nt))
        //VerbMsg1("spent %ld seconds\n",(time2-time1))
        time1=time(NULL);
     }
  }

  return 0;
}

//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC2dWaveprop_op2(int tsign, int *isdep, int *irdep, float *src, float *dxinvvelinvdt2, int izmax_inc, float *data, float *wvmv )
{
  int ix,iz,it,jt;
  int nx,nz,nt;
  int nxtape;
  int stat;
  float *wvtmp;
  int izmin,izmax;
  int ixmin,ixmax;
  int flag;
  time_t time1,time2;
  float *wvt1, *wvt2, *wvt3, *wvt6;
  nt=XC2dWaveprop_nt;
  jt=XC2dWaveprop_jtmv;
  nx=XC2dWaveprop_nx;
  nxtape=XC2dWaveprop_nxtape;
  nz=XC2dWaveprop_nz;
  wvt1=XC2dWaveprop_wavet1;
  wvt2=XC2dWaveprop_wavet2;
  wvt3=XC2dWaveprop_wavet3;
  wvt6=XC2dWaveprop_wavet6;
  // zero out all the wavefield
  WpVerbMsg("start zero XC2dWaveprop_wavet1\n") 
  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
        wvt1[ Wpzxloc(iz,ix) ]=0.;
  
  WpVerbMsg("start zero XC2dWaveprop_wavet2\n") 
  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
        wvt2[ Wpzxloc(iz,ix) ]=0.;
  
  WpVerbMsg("start zero XC2dWaveprop_wavet3\n") 
  //for (iy=0;iy<ny;iy++)
  //   for (ix=0;ix<nx;ix++)
  //      for (iz=0;iz<nz;iz++)
  //         wvt3[ Wpzxloc(iz,ix) ]=0.;
  
     for (ix=0;ix<nx;ix++)
        for (iz=0;iz<nz;iz++)
           wvt6[ Wpzxloc(iz,ix) ]=0.;
  
  WpVerbMsg("start propagation in Waveprop_op2 with \n") 
  // start propagation
  time1=time(NULL);

  // determine ixmin
  flag=0;
  for (ix=0;ix<(nx-2*nxtape);ix++)
  {
     if (flag==0)
     {
        for (it=0;it<nt;it++)
           if ( src[Wptxlocnopad(it,ix)] != 0.)
           {
              ixmin=ix;
              flag=1;
              break;
           }
     }
  }
  //determine ixmax
  flag=0;
  for (ix=(nx-1-2*nxtape);ix>-1;ix--)
  {
     if (flag==0)
     {
        for (it=0;it<nt;it++)
           if ( src[Wptxlocnopad(it,ix)] != 0.)
           {
              ixmax=ix;
              flag=1;
              break;
           }
     }
  }

  // determine z range for wave propagation    
  izmin=nz;
  izmax=0; 

  for(ix=0;ix<nx-2*nxtape;ix++)
  {
     iz=isdep[ix];
     if (iz>izmax)
        izmax=iz;
     if (iz<izmin)
        izmin=iz;
  }

  if (XC2dWaveprop_freesurf>0)
     izmin=XC2dWaveprop_nztape;
  for (it=0;it<nt;it++)
  {   
     VerbMsg1("in Waveprop_op2, start time step %d\n",it) 
     // inject source  
     WpVerbMsg("start inject source Waveprop_op2\n") 
     if (tsign>0)  
        stat=XC2dWaveprop_injectnopad(it,isdep,src,wvt2);
     else  
        stat=XC2dWaveprop_injectnopad(nt-it-1,irdep,src,wvt2);
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_injectnopad, program teminated!\n");

     // record data  
     if (XC2dWaveprop_needdat>0)
     {
        WpVerbMsg("start record data in Waveprop_op2\n") 
        if (tsign>0)  
           stat=XC2dWaveprop_rcdnopad(it,irdep,data,wvt2);
        else  
           stat=XC2dWaveprop_rcdnopad(nt-it-1,irdep,data,wvt2);
        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcdnopad, program teminated!\n");
     }

     // record wave movie if necessary  
     if ( (XC2dWaveprop_needwvmv>0) && (it%jt==0) ) 
     { 
        WpVerbMsg("start record movie in Waveprop_op2\n") 
        if (tsign>0)  
           stat=XC2dWaveprop_rcdmvnopad(it,wvmv,wvt2);
        else
           stat=XC2dWaveprop_rcdmvnopad(((int)((nt-1)/jt))*jt-it,wvmv,wvt2);

        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcdmvnopad, program teminated!\n");
     }
     if (XC2dWaveprop_freesurf==0)
        izmin=izmin-izmax_inc;

     izmax=izmax+izmax_inc;
     ixmin=ixmin-izmax_inc;
     ixmax=ixmax+izmax_inc;

   
     //VerbMsg2("izmin=%d izmax=%d\n",izmin,izmax)
     //VerbMsg2("izmax_inc=%d nz=%d\n",izmax_inc,nz)
     //izmin=0;
     //izmax=nz;
     // 1 step propagation
     //VerbMsg2("start 1 step propagation in Waveprop_op2, with izmin=%d, izmax=%d \n",izmin,izmax) 
     stat=XC2dWaveprop_1step4t10spacewithbnd1optinvvelin(dxinvvelinvdt2, wvt1, wvt2, wvt6, izmin, izmax, ixmin, ixmax );
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_1step4t10spacewithbnd1optinline, program teminated!\n");

     // swap wavefield slices
     WpVerbMsg("start pointer shift in Waveprop_op2 \n") 
     wvtmp=wvt1;
     wvt1=wvt2; 
     wvt2=wvtmp;
  }

  return 0;
}

//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC2dWaveprop_op2_rndbnd_withimag(int *isdep, int *irdep, float *src, float *dxinvvelinvdt2, int izmax_inc, float *data, double *grad, double *precond, int needprecond, float dt, int inode, int rcdmv, char* mvpath  )
{
  int ix,iz,it,jt;
  int nx,nz,nt;
  int nxtape;
  int stat;
  float *wvtmp;
  int izmin,izmax;
  int ixmin,ixmax;
  int flag;
  time_t time1,time2;
  nt=XC2dWaveprop_nt;
  jt=XC2dWaveprop_jtmv;
  nx=XC2dWaveprop_nx;
  nxtape=XC2dWaveprop_nxtape;
  nz=XC2dWaveprop_nz;
  float *wvt1, *wvt2, *wvt3, *wvt4, *wvt5, *wvt6;
  wvt1=XC2dWaveprop_wavet1;
  wvt2=XC2dWaveprop_wavet2;
  wvt3=XC2dWaveprop_wavet3;
  wvt4=XC2dWaveprop_wavet4;
  wvt5=XC2dWaveprop_wavet5;
  wvt6=XC2dWaveprop_wavet6;
  float *wvt11, *wvt12, *wvt13;
  wvt11=XC2dWaveprop_wavet11;
  wvt12=XC2dWaveprop_wavet12;
  wvt13=XC2dWaveprop_wavet13;
  // zero out all the wavefield
  VerbMsg("start XC2dWaveprop_op2_rndbnd_imag\n") 
  WpVerbMsg("start zero XC2dWaveprop_wavet1\n") 
  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
     {
        wvt1[ Wpzxloc(iz,ix) ]=0.;
        wvt2[ Wpzxloc(iz,ix) ]=0.;
        wvt6[ Wpzxloc(iz,ix) ]=0.;
        wvt11[ Wpzxloc(iz,ix) ]=0.;
        wvt12[ Wpzxloc(iz,ix) ]=0.;
     } 
  int i;
  if (needprecond>1)
     fprintf(stderr,"Warning! needprecond>1 is not implemented in this version, using needprecond==1 instead!\n");
  WpVerbMsg("start propagation in Waveprop_op2_rndbnd_imag with \n") 
  // start propagation
  time1=time(NULL);
  
 // determine ixmin
  flag=0;
  for (ix=0;ix<(nx-2*nxtape);ix++)
  {
     if (flag==0)
     {
        for (it=0;it<nt;it++)
           if ( src[Wptxlocnopad(it,ix)] != 0.)
           {
              ixmin=ix;
              flag=1;
              break;
           }
     }
  }
  //determine ixmax
  flag=0;
  for (ix=(nx-1-2*nxtape);ix>-1;ix--)
  {
     if (flag==0)
     {
        for (it=0;it<nt;it++)
           if ( src[Wptxlocnopad(it,ix)] != 0.)
           {
              ixmax=ix;
              flag=1;
              break;
           }
     }
  }


  // determine z range for wave propagation    
  izmin=nz;
  izmax=0; 

  for(ix=0;ix<nx-2*nxtape;ix++)
  {
     iz=isdep[ix];
     if (iz>izmax)
        izmax=iz;
     if (iz<izmin)
        izmin=iz;
  }

  if (XC2dWaveprop_freesurf>0)
     izmin=XC2dWaveprop_nztape;
 
  for (it=0;it<nt;it++)
  {   
     VerbMsg1("in Waveprop_op2, start time step %d\n",it) 
     // inject source  
     WpVerbMsg("start inject source Waveprop_op2\n") 

     stat=XC2dWaveprop_injectnopad(it,isdep,src,wvt2);

     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_injectnopad, program teminated!\n");

     if (XC2dWaveprop_freesurf==0)
        izmin=izmin-izmax_inc;

     izmax=izmax+izmax_inc;
     ixmin=ixmin-izmax_inc;
     ixmax=ixmax+izmax_inc;

   
     // 1 step propagation
     stat=XC2dWaveprop_1step4t10spaceoptinvvelin(dxinvvelinvdt2, wvt1, wvt2, wvt1, wvt6, izmin, izmax, ixmin, ixmax );
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_1step4t10spacewithbnd1optinline, program teminated!\n");

     // swap wavefield slices
     WpVerbMsg("start pointer shift in Waveprop_op2 \n") 
     wvtmp=wvt1;
     wvt1=wvt2;
     wvt2=wvtmp;
  }


  wvtmp=wvt1;
  wvt1=wvt2;
  wvt2=wvtmp;
  for (it=nt-1;it>-1;it--)
  {   
     VerbMsg1("in Waveprop_op2_rndbnd_imag, start time step %d\n",it) 
     // inject source  
     WpVerbMsg("start inject source Waveprop_op2\n") 
     stat=XC2dWaveprop_injectderivnopad(it,irdep,data,wvt12);

     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_injectnopad, program teminated!\n");

     if (XC2dWaveprop_freesurf==0)
        izmin=izmin-izmax_inc;

     izmax=izmax+izmax_inc;
     ixmin=ixmin-izmax_inc;
     ixmax=ixmax+izmax_inc;

   
     // 1 step propagation
     stat=XC2dWaveprop_1step4t10spaceoptinvvelin(dxinvvelinvdt2, wvt1, wvt2, wvt1, wvt6, izmin, izmax, ixmin, ixmax );
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_1step4t10spaceoptinline, program teminated!\n");

     stat=XC2dWaveprop_1step4t10spaceoptinvvelin(dxinvvelinvdt2, wvt11, wvt12, wvt11, wvt6, izmin, izmax, ixmin, ixmax );
     //stat=XC2dWaveprop_1step4t10spacewithbnd1optinvvelin(dxinvvelinvdt2, wvt11, wvt12, wvt6, izmin, izmax, ixmin, ixmax, iymin, iymax );
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_1step4t10spacewithbnd1optinvvelin, program teminated!\n");
     //stat=XC2dWaveprop_1step4t10spaceoptinvvelin(dxinvvelinvdt2, wvt11, wvt12, wvt11, wvt6, izmin, izmax, ixmin, ixmax, iymin, iymax );
     // gradient calculation
     if ( (it>1) && (it<nt-2) && (it%jt==0) )
     {
         //if (isgradleftright==0)
         //{
         //   if (isgradupdown==0)
               XC2dWaveprop_calgrad( wvt1, wvt11, dt, grad, precond, needprecond );
         //   else if (isgradupdown==1)
         //      XC2dWaveprop_calgrad_updown( wvt1, wvt11, grad, precond, needprecond );
         //   else if (isgradupdown==-1)
         //      XC2dWaveprop_calgrad_upup( wvt1, wvt11, grad, precond, needprecond );
         //}
         //else if (isgradleftright==1 )
         //   XC2dWaveprop_calgrad_leftright( wvt1, wvt11, grad, precond, needprecond );
         //else if (isgradleftright==-1 )
         //   XC2dWaveprop_calgrad_leftleft( wvt1, wvt11, grad, precond, needprecond );
        if ((inode==1)&&(rcdmv==1))
        {
          if( (nx*nz*4)!=srite(mvpath,wvt1,4*nx*nz) )
             seperr("trouble writing out src mv\n");
          if( (nx*nz*4)!=srite(mvpath,wvt11,4*nx*nz) )
             seperr("trouble writing out rsd rcv mv\n");

        }
     } 
       
     //stat=XC2dWaveprop_1step4t10spaceoptinvvelin(dxinvvelinvdt2, wvt11, wvt12, wvt11, wvt6, izmin, izmax, ixmin, ixmax, iymin, iymax );
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_1step4t10spacewithbnd1optinline, program teminated!\n");
     // swap wavefield slices
     WpVerbMsg("start pointer shift in Waveprop_op2_rndbnd_imag \n") 
     wvtmp=wvt2; 
     wvt2=wvt1;
     wvt1=wvtmp;

     wvtmp=wvt11;
     wvt11=wvt12;
     wvt12=wvtmp;
  }

  return 0;
}


///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_setrcddat(int needdat)
{
   XC2dWaveprop_needdat=needdat;
   return 0;
}

int XC2dWaveprop_setwvmv(int needwvmvin)
{
   XC2dWaveprop_needwvmv=needwvmvin;
   return 0;
}
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_inject(int it, int *isdep, float *src)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   for (ix=0;ix<nx;ix++)
   {
      iz=isdep[ix ];
      XC2dWaveprop_wavet2[ Wpzxloc(iz,ix) ] +=src[ Wptxloc(it,ix) ];
      //XC2dWaveprop_wavet2[ Wpzxloc(iz,ix) ] +=0.01;
   }
   return 0;
}

int XC2dWaveprop_injectnopad(int it, int *isdep, float *src, float *wvt)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   for (ix=0;ix<nx-2*nxtape;ix++)
   {
      iz=isdep[ ix ];
      wvt[ Wpzxloc(iz,ix+nxtape) ] +=src[ Wptxlocnopad(it,ix) ];
   }
   return 0;
}

int XC2dWaveprop_injectderivnopad(int it, int *isdep, float *src, float *wvt)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   for (ix=0;ix<nx-2*nxtape;ix++)
   {
      iz=isdep[ ix ];
      if ( (it<(XC2dWaveprop_nt-2)) && (it>1) )
         wvt[ Wpzxloc(iz,ix+nxtape) ] += -1./12.*src[ Wptxlocnopad(it-2,ix) ] \
                                                    +4./3. *src[ Wptxlocnopad(it-1,ix) ] \
                                                    -2.5   *src[ Wptxlocnopad(it,ix) ]   \
                                                    +4./3. *src[ Wptxlocnopad(it+1,ix) ] \
                                                    -1./12.*src[ Wptxlocnopad(it+2,ix) ];
      else
         wvt[ Wpzxloc(iz,ix+nxtape) ] +=src[ Wptxlocnopad(it,ix) ];
   }
   return 0;
}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_rcd(int it, int *irdep, float *data)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   for (ix=0;ix<nx;ix++)
   {
      iz=irdep[ ix ];
      data[ Wptxloc(it,ix) ] = XC2dWaveprop_wavet2[ Wpzxloc(iz,ix) ];
   }
   return 0;
}

int XC2dWaveprop_rcdnopad(int it, int *irdep, float *data, float *wvt)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   for (ix=0;ix<nx-2*nxtape;ix++)
   {
      iz=irdep[ ix ];
      data[ Wptxlocnopad(it,ix) ] = wvt[ Wpzxloc(iz,ix+nxtape) ];
   }
   return 0;
}
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_rcdmv(int it, float *wvmv)
{
   int ix,iz;
   int jt;
   int nx,nz;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   jt=XC2dWaveprop_jtmv;
   int cnt=0;
   int cnt1=0;
   for (ix=0;ix<nx;ix++)
      for (iz=0;iz<nz;iz++)
      {
         wvmv[ Wpzxloc(iz,ix) + nx*nz*((int)(((it)/jt) )) ] = XC2dWaveprop_wavet2[ Wpzxloc(iz,ix) ];
      }//XC2dWaveprop_wvmv[ Wpzxloc(iz,ix) + nx*ny*nz*(it/jt) ] = XC2dWaveprop_wavet1[ Wpzxloc(iz,ix) ];
   return 0;
}

int XC2dWaveprop_rcdmvnopad(int it, float *wvmv, float *wvt)
{
   int ix,iz;
   int jt;
   int nx,nz;
   int nxtape,nztape;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
   jt=XC2dWaveprop_jtmv;
   for (ix=0;ix<nx-2*nxtape;ix++)
      for (iz=0;iz<nz-2*nztape;iz++)
         wvmv[ Wpzxlocnopad(iz,ix) + (nx-2*nxtape)*(nz-2*nztape)*(it/jt) ] = wvt[ Wpzxloc(iz+nztape,ix+nxtape) ];
   return 0;
}

int XC2dWaveprop_calgrad(float *srcwvt3, float *rcvwvt3, float dt, double *grad, double *precond, int needprecond )
{
   int ix,iz;
   int jt;
   int nx,nz;
   int nxtape,nztape;
   float temp1,maxval;
   //maxval=-1000l;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
   jt=XC2dWaveprop_jtmv;
   for (ix=nxtape;ix<nx-nxtape;ix++)
      for (iz=nztape;iz<nz-nztape;iz++)
      {
         grad[ Wpzxloc(iz,ix) ] += -rcvwvt3[ Wpzxloc(iz,ix) ] * srcwvt3[Wpzxloc(iz,ix)];

         if (needprecond==1)
            precond[ Wpzxloc(iz,ix) ]+=srcwvt3[Wpzxloc(iz,ix)] * srcwvt3[Wpzxloc(iz,ix)];
      }
   return 0;
}


int XC2dWaveprop_initfft ( int n, int sign, fftwf_complex *fin, fftwf_complex *fout, fftwf_plan *planfwd, fftwf_plan *planbkwd)
{
  
   fprintf(stderr,"Start XC2dWaveprop_initfft with n=%d\n ",n);
   //fin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*n);
   //fout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*n);

   if (sign==1)
   {
      *planfwd = fftwf_plan_dft_1d(n, fin, fout, FFTW_FORWARD, FFTW_MEASURE);
      *planbkwd = fftwf_plan_dft_1d(n, fout, fin, FFTW_BACKWARD, FFTW_MEASURE);
      return 0;
   }
   else if (sign==-1)
   {
      *planfwd = fftwf_plan_dft_1d(n, fin, fout, FFTW_BACKWARD, FFTW_MEASURE);
      *planbkwd = fftwf_plan_dft_1d(n, fout, fin, FFTW_FORWARD, FFTW_MEASURE);
      return 0;
   }
   else
   {
      fprintf(stderr,"Error! in XC2dWaveprop_initfft, sign must be either +1 or -1!\n ");
      return 1;
   }
   if (fin==NULL)
   {
      fprintf (stderr,"allocation of fin failed!\n ");
      return 1;
   }
   if (fout==NULL)
   {
      fprintf (stderr,"allocation of fout failed!\n ");
      return 1;
   }
}

int XC2dWaveprop_calgrad_updown(float *srcwvt3, float *rcvwvt3, double *graddif, double *precond, int needprecond )
{
   int ix,iz;
   int jt;
   int nx,nz;
   int nxtape,nztape;
   float temp1,maxval;
   //maxval=-1000l;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
   jt=XC2dWaveprop_jtmv;
   //fprintf(stderr,"#################start calgrad_updown, nz=%d\n",nz);
   if (XC2dWaveprop_rcvftzin==NULL)
   {
      fprintf (stderr,"allocation of rcvftzin failed!\n ");
      return 1;
   }
   for (ix=nxtape;ix<nx-nxtape;ix++)
   {  
         
      for (iz=0;iz<nz;iz++)
      {
         XC2dWaveprop_rcvftzin[iz][0] = rcvwvt3[ Wpzxloc(iz,ix) ];
         XC2dWaveprop_rcvftzin[iz][1] = 0;
         XC2dWaveprop_srcftzin[iz][0] = srcwvt3[ Wpzxloc(iz,ix) ];
         XC2dWaveprop_srcftzin[iz][1] = 0;
      } 

      fftwf_execute(XC2dWaveprop_srcftzfwd_plan);
      fftwf_execute(XC2dWaveprop_rcvftzfwd_plan);
          
      for (iz=0;iz<nz/2;iz++)
      {
         XC2dWaveprop_rcvftzout[iz][0] = 0;
         XC2dWaveprop_rcvftzout[iz][1] = 0;
         XC2dWaveprop_srcftzout[iz][0] = 0;
         XC2dWaveprop_srcftzout[iz][1] = 0;
      } 

      fftwf_execute(XC2dWaveprop_srcftzbkwd_plan);
      fftwf_execute(XC2dWaveprop_rcvftzbkwd_plan);
         
      for (iz=nztape;iz<nz-nztape;iz++)
      {
         graddif[ Wpzxloc(iz,ix) ] += - (( XC2dWaveprop_rcvftzin[iz][0] * XC2dWaveprop_srcftzin[iz][0] + \
                                              XC2dWaveprop_rcvftzin[iz][1] * XC2dWaveprop_srcftzin[iz][1] )*(1./(nz*nz))) ;
      } 
      if (needprecond!=0)
         fprintf(stderr,"Warning! needprecond!=0 not implemented in XC2dWaveprop_calgrad_updown!\n ");
   }
   return 0;
}

int XC2dWaveprop_calgrad_upup(float *srcwvt3, float *rcvwvt3, double *graddif, double *precond, int needprecond )
{
   int ix,iz;
   int jt;
   int nx,nz;
   int nxtape,nztape;
   float temp1,maxval;
   //maxval=-1000l;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
   jt=XC2dWaveprop_jtmv;
   //fprintf(stderr,"#################start calgrad_updown, nz=%d\n",nz);
   if (XC2dWaveprop_rcvftzin==NULL)
   {
      fprintf (stderr,"allocation of rcvftzin failed!\n ");
      return 1;
   }
   for (ix=nxtape;ix<nx-nxtape;ix++)
   {  
         
      for (iz=0;iz<nz;iz++)
      {
         XC2dWaveprop_rcvftzin[iz][0] = rcvwvt3[ Wpzxloc(iz,ix) ];
         XC2dWaveprop_rcvftzin[iz][1] = 0;
         XC2dWaveprop_srcftzin[iz][0] = srcwvt3[ Wpzxloc(iz,ix) ];
         XC2dWaveprop_srcftzin[iz][1] = 0;
      } 

      fftwf_execute(XC2dWaveprop_srcftzfwd_plan);
      fftwf_execute(XC2dWaveprop_rcvftzfwd_plan);
         
      //for (iz=nz/2;iz<nz;iz++)
      for (iz=nz/2;iz<nz;iz++)
      {
         XC2dWaveprop_rcvftzout[iz][0] = 0;
         XC2dWaveprop_rcvftzout[iz][1] = 0;
         XC2dWaveprop_srcftzout[iz][0] = 0;
         XC2dWaveprop_srcftzout[iz][1] = 0;
      } 

      fftwf_execute(XC2dWaveprop_srcftzbkwd_plan);
      fftwf_execute(XC2dWaveprop_rcvftzbkwd_plan);
       
      for (iz=nztape;iz<nz-nztape;iz++)
      {
         graddif[ Wpzxloc(iz,ix) ] += - ( ( XC2dWaveprop_rcvftzin[iz][0] * XC2dWaveprop_srcftzin[iz][0] - \
                                                XC2dWaveprop_rcvftzin[iz][1] * XC2dWaveprop_srcftzin[iz][1] )*(1./(nz*nz))) ;
      } 
      if (needprecond!=0)
         fprintf(stderr,"Warning! needprecond!=0 not implemented in XC2dWaveprop_calgrad_upup!\n ");
   }
   //fprintf(stderr,"#################done calgrad_updown\n");
   return 0;
}

int XC2dWaveprop_calgrad_leftright(float *srcwvt3, float *rcvwvt3, double *graddif, double *precond, int needprecond )
{
   int ix,iz;   
   int jt;
   int nx,nz;
   int nxtape,nztape;
   float temp1,maxval;
   //maxval=-1000l;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
   jt=XC2dWaveprop_jtmv;
   //fprintf(stderr,"#################start calgrad_updown, nz=%d\n",nz);
   if (XC2dWaveprop_rcvftxin==NULL)
   {
      fprintf (stderr,"allocation of rcvftxin failed!\n ");
      return 1;
   }
   for (iz=nztape;iz<nz-nztape;iz++)
   {  
         
      for (ix=0;ix<nx;ix++)
      {
         XC2dWaveprop_rcvftxin[ix][0] = rcvwvt3[ Wpzxloc(iz,ix) ];
         XC2dWaveprop_rcvftxin[ix][1] = 0;
         XC2dWaveprop_srcftxin[ix][0] = srcwvt3[ Wpzxloc(iz,ix) ];
         XC2dWaveprop_srcftxin[ix][1] = 0;
      } 

      fftwf_execute(XC2dWaveprop_srcftxfwd_plan);
      fftwf_execute(XC2dWaveprop_rcvftxfwd_plan);
          
      for (ix=0;ix<nx/2;ix++)
      {
         XC2dWaveprop_rcvftxout[ix][0] = 0;
         XC2dWaveprop_rcvftxout[ix][1] = 0;
         XC2dWaveprop_srcftxout[ix][0] = 0;
         XC2dWaveprop_srcftxout[ix][1] = 0;
      } 

      fftwf_execute(XC2dWaveprop_srcftxbkwd_plan);
      fftwf_execute(XC2dWaveprop_rcvftxbkwd_plan);
         
      for (ix=nxtape;ix<nx-nxtape;ix++)
      {
         graddif[ Wpzxloc(iz,ix) ] += - ( ( XC2dWaveprop_rcvftxin[ix][0] * XC2dWaveprop_srcftxin[ix][0] + \
                                                 XC2dWaveprop_rcvftxin[ix][1] * XC2dWaveprop_srcftxin[ix][1] )*(1./(nx*nx)) ) ;
      } 
      if (needprecond!=0)
         fprintf(stderr,"Warning! needprecond!=0 not implemented in XC2dWaveprop_calgrad_updown!\n ");
   }
   //fprintf(stderr,"#################done calgrad_updown\n");
   return 0;
}

int XC2dWaveprop_calgrad_leftleft(float *srcwvt3, float *rcvwvt3, double *graddif, double *precond, int needprecond )
{
   int ix,iz;
   int jt;
   int nx,nz;
   int nxtape,nztape;
   float temp1,maxval;
   //maxval=-1000l;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
   jt=XC2dWaveprop_jtmv;
   //fprintf(stderr,"#################start calgrad_updown, nz=%d\n",nz);
   if (XC2dWaveprop_rcvftxin==NULL)
   {
      fprintf (stderr,"allocation of rcvftxin failed!\n ");
      return 1;
   }
   for (iz=nztape;iz<nz-nztape;iz++)
   {
      for (ix=0;ix<nx;ix++)
      {
         XC2dWaveprop_rcvftxin[ix][0] = rcvwvt3[ Wpzxloc(iz,ix) ];
         XC2dWaveprop_rcvftxin[ix][1] = 0;
         XC2dWaveprop_srcftxin[ix][0] = srcwvt3[ Wpzxloc(iz,ix) ];
         XC2dWaveprop_srcftxin[ix][1] = 0;
      } 

      fftwf_execute(XC2dWaveprop_srcftxfwd_plan);
      fftwf_execute(XC2dWaveprop_rcvftxfwd_plan);
          
      for (ix=nx/2;ix<nx;ix++)
      {
         XC2dWaveprop_rcvftxout[ix][0] = 0;
         XC2dWaveprop_rcvftxout[ix][1] = 0;
         XC2dWaveprop_srcftxout[ix][0] = 0;
         XC2dWaveprop_srcftxout[ix][1] = 0;
      } 

      fftwf_execute(XC2dWaveprop_srcftxbkwd_plan);
      fftwf_execute(XC2dWaveprop_rcvftxbkwd_plan);
         
      for (ix=nxtape;ix<nx-nxtape;ix++)
      {
         graddif[ Wpzxloc(iz,ix) ] += - ( ( XC2dWaveprop_rcvftxin[ix][0] * XC2dWaveprop_srcftxin[ix][0] - \
                                              XC2dWaveprop_rcvftxin[ix][1] * XC2dWaveprop_srcftxin[ix][1] )*(1./(nx*nx)) ) ;
      } 
      if (needprecond!=0)
         fprintf(stderr,"Warning! needprecond!=0 not implemented in XC2dWaveprop_calgrad_leftleft!\n ");
   }
   //fprintf(stderr,"#################done calgrad_updown\n");
   return 0;
}


