
// dimensional information ( t,x,z, note that x,z info are after tapering/padding)
int   XC2dWaveprop_nt,XC2dWaveprop_nx,XC2dWaveprop_nz;
float   XC2dWaveprop_dt,XC2dWaveprop_dx,XC2dWaveprop_dz;
int   XC2dWaveprop_nxtape,XC2dWaveprop_nztape;
float *XC2dWaveprop_veldtinvdx2;
float *XC2dWaveprop_wavep1;
float *XC2dWaveprop_wavep2;
float *XC2dWaveprop_wavep6;
float *XC2dWaveprop_wavep11;
float *XC2dWaveprop_wavep12;
float *XC2dWaveprop_waver1;
float *XC2dWaveprop_waver2;
float *XC2dWaveprop_waver6;
float *XC2dWaveprop_waver11;
float *XC2dWaveprop_waver12;
float *XC2dWaveprop_wvmv;
fftwf_plan XC2dWaveprop_srcftzfwd_plan, XC2dWaveprop_srcftzbkwd_plan;
fftwf_plan XC2dWaveprop_rcvftzfwd_plan, XC2dWaveprop_rcvftzbkwd_plan;
fftwf_complex *XC2dWaveprop_rcvftzin, *XC2dWaveprop_rcvftzout;
fftwf_complex *XC2dWaveprop_srcftzin, *XC2dWaveprop_srcftzout;
fftwf_plan XC2dWaveprop_srcftxfwd_plan, XC2dWaveprop_srcftxbkwd_plan;
fftwf_plan XC2dWaveprop_rcvftxfwd_plan, XC2dWaveprop_rcvftxbkwd_plan;
fftwf_complex *XC2dWaveprop_rcvftxin, *XC2dWaveprop_rcvftxout;
fftwf_complex *XC2dWaveprop_srcftxin, *XC2dWaveprop_srcftxout;
    // needwvmvin equals 1 means the waveprop operator is for forwarding modeling with recording wave movie, then recorded data/wvmv/isdep/irdep is with tapering zone
    // needwvmvin equals 2 means the waveprop operator is for waveform inversion, then recorded data/wvmv/isdep/irdep is without tapering zone
int  XC2dWaveprop_needwvmv,XC2dWaveprop_jtmv;
int  XC2dWaveprop_needdat;
int  XC2dWaveprop_freesurf;

#define Wpzxlocnopad(iz,ix) ((iz)+(ix)*(XC2dWaveprop_nz-2*XC2dWaveprop_nztape))
#define Wptxlocnopad(it,ix) ((it)+(ix)*XC2dWaveprop_nt)
#define Wpzxloc(iz,ix) ((iz)+(ix)*XC2dWaveprop_nz)
#define Wptxloc(it,ix) ((it)+(ix)*XC2dWaveprop_nt)
#define WpErrmsg(str)  {fprintf(stderr,(str));return 1;}
#define max(x,y) (((x)>(y))?(x):(y))
#define min(x,y) (((x)<(y))?(x):(y))
//#define VerbMsg(str) fprintf(stderr,str);
//#define WpVerbMsg(str) fprintf(stderr,str);
#define WpVerbMsg(str) ;
//#define VerbMsg(str) fprintf(stderr,str);
//#define VerbMsg1(str,str1) fprintf(stderr,str,str1);
#define VerbMsg2(str,str1,str2) fprintf(stderr,str,str1,str2);
#define VerbMsg3(str,str1,str2,str3) fprintf(stderr,str,str1,str2,str3);
//#define VerbMsg4(str,str1,str2,str3,str4) fprintf(stderr,str,str1,str2,str3,str4);
#define VerbMsg(str) ;
//#define VerbMsg2(str,str1,str2) ;
#define VerbMsg1(str,str1) ;

#include "2dstencil.h"

int XC2dWaveprop_Init(int ntin,  int nxin,  int nzin, \
                      float dtin,  float dxin, float dzin, \
                      int nxtapein, int nztapein,  \
                      int needwvmvin, int jtmvin, int freesurf, long *memcnt);
//izmax_inc : incremental z range of wavefield to be calculated as t increases
//mod is of nz*nx*3, with veldtinvdx2, epsf:(1+2*eps)*veldtinvdx2, deltaf:sqrt(1+2*delta)*veldtinvdx2
int XC2dWaveprop_op(int tsign, int *isdep, int *irdep, float *src, float *mod, int izmax_inc, float *data, float *wvmv );
int XC2dWaveprop_op2(int tsign, int *isdep, int *irdep, float *src, float *mod, int izmax_inc, float *data, float *pwvmv, float*rwvmv );
int XC2dWaveprop_setrcddat(int needdat);
int XC2dWaveprop_setwvmv(int needwvmvin);
int XC2dWaveprop_inject(int it, int *isdep, float *src, float *mod);
int XC2dWaveprop_injectnopad(int it, int *isdep, float *src, float *wvp, float *wvr, float *mod);
int XC2dWaveprop_injectderivnopad(int it, int *isdep, float *src, float *wvp, float *wvr, float *mod);
int XC2dWaveprop_rcdp(int it, int *irdep, float *data);
int XC2dWaveprop_rcdpnopad(int it, int *irdep, float *data, float *wvp);
int XC2dWaveprop_rcdr(int it, int *irdep, float *data);
int XC2dWaveprop_rcdrnopad(int it, int *irdep, float *data, float *wvr);
int XC2dWaveprop_rcdpmv(int it, float *wvmv);
int XC2dWaveprop_rcdpmvnopad(int it, float *wvmv, float *wvp);
int XC2dWaveprop_rcdrmv(int it, float *wvmv);
int XC2dWaveprop_rcdrmvnopad(int it, float *wvmv, float *wvr);
int XC2dWaveprop_calgrad(float *srcwvp3, float *rcvwvp3, float *srcwvr3, float *rcvwvr3,  float dt, double *grad, double *precond, int needprecond );
int XC2dWaveprop_op2_rndbnd_withimag(int *isdep, int *irdep, float *src, float *mod, int izmax_inc, float *data, double *grad, double *precond, int needprecond, float dt, int inode, int rcdmv, char* mvpath  );
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_Init(int ntin,  int nxin, int nzin, \
                      float dtin,  float dxin, float dzin, \
                      int nxtapein, int nztapein,  \
                      int needwvmvin, int jtmvin, int freesurf, long *memcnt )
{
   int sizet;
   XC2dWaveprop_dt=dtin;
   XC2dWaveprop_dx=dxin;
   XC2dWaveprop_dz=dzin;
   XC2dWaveprop_nt=ntin;
   XC2dWaveprop_nx=nxin;
   XC2dWaveprop_nz=nzin;
   XC2dWaveprop_nxtape=nxtapein;
   XC2dWaveprop_nztape=nztapein;
   XC2dWaveprop_needdat=1;
   XC2dWaveprop_needwvmv=needwvmvin;
   XC2dWaveprop_jtmv=jtmvin;
   XC2dWaveprop_freesurf=freesurf;
 
   //VerbMsg1("needwvmv in Waveprop is %d\n",needwvmvin) 
   // determine if padded reigon is reasonable
   if (nxin<=2*nxtapein)
      WpErrmsg("Error, nx less or equal than twice of padded x reigon\n")
   if (nzin<=2*nztapein)
      WpErrmsg("Error, nz less or equal than twice of padded z reigon\n")


   sizet=nxin*nzin;
   XC2dWaveprop_wavep1=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_wavep2=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_wavep6=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_waver1=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_waver2=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_waver6=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_wavep11=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_wavep12=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_waver11=(float*)malloc(sizet*sizeof(float));
   XC2dWaveprop_waver12=(float*)malloc(sizet*sizeof(float));
   //XC2dWaveprop_wavet13=(float*)malloc(sizet*sizeof(float));
   *memcnt+=sizet*sizeof(float)*5;

  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 wavefield snapshot size=%d \n",sizet) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nx=%d \n",nxin) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nz=%d \n",nzin) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nxtape=%d \n",nxtapein) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nztape=%d \n",nztapein) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nt=%d \n",ntin) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 jt=%d \n",jtmvin) 
   //if (XC2dWaveprop_needwvmv>0)
   //   XC2dWaveprop_wvmv=(float*)malloc(sizet*sizeof(float)*(ntin/jtmvin));
  /* 
  XC2dWaveprop_rcvftzin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);
  XC2dWaveprop_rcvftzout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);
  XC2dWaveprop_srcftzin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);
  XC2dWaveprop_srcftzout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);

  XC2dWaveprop_rcvftxin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  XC2dWaveprop_rcvftxout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  XC2dWaveprop_srcftxin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  XC2dWaveprop_srcftxout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  int zsign=1;
  int xsign=1;
  int stat;

  stat=XC2dWaveprop_initfft ( nzin, zsign, XC2dWaveprop_srcftzin, XC2dWaveprop_srcftzout, &XC2dWaveprop_srcftzfwd_plan, &XC2dWaveprop_srcftzbkwd_plan);
  if (stat==1) 
      WpErrmsg("Error in XC2dWaveprop_initfft, program teminated!\n");

  stat=XC2dWaveprop_initfft ( nzin, zsign, XC2dWaveprop_rcvftzin, XC2dWaveprop_rcvftzout, &XC2dWaveprop_rcvftzfwd_plan, &XC2dWaveprop_rcvftzbkwd_plan);
  if (stat==1) 
      WpErrmsg("Error in XC2dWaveprop_initfft, program teminated!\n");

  stat=XC2dWaveprop_initfft ( nxin, xsign, XC2dWaveprop_srcftxin, XC2dWaveprop_srcftxout, &XC2dWaveprop_srcftxfwd_plan, &XC2dWaveprop_srcftxbkwd_plan);
  if (stat==1) 
      WpErrmsg("Error in XC2dWaveprop_initfft, program teminated!\n");

  stat=XC2dWaveprop_initfft ( nxin, xsign, XC2dWaveprop_rcvftxin, XC2dWaveprop_rcvftxout, &XC2dWaveprop_rcvftxfwd_plan, &XC2dWaveprop_rcvftxbkwd_plan);
  if (stat==1) 
      WpErrmsg("Error in XC2dWaveprop_initfft, program teminated!\n");
  
  if (XC2dWaveprop_srcftin==NULL)
  {
     fprintf (stderr,"allocation of srcftin failed!\n ");
     return 1;
  }
  if (XC2dWaveprop_srcftout==NULL)
  {
     fprintf (stderr,"allocation of srcftout failed!\n ");
     return 1;
  }
  if (XC2dWaveprop_rcvftin==NULL)
  {
     fprintf (stderr,"allocation of rcvftin failed!\n ");
     return 1;
  }
  if (XC2dWaveprop_rcvftout==NULL)
  {
     fprintf (stderr,"allocation of rcvftout failed!\n ");
     return 1;
  }*/
   return 0;
}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC2dWaveprop_op(int tsign, int *isdep, int *irdep, float *src, float *mod, int izmax_inc, float *data, float *wvmv )
{
  int ix,iz,it,jt;
  int nx,nz,nt;
  int stat;
  float *wvtmp;
  int izmin,izmax,tmpit;
  time_t time1,time2;
  nt=XC2dWaveprop_nt;
  jt=XC2dWaveprop_jtmv;
  nx=XC2dWaveprop_nx;
  nz=XC2dWaveprop_nz;
  // zero out all the wavefield
  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
	 {	 
        XC2dWaveprop_wavep1[ Wpzxloc(iz,ix) ]=0.;
		XC2dWaveprop_wavep2[ Wpzxloc(iz,ix) ]=0.;
		XC2dWaveprop_wavep6[ Wpzxloc(iz,ix) ]=0.;
		XC2dWaveprop_waver1[ Wpzxloc(iz,ix) ]=0.;
		XC2dWaveprop_waver2[ Wpzxloc(iz,ix) ]=0.;
		XC2dWaveprop_waver6[ Wpzxloc(iz,ix) ]=0.;
	 }	 

  //VerbMsg("start propagation in Waveprop_op with \n") 
  // start propagation
  time1=time(NULL);
  // determine z range for wave propagation    
  izmin=nz;
  izmax=0; 
  for(ix=0;ix<nx;ix++)
  {
     iz=isdep[ix];
     if (iz>izmax)
        izmax=iz;
     if (iz<izmin)
        izmin=iz;
  }

  if (XC2dWaveprop_freesurf>0)
     izmin=XC2dWaveprop_nztape;

  for (it=0;it<nt;it++)
  {   
     // inject source  
     //VerbMsg("start inject source Waveprop_op\n") 
     if (tsign>0)  
        stat=XC2dWaveprop_inject(it,isdep,src, mod);
     else
        stat=XC2dWaveprop_inject(nt-it-1,isdep,src, mod);
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_inject, program teminated!\n");

     // record data  
     if (XC2dWaveprop_needdat>0)
     {
        //VerbMsg("start record data in Waveprop_op\n") 
        if (tsign>0)  
           stat=XC2dWaveprop_rcdp(it,irdep,data);
        else  
           stat=XC2dWaveprop_rcdp(nt-it-1,irdep,data);
        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcd, program teminated!\n");
     }

     // record wave movie if necessary  
     if ( (XC2dWaveprop_needwvmv>0) && (it%jt==0) && (tsign>0) ) 
     { 
           stat=XC2dWaveprop_rcdpmv(it,wvmv);
        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcdmv, program teminated!\n");
     }
     if ( (XC2dWaveprop_needwvmv>0) && ((nt-1-it)%jt==0) && (tsign<0) ) 
     {
        tmpit=nt-1-it;  
           stat=XC2dWaveprop_rcdpmv(tmpit,wvmv);
        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcdmv, program teminated!\n");
     }
     /*
     // determine z range for wave propagation    
     izmin=nz;
     izmax=0; 

     for(iy=1;iy<ny;iy++)
        for(ix=1;ix<nx;ix++)
        {
           iz=isdep[Wpxloc(ix)];
           if (iz>izmax)
              izmax=iz;
           if (iz<izmin)
              izmin=iz;
        }
     */
     if (XC2dWaveprop_freesurf==0)
        izmin=izmin-izmax_inc;
     izmax=izmax+izmax_inc;
   
     // 1 step propagation
     //VerbMsg("start 1 step propagation in Waveprop_op \n") 
         stat=XC2dVTIWaveprop_1step4t10spacetest1opt(mod, XC2dWaveprop_wavep1, XC2dWaveprop_wavep2, XC2dWaveprop_wavep1,  XC2dWaveprop_wavep6, XC2dWaveprop_waver1, XC2dWaveprop_waver2, XC2dWaveprop_waver1,  XC2dWaveprop_waver6, izmin,izmax);
	  if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_1step4t10space, program teminated!\n");

     // swap wavefield slices
     wvtmp=XC2dWaveprop_wavep1;
     XC2dWaveprop_wavep1=XC2dWaveprop_wavep2;
     XC2dWaveprop_wavep2=wvtmp;
	  
     wvtmp=XC2dWaveprop_waver1;
     XC2dWaveprop_waver1=XC2dWaveprop_waver2;
     XC2dWaveprop_waver2=wvtmp;
     //XC2dWaveprop_wavet2=XC2dWaveprop_wavet3;
     //XC2dWaveprop_wavet3=wvtmp;
     
     if ( (it%(nt/10))==0 ) 
     {
        time2=time(NULL);
        //VerbMsg1("Finished %d percent of one shot modeling ",(it*100/nt))
        //VerbMsg1("spent %ld seconds\n",(time2-time1))
        time1=time(NULL);
     }
  }

  return 0;
}

//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC2dWaveprop_op2(int tsign, int *isdep, int *irdep, float *src, float *mod, int izmax_inc, float *data, float *pwvmv, float *rwvmv )
{
  int ix,iz,it,jt;
  int nx,nz,nt;
  int nxtape;
  int stat;
  float *wvtmp;
  int izmin,izmax;
  int ixmin,ixmax;
  int flag;
  time_t time1,time2;
  float *wvp1, *wvp2, *wvp6, *wvr1, *wvr2, *wvr6;
  nt=XC2dWaveprop_nt;
  jt=XC2dWaveprop_jtmv;
  nx=XC2dWaveprop_nx;
  nxtape=XC2dWaveprop_nxtape;
  nz=XC2dWaveprop_nz;
  wvp1=XC2dWaveprop_wavep1;
  wvp2=XC2dWaveprop_wavep2;
  wvp6=XC2dWaveprop_wavep6;
  wvr1=XC2dWaveprop_waver1;
  wvr2=XC2dWaveprop_waver2;
  wvr6=XC2dWaveprop_waver6;

  // zero out all the wavefield
  WpVerbMsg("start zero XC2dWaveprop_wavet1\n") 
  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
	 {	  
            wvp1[ Wpzxloc(iz,ix) ]=0.;
	    wvp2[ Wpzxloc(iz,ix) ]=0.;
	    wvp6[ Wpzxloc(iz,ix) ]=0.;
	    wvr1[ Wpzxloc(iz,ix) ]=0.;
	    wvr2[ Wpzxloc(iz,ix) ]=0.;
	    wvr6[ Wpzxloc(iz,ix) ]=0.;
	 }
	
  WpVerbMsg("start propagation in Waveprop_op2 with \n") 
  // start propagation
  time1=time(NULL);

  // determine ixmin
  flag=0;
  for (ix=0;ix<(nx-2*nxtape);ix++)
  {
     if (flag==0)
     {
        for (it=0;it<nt;it++)
           if ( src[Wptxlocnopad(it,ix)] != 0.)
           {
              ixmin=ix;
              flag=1;
              break;
           }
     }
  }
  //determine ixmax
  flag=0;
  for (ix=(nx-1-2*nxtape);ix>-1;ix--)
  {
     if (flag==0)
     {
        for (it=0;it<nt;it++)
           if ( src[Wptxlocnopad(it,ix)] != 0.)
           {
              ixmax=ix;
              flag=1;
              break;
           }
     }
  }

  // determine z range for wave propagation    
  izmin=nz;
  izmax=0; 

  for(ix=0;ix<nx-2*nxtape;ix++)
  {
     iz=isdep[ix];
     if (iz>izmax)
        izmax=iz;
     if (iz<izmin)
        izmin=iz;
  }

  if (XC2dWaveprop_freesurf>0)
     izmin=XC2dWaveprop_nztape;
  for (it=0;it<nt;it++)
  {   
     VerbMsg1("in Waveprop_op2, start time step %d\n",it) 
     // inject source  
     WpVerbMsg("start inject source Waveprop_op2\n") 
     if (tsign>0)  
        stat=XC2dWaveprop_injectnopad(it,isdep,src,wvp2,wvr2,mod);
     else  
        stat=XC2dWaveprop_injectnopad(nt-it-1,irdep,src,wvp2,wvr2,mod);
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_injectnopad, program teminated!\n");

     // record data  
     if (XC2dWaveprop_needdat>0)
     {
        WpVerbMsg("start record data in Waveprop_op2\n") 
        if (tsign>0)  
           stat=XC2dWaveprop_rcdrnopad(it,irdep,data,wvr2);
        else  
           stat=XC2dWaveprop_rcdrnopad(nt-it-1,irdep,data,wvr2);
        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcdnopad, program teminated!\n");
     }

     // record wave movie if necessary  
     if ( (XC2dWaveprop_needwvmv>0) && (it%jt==0) ) 
     { 
        WpVerbMsg("start record movie in Waveprop_op2\n") 
        if (tsign>0)  
        {
           stat=XC2dWaveprop_rcdpmvnopad(it,pwvmv,wvp2);
           stat=XC2dWaveprop_rcdrmvnopad(it,rwvmv,wvr2);
        }
        else
        {
           stat=XC2dWaveprop_rcdpmvnopad(((int)((nt-1)/jt))*jt-it,pwvmv,wvp2);
           stat=XC2dWaveprop_rcdrmvnopad(((int)((nt-1)/jt))*jt-it,rwvmv,wvr2);
        }
        if (stat==1) 
           WpErrmsg("Error in XC2dWaveprop_rcdmvnopad, program teminated!\n");
     }
     if (XC2dWaveprop_freesurf==0)
        izmin=izmin-izmax_inc;

     izmax=izmax+izmax_inc;
     ixmin=ixmin-izmax_inc;
     ixmax=ixmax+izmax_inc;

   
     //VerbMsg2("izmin=%d izmax=%d\n",izmin,izmax)
     //VerbMsg2("izmax_inc=%d nz=%d\n",izmax_inc,nz)
     //izmin=0;
     //izmax=nz;
     // 1 step propagation
     //VerbMsg2("start 1 step propagation in Waveprop_op2, with izmin=%d, izmax=%d \n",izmin,izmax) 
     stat=XC2dVTIWaveprop_1step4t10spacetest1opt(mod, wvp1, wvp2, wvp1, wvp6, wvr1, wvr2, wvr1, wvr6, izmin,izmax);

     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_1step4t10spacewithbnd1optinline, program teminated!\n");

     // swap wavefield slices
     WpVerbMsg("start pointer shift in Waveprop_op2 \n") 
     wvtmp=wvp1; wvp1=wvp2; wvp2=wvtmp;
     wvtmp=wvr1; wvr1=wvr2; wvr2=wvtmp;

  }

  return 0;
}

//////////////////////////////////
//////////////////////////////////
//////////////////////////////////
/// next edit start here
//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC2dWaveprop_op2_rndbnd_withimag(int *isdep, int *irdep, float *src, float *mod, int izmax_inc, float *data, double *grad, double *precond, int needprecond, float dt, int inode, int rcdmv, char* mvpath  )
{
  int ix,iz,it,jt;
  int nx,nz,nt;
  int nxtape;
  int stat;
  float *wvtmp;
  int izmin,izmax;
  int ixmin,ixmax;
  int flag;
  time_t time1,time2;
  nt=XC2dWaveprop_nt;
  jt=XC2dWaveprop_jtmv;
  nx=XC2dWaveprop_nx;
  nxtape=XC2dWaveprop_nxtape;
  nz=XC2dWaveprop_nz;
  float *wvp1, *wvp2, *wvp6, *wvp11,*wvp12;
  float *wvr1, *wvr2, *wvr6, *wvr11,*wvr12;
  wvp1=XC2dWaveprop_wavep1;
  wvp2=XC2dWaveprop_wavep2;
  wvp6=XC2dWaveprop_wavep6;
  wvp11=XC2dWaveprop_wavep11;
  wvp12=XC2dWaveprop_wavep12;
  wvr1=XC2dWaveprop_waver1;
  wvr2=XC2dWaveprop_waver2;
  wvr6=XC2dWaveprop_waver6;
  wvr11=XC2dWaveprop_waver11;
  wvr12=XC2dWaveprop_waver12;
  // zero out all the wavefield
  VerbMsg("start XC2dWaveprop_op2_rndbnd_imag\n") 
  WpVerbMsg("start zero XC2dWaveprop_wavet1\n") 
  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
     {
        wvp1[ Wpzxloc(iz,ix) ]=0.;
        wvp2[ Wpzxloc(iz,ix) ]=0.;
        wvp6[ Wpzxloc(iz,ix) ]=0.;
        wvp11[ Wpzxloc(iz,ix) ]=0.;
        wvp12[ Wpzxloc(iz,ix) ]=0.;
        wvr1[ Wpzxloc(iz,ix) ]=0.;
        wvr2[ Wpzxloc(iz,ix) ]=0.;
        wvr6[ Wpzxloc(iz,ix) ]=0.;
        wvr11[ Wpzxloc(iz,ix) ]=0.;
        wvr12[ Wpzxloc(iz,ix) ]=0.;
     } 
  int i;
  if (needprecond>1)
     fprintf(stderr,"Warning! needprecond>1 is not implemented in this version, using needprecond==1 instead!\n");
  WpVerbMsg("start propagation in Waveprop_op2_rndbnd_imag with \n") 
  // start propagation
  time1=time(NULL);
  
 // determine ixmin
  flag=0;
  for (ix=0;ix<(nx-2*nxtape);ix++)
  {
     if (flag==0)
     {
        for (it=0;it<nt;it++)
           if ( src[Wptxlocnopad(it,ix)] != 0.)
           {
              ixmin=ix;
              flag=1;
              break;
           }
     }
  }
  //determine ixmax
  flag=0;
  for (ix=(nx-1-2*nxtape);ix>-1;ix--)
  {
     if (flag==0)
     {
        for (it=0;it<nt;it++)
           if ( src[Wptxlocnopad(it,ix)] != 0.)
           {
              ixmax=ix;
              flag=1;
              break;
           }
     }
  }


  // determine z range for wave propagation    
  izmin=nz;
  izmax=0; 

  for(ix=0;ix<nx-2*nxtape;ix++)
  {
     iz=isdep[ix];
     if (iz>izmax)
        izmax=iz;
     if (iz<izmin)
        izmin=iz;
  }

  if (XC2dWaveprop_freesurf>0)
     izmin=XC2dWaveprop_nztape;
 
  for (it=0;it<nt;it++)
  {   
     VerbMsg1("in Waveprop_op2, start time step %d\n",it) 
     // inject source  
     WpVerbMsg("start inject source Waveprop_op2\n") 

     stat=XC2dWaveprop_injectnopad(it,isdep,src,wvp2,wvr2,mod);

     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_injectnopad, program teminated!\n");

     if (XC2dWaveprop_freesurf==0)
        izmin=izmin-izmax_inc;

     izmax=izmax+izmax_inc;
     ixmin=ixmin-izmax_inc;
     ixmax=ixmax+izmax_inc;

   
     // 1 step propagation
     stat=XC2dVTIWaveprop_1step4t10spacenobnd(mod, wvp1, wvp2, wvp1, wvp6, wvr1, wvr2, wvr1, wvr6, izmin, izmax );
     if (stat==1) 
        WpErrmsg("Error in XC2dVTIWaveprop_1step4t10spacenobnd, program teminated!\n");

     // swap wavefield slices
     WpVerbMsg("start pointer shift in Waveprop_op2 \n") 
     wvtmp=wvp1; wvp1=wvp2; wvp2=wvtmp;
     wvtmp=wvr1; wvr1=wvr2; wvr2=wvtmp;
  }


  wvtmp=wvp1; wvp1=wvp2; wvp2=wvtmp;
  wvtmp=wvr1; wvr1=wvr2; wvr2=wvtmp;
  for (it=nt-1;it>-1;it--)
  {   
     VerbMsg1("in Waveprop_op2_rndbnd_imag, start time step %d\n",it) 
     // inject source  
     WpVerbMsg("start inject source Waveprop_op2\n") 
     stat=XC2dWaveprop_injectderivnopad(it,irdep,data,wvp12,wvr12,mod);

     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_injectnopad, program teminated!\n");

     if (XC2dWaveprop_freesurf==0)
        izmin=izmin-izmax_inc;

     izmax=izmax+izmax_inc;
     ixmin=ixmin-izmax_inc;
     ixmax=ixmax+izmax_inc;

   
     // 1 step propagation
     stat=XC2dVTIWaveprop_1step4t10spacenobnd(mod, wvp1, wvp2, wvp1, wvp6, wvr1, wvr2, wvr1, wvr6, izmin, izmax );
     if (stat==1) 
        WpErrmsg("Error in XC2dVTIWaveprop_1step4t10spacenobnd, program teminated!\n");

     stat=XC2dVTIWaveprop_1step4t10spacenobnd(mod, wvp11, wvp12, wvp11, wvp6, wvr11, wvr12, wvr11, wvr6, izmin, izmax );
     if (stat==1) 
        WpErrmsg("Error in XC2dWaveprop_1step4t10spacenobnd, program teminated!\n");
     // gradient calculation
     if ( (it>1) && (it<nt-2) && (it%jt==0) )
     {
        ///
        ///
        /// need to be double checked for modification in VTI case 
               XC2dWaveprop_calgrad( wvp1, wvp11, wvr1, wvr11, dt, grad, precond, needprecond );
        if ((inode==1)&&(rcdmv==1))
        {
          if( (nx*nz*4)!=srite(mvpath,wvp1,4*nx*nz) )
             seperr("trouble writing out src mv\n");
          if( (nx*nz*4)!=srite(mvpath,wvp11,4*nx*nz) )
             seperr("trouble writing out rsd rcv mv\n");

        }
     } 
       
     // swap wavefield slices
     WpVerbMsg("start pointer shift in Waveprop_op2_rndbnd_imag \n") 
     wvtmp=wvp2;wvp2=wvp1;wvp1=wvtmp;
     wvtmp=wvp12;wvp12=wvp11;wvp11=wvtmp;

     wvtmp=wvr2;wvr2=wvr1;wvr1=wvtmp;
     wvtmp=wvr12;wvr12=wvr11;wvr11=wvtmp;

  }

  return 0;
}


///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_setrcddat(int needdat)
{
   XC2dWaveprop_needdat=needdat;
   return 0;
}

int XC2dWaveprop_setwvmv(int needwvmvin)
{
   XC2dWaveprop_needwvmv=needwvmvin;
   return 0;
}
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_inject(int it, int *isdep, float *src, float *mod)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   int sz=nx*XC2dWaveprop_nz;
   for (ix=0;ix<nx;ix++)
   {
      iz=isdep[ix ];
      XC2dWaveprop_waver2[ Wpzxloc(iz,ix) ] +=src[ Wptxloc(it,ix) ];
	  XC2dWaveprop_wavep2[ Wpzxloc(iz,ix) ] +=src[ Wptxloc(it,ix) ]*(mod[ Wpzxloc(iz,ix) + sz ] + mod[ Wpzxloc(iz,ix) + 2*sz ])/(mod[ Wpzxloc(iz,ix) + 2*sz ]+mod[ Wpzxloc(iz,ix) ]) ;	   
      //XC2dWaveprop_wavet2[ Wpzxloc(iz,ix) ] +=0.01;
   }
   return 0;
}

int XC2dWaveprop_injectnopad(int it, int *isdep, float *src, float *wvp, float*wvr, float *mod)
{
   int ix,iz;
   int nx;
   int nxtape,nztape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
   int sz=nx*XC2dWaveprop_nz;
   for (ix=0;ix<nx-2*nxtape;ix++)
   {
      iz=isdep[ ix ];
      wvp[ Wpzxloc(iz,ix+nxtape) ] +=src[ Wptxlocnopad(it,ix) ]*((mod[ Wpzxloc(iz,ix+nxtape) + sz ] + mod[ Wpzxloc(iz,ix+nxtape) + 2*sz ])/(mod[ Wpzxloc(iz,ix+nxtape) + 2*sz ]+mod[ Wpzxloc(iz,ix+nxtape) ])) ;	   
      wvr[ Wpzxloc(iz,ix+nxtape) ] +=src[ Wptxlocnopad(it,ix) ];
   }
   return 0;
}

int XC2dWaveprop_injectderivnopad(int it, int *isdep, float *src, float *wvp, float *wvr, float *mod)
{
   int ix,iz;
   int nx;
   int nxtape,nztape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
	int sz=nx*XC2dWaveprop_nz;
   for (ix=0;ix<nx-2*nxtape;ix++)
   {
      iz=isdep[ ix ];
      if ( (it<(XC2dWaveprop_nt-2)) && (it>1) )
         wvr[ Wpzxloc(iz,ix+nxtape) ] += -1./12.*src[ Wptxlocnopad(it-2,ix) ] \
                                                    +4./3. *src[ Wptxlocnopad(it-1,ix) ] \
                                                    -2.5   *src[ Wptxlocnopad(it,ix) ]   \
                                                    +4./3. *src[ Wptxlocnopad(it+1,ix) ] \
                                                    -1./12.*src[ Wptxlocnopad(it+2,ix) ];
      else
         wvr[ Wpzxloc(iz,ix+nxtape) ] +=src[ Wptxlocnopad(it,ix) ];
	
	  if ( (it<(XC2dWaveprop_nt-2)) && (it>1) )
		   wvp[ Wpzxloc(iz,ix+nxtape) ] += (-1./12.*src[ Wptxlocnopad(it-2,ix) ] \
											+4./3. *src[ Wptxlocnopad(it-1,ix) ] \
											-2.5   *src[ Wptxlocnopad(it,ix) ]   \
											+4./3. *src[ Wptxlocnopad(it+1,ix) ] \
											-1./12.*src[ Wptxlocnopad(it+2,ix) ])*(mod[ Wpzxloc(iz,ix+nxtape) + sz ] + mod[ Wpzxloc(iz,ix+nxtape) + 2*sz ])/(mod[ Wpzxloc(iz,ix+nxtape) + 2*sz ]+mod[ Wpzxloc(iz,ix+nxtape) ]);
	   else
		   wvp[ Wpzxloc(iz,ix+nxtape) ] +=src[ Wptxlocnopad(it,ix) ]*(mod[ Wpzxloc(iz,ix+nxtape) + sz ] + mod[ Wpzxloc(iz,ix+nxtape) + 2*sz ])/(mod[ Wpzxloc(iz,ix+nxtape) + sz ]+mod[ Wpzxloc(iz,ix+nxtape) ]);
	   
   }
   return 0;
}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_rcdp(int it, int *irdep, float *data)
{
	int ix,iz;
	int nx;
	int nxtape;
	nx=XC2dWaveprop_nx;
	nxtape=XC2dWaveprop_nxtape;
	for (ix=0;ix<nx;ix++)
	{
		iz=irdep[ ix ];
		data[ Wptxloc(it,ix) ] = XC2dWaveprop_wavep2[ Wpzxloc(iz,ix) ];
	}
	return 0;
}

int XC2dWaveprop_rcdpnopad(int it, int *irdep, float *data, float *wvp)
{
	int ix,iz;
	int nx;
	int nxtape;
	nx=XC2dWaveprop_nx;
	nxtape=XC2dWaveprop_nxtape;
	for (ix=0;ix<nx-2*nxtape;ix++)
	{
		iz=irdep[ ix ];
		data[ Wptxlocnopad(it,ix) ] = wvp[ Wpzxloc(iz,ix+nxtape) ];
	}
	return 0;
}
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_rcdr(int it, int *irdep, float *data)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   for (ix=0;ix<nx;ix++)
   {
      iz=irdep[ ix ];
      data[ Wptxloc(it,ix) ] = XC2dWaveprop_waver2[ Wpzxloc(iz,ix) ];
   }
   return 0;
}

int XC2dWaveprop_rcdrnopad(int it, int *irdep, float *data, float *wvr)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dWaveprop_nx;
   nxtape=XC2dWaveprop_nxtape;
   for (ix=0;ix<nx-2*nxtape;ix++)
   {
      iz=irdep[ ix ];
      data[ Wptxlocnopad(it,ix) ] = wvr[ Wpzxloc(iz,ix+nxtape) ];
   }
   return 0;
}
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dWaveprop_rcdrmv(int it, float *wvmv)
{
   int ix,iz;
   int jt;
   int nx,nz;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   jt=XC2dWaveprop_jtmv;
   int cnt=0;
   int cnt1=0;
   for (ix=0;ix<nx;ix++)
      for (iz=0;iz<nz;iz++)
      {
         wvmv[ Wpzxloc(iz,ix) + nx*nz*((int)(((it)/jt) )) ] = XC2dWaveprop_waver2[ Wpzxloc(iz,ix) ];
	  }
	return 0;
}

int XC2dWaveprop_rcdpmv(int it, float *wvmv)
{
	int ix,iz;
	int jt;
	int nx,nz;
	nx=XC2dWaveprop_nx;
	nz=XC2dWaveprop_nz;
	jt=XC2dWaveprop_jtmv;
	int cnt=0;
	int cnt1=0;
	for (ix=0;ix<nx;ix++)
		for (iz=0;iz<nz;iz++)
		{
			wvmv[ Wpzxloc(iz,ix) + nx*nz*((int)(((it)/jt) )) ] = XC2dWaveprop_wavep2[ Wpzxloc(iz,ix) ];
		}
	return 0;
}

int XC2dWaveprop_rcdrmvnopad(int it, float *wvmv, float *wvr)
{
	int ix,iz;
	int jt;
	int nx,nz;
	int nxtape,nztape;
	nx=XC2dWaveprop_nx;
	nz=XC2dWaveprop_nz;
	nxtape=XC2dWaveprop_nxtape;
	nztape=XC2dWaveprop_nztape;
	jt=XC2dWaveprop_jtmv;
	for (ix=0;ix<nx-2*nxtape;ix++)
		for (iz=0;iz<nz-2*nztape;iz++)
			wvmv[ Wpzxlocnopad(iz,ix) + (nx-2*nxtape)*(nz-2*nztape)*(it/jt) ] = wvr[ Wpzxloc(iz+nztape,ix+nxtape) ];
	return 0;
}

int XC2dWaveprop_rcdpmvnopad(int it, float *wvmv, float *wvp)
{
   int ix,iz;
   int jt;
   int nx,nz;
   int nxtape,nztape;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
   jt=XC2dWaveprop_jtmv;
   for (ix=0;ix<nx-2*nxtape;ix++)
      for (iz=0;iz<nz-2*nztape;iz++)
         wvmv[ Wpzxlocnopad(iz,ix) + (nx-2*nxtape)*(nz-2*nztape)*(it/jt) ] = wvp[ Wpzxloc(iz+nztape,ix+nxtape) ];
   return 0;
}

///
/// need further work/double check
int XC2dWaveprop_calgrad(float *srcwvp, float *rcvwvp, float *srcwvr, float *rcvwvr, float dt, double *grad, double *precond, int needprecond )
{ 
   /*
   int ix,iz,idx,idx1;
   int jt;
   int nx,nz;
   int nxtape,nztape;
   float temp1,temp2,maxval;
   float dx;
   //maxval=-1000l;
   nx=XC2dWaveprop_nx;
   nz=XC2dWaveprop_nz;
   nxtape=XC2dWaveprop_nxtape;
   nztape=XC2dWaveprop_nztape;
   jt=XC2dWaveprop_jtmv;
   dx=XC2dWaveprop_dx;
   dt=XC2dWaveprop_dt;
   for (ix=nxtape;ix<nx-nxtape;ix++)
      for (iz=nztape;iz<nz-nztape;iz++)
      {  
         idx=Wpzxloc(iz,ix);
         if (XC2dWaveprop_paramtype==1)
         {
            temp1=-1./12.*(srcwvp[idx-2*nz]+srcwvp[idx+2*nz])+4./3.*(srcwvp[idx-nz]+srcwvp[idx+nz])-2.5*srcwvp[idx];
            temp2=-1./12.*(srcwvr[idx-2]+srcwvr[idx+2])+4./3.*(srcwvr[idx-1]+srcwvr[idx+1])-2.5*srcwvr[idx];
            grad[idx+nz*nx]+=temp1*rcvwvp[idx]/(dx*dx);

            grad[idx]+=temp1*rcvwvr[idx]*mod[i+2*nz*nx]/mod[i]/(dx*dx);
            grad[idx]+=temp2*rcvwvp[idx]*mod[i+2*nz*nx]/mod[i]/(dx*dx)+temp2*rcvwvr[idx]/(dx*dx);

         }
         else if (XC2dWaveprop_paramtype==2)
         {
            temp1=-1./12.*(srcwvp[idx-2*nz]+srcwvp[idx+2*nz])+4./3.*(srcwvp[idx-nz]+srcwvp[idx+nz])-2.5*srcwvp[idx];
            grad[idx+nz*nx]+=temp1*rcvwvp[idx]/(dx*dx);
            temp1=-1./12.*(srcwvp[idx+(it-2)*nx*nz]+srcwvp[idx+(it+2)*nx*nz])+4./3.*(srcwvp[idx+(it-1)*nx*nz]+srcwvp[idx+(it+1)*nx*nz])-2.5*srcwvp[idx+it*nx*nz];
            grad[idx1]+=temp1*rcvwvp[idx+nx*nz*it]/(dt*jtmv*dt*jtmv);

         }
         grad[ Wpzxloc(iz,ix) ] += -rcvwvt3[ Wpzxloc(iz,ix) ] * srcwvt3[Wpzxloc(iz,ix)];

         if (needprecond==1)
            precond[ Wpzxloc(iz,ix) ]+=srcwvt3[Wpzxloc(iz,ix)] * srcwvt3[Wpzxloc(iz,ix)];
      }
    */
   return 0;
}
