#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <sep_pars_external.h>
#include <seplib.h>
#include <sep3dc.h>


#define txyloc(it,ix,iy) ( (it)+(ix)*nt+(iy)*nt*nx )
#define txloc(it,ix) ( (it)+(ix)*nt )

int main(int argc, char** argv)
{
    int ndim;
    float tmp,tdelay,t,fpeak,type;
    char temp_char[256];
    int   nt, nx, ny, nz, nsx, nsy, ns;
    float ot, ox, oy, oz, osx, osy;
    float dt, dx, dy, dz, dsx, dsy;
    int   it, ix, iy, is, isx, isy,i,idxy;
    float *src;
    sep3d outfile; 

    initpar(argc,argv);
    // read t,x,y from source file
    if (0==getch("nt","i", &nt)) nt=200;
    if (0==getch("nx","i", &nx)) nx=100;
    if (0==getch("ny","i", &ny)) ny=100;
    if (0==getch("ot","f", &ot)) ot=0;
    if (0==getch("ox","f", &ox)) ox=0;
    if (0==getch("oy","f", &oy)) oy=0;
    if (0==getch("dt","f", &dt)) dt=0.004;
    if (0==getch("dx","f", &dx)) dx=10;
    if (0==getch("dy","f", &dy)) dy=10;

    if (0==getch("nsx","i", &nsx)) nsx=2;
    if (0==getch("nsy","i", &nsy)) nsy=2;
    if (0==getch("osx","f", &osx)) osx=0;
    if (0==getch("osy","f", &osy)) osy=0;
    if (0==getch("dsx","f", &dsx)) dsx=4*dx;
    if (0==getch("dsy","f", &dsy)) dsy=4*dy;

    if (0==getch("type","f", &type)) type=1.;
    if (0==getch("tdelay","f", &tdelay)) tdelay=0.2;
    if (0==getch("fpeak","f", &fpeak)) fpeak=15;

    ns=nsx*nsy;
    src=(float*)malloc(nt*nx*sizeof(float));

    //output recorded data
    ndim=4;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=ot;
    outfile.d[0]=dt;
    outfile.n[0]=nt;
    outfile.o[1]=ox;
    outfile.d[1]=dx;
    outfile.n[1]=nx;
    outfile.o[2]=oy;
    outfile.d[2]=dy;
    outfile.n[2]=ny;
    outfile.o[3]=0;
    outfile.d[3]=1;
    outfile.n[3]=ns;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for out\n");

    for (isy=0;isy<nsy;isy++) 
       for (isx=0;isx<nsx;isx++) 
          for (idxy=0;idxy<ny;idxy++) 
          {
             for (i=0;i<nx*nt;i++)
                src[i]=0;
             ix=((osx+isx*dsx)-ox)/dx;
             iy=((osy+isy*dsy)-oy)/dy;
             if ( (type==1.) && (iy==idxy) )
                for (it=0;it<nt;it++)
                {
                   t=ot+it*dt;
                   tmp=pi*fpeak*(t+tdelay);
                   src[txloc(it,ix)]=2*tmp*expf(-tmp*tmp);
                   fprintf(stderr,"iy=%d,idxy=%d\n",iy,idxy);
                }
             else if( (type==2.) && (iy==idxy) )
                for (it=0;it<nt;it++)
                {
                   t=ot+it*dt;
                   tmp=pi*fpeak*(t+tdelay);
                   src[txloc(it,ix)]=(1.-2*tmp*tmp)*expf(-tmp*tmp);
                }
             if( (nt*nx*4)!=srite("out",src,4*nt*nx) )
                   seperr("trouble writing out data\n");
          }


    return 0;
}
