#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <sep_pars_external.h>
#include <seplib.h>
#include <sep3dc.h>
#include "fftw3.h"

int main(int argc, char** argv)
{
    int ndim,i,n;
    float o,d;
    char temp_char[256];
    int   nt, nx, ny, nz, ns;
    float ot, ox, oy, oz;
    float dt, dx, dy, dz;
    int   it, ix, iy, iz, is;
    int   nxtape,nytape,nztape;
    int   needwvmv,jtmv;
    int   stat;
    float *finre, *finim;
    sep3d outfile; 
    time_t time1,time2;
    fftwf_plan planfwd, planbkwd;
    fftwf_complex *fin, *fout;
    fftwf_complex *fin2, *fout2;
    fftwf_complex zero;
    initpar(argc,argv);
    // read t,x,y from source file
   
    zero[0]=0;
    zero[1]=0;
    ndim=2; 
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          nt=n;
          dt=d;
          ot=o;
       }
    }
    fin = (fftwf_complex*)fftwf_malloc(nt*sizeof(fftwf_complex));
    fout = (fftwf_complex*)fftwf_malloc(nt*sizeof(fftwf_complex));
    planfwd = fftwf_plan_dft_1d(nt, fin, fout, FFTW_FORWARD, FFTW_MEASURE);
    planbkwd = fftwf_plan_dft_1d(nt, fout, fin, FFTW_BACKWARD, FFTW_MEASURE);
    finre=(float*)malloc(sizeof(float)*nt);
    finim=(float*)malloc(sizeof(float)*nt);
    sreed("in",finre,nt*4);
    sreed("in",finim,nt*4);
    for (it=0;it<nt;it++)
    {
       fin[it][0]=finre[it];
       fin[it][1]=finim[it];
    } 

    fprintf(stderr,"start execute plan");
    fftwf_execute(planfwd);

    
    for (it=nt/2;it<nt;it++)
    {
      fout[it][0]=0;
      fout[it][1]=0;
    } 

    fftwf_execute(planbkwd);

    for (it=0;it<nt;it++)
    {
       finre[it]=fin[it][0];
       finim[it]=fin[it][1];
    } 

    ndim=2;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=ot;
    outfile.d[0]=dt;
    outfile.n[0]=nt;
    outfile.o[1]=0;
    outfile.d[1]=1;
    outfile.n[1]=2;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for data\n");

    if( (nt*4)!=srite("out",finre,4*nt) )
       seperr("unable to output real part for data\n");
    if( (nt*4)!=srite("out",finim,4*nt) )
       seperr("unable to output imag part for data\n");

    return 0;
}
