#include "stdlib.h"
#include "math.h"
#include "string.h"
#include <seplib.h>
#include <sep3dc.h>


#define xmax(a,b) ((a)>(b)?(a):(b))
#define xmin(a,b) ((a)<(b)?(a):(b))
#define xbound(a1,a,a2) (xmin( (xmax((a1),(a))),(a2) ))
int main(int argc, char** argv)
{
    int ndim,n,flag;
    float o,d;
    char temp_char[256];
    int   n1, n2;
    float o1, o2;
    float d1, d2;
    int   i1, i2, i, ibeg, iend ;
    int i2idx2,i2idx1,i1idx2,i1idx1;
    float *velin, *velout;
    sep3d outfile; 
    initpar(argc,argv);
    // read t,x,y from source file
   
    if(0!=sep_get_number_data_axes("in",&ndim))
       seperr("unable to get dimension from src!\n");
    
    for(i=1;i<=ndim;i++)
    {
       if(0!=sep_get_data_axis_par("in",&i,&n,&o,&d,temp_char))
       seperr("unable to get parameters from src!\n");
       if(i==1)
       {
          n1=n;
          d1=d;
          o1=o;
       }
       else if(i==2)
       {
          n2=n;
          d2=d;
          o2=o;
       }
    }

    fprintf(stderr,"n1=%d, n2=%d\n",n1,n2);
    // readin other parameters
    /*
    if (0==getch("k","f", &slope)) slope=1;
    if (0==getch("k2","f", &slope2)) slope2=2;
    if (0==getch("flo","f", &flo)) flo=0;
    if (0==getch("ofst","f", &ofst)) ofst=0.1;
    if (0==getch("keep","f", &keep)) keep=1;
    if (0==getch("type","f", &type)) type=1;
    if (0==getch("halftaperwidth","i", &halftaperwidth)) halftaperwidth=5;

    fprintf(stderr,"n1=%d\n",n1);
    if (ofst<0) ofst=-ofst;
    if (slope<0) slope=-slope;
    if (slope2<0) slope2=-slope2;
    */
    // allocate memories

    velin=(float*)malloc(n1*n2*sizeof(float)*2);
    velout=(float*)malloc(n1*n2*sizeof(float)*2);

    if ((n1*n2*4)!=sreed("in",velin,n1*n2*4))
       seperr("Error read in fk domain data from stdin\n");

    fprintf(stderr,"after sreed, n1=%d\n",n1);
    for (i=0;i<n1*n2;i++) 
       velout[i]=velin[i]; 
    //change anomaly 1
    i2idx1=255;i2idx2=325;
    i1idx1=250;i1idx2=300;
    for (i2=i2idx1;i2<i2idx2;i2++)
    {
       if (i2>i2idx1 && i2<i2idx2-1 )
          for (i1=i1idx1;i1<i1idx2;i1++)
          { 
             i=i1+i2*n1;
             ibeg=i1+i2idx1*n1;
             iend=i1+(i2idx2-1)*n1;
             velout[i]=(velin[ibeg]*(i2idx2-1.0-i2)+velin[iend]*(i2-i2idx1-0.0))/(i2idx2*1.0-i2idx1-1.0);
	  }
    }

    //change anomaly 2
    i2idx1=400;i2idx2=455;
    i1idx1=250;i1idx2=300;
    for (i2=i2idx1;i2<i2idx2;i2++)
    {
       if (i2>i2idx1 && i2<i2idx2-1 )
          for (i1=i1idx1;i1<i1idx2;i1++)
          { 
             i=i1+i2*n1;
             ibeg=i1+i2idx1*n1;
             iend=i1+(i2idx2-1)*n1;
             velout[i]=(velin[ibeg]*(i2idx2-1.0-i2)+velin[iend]*(i2-i2idx1-0.0))/(i2idx2*1.0-i2idx1-1.0);
	  }
    }


    //change anomaly 3
    i2idx1=480;i2idx2=560;
    i1idx1=245;i1idx2=295;
    for (i2=i2idx1;i2<i2idx2;i2++)
    {
       if (i2>i2idx1 && i2<i2idx2-1 )
          for (i1=i1idx1;i1<i1idx2;i1++)
          { 
             i=i1+i2*n1;
             ibeg=i1+i2idx1*n1;
             iend=i1+(i2idx2-1)*n1;
             velout[i]=(velin[ibeg]*(i2idx2-1.0-i2)+velin[iend]*(i2-i2idx1-0.0))/(i2idx2*1.0-i2idx1-1.0);
	  }
    }


    //change anomaly 4
    i2idx1=595;i2idx2=695;
    i1idx1=273;i1idx2=327;
    for (i2=i2idx1;i2<i2idx2;i2++)
    {
       if (i2>i2idx1 && i2<i2idx2-1 )
          for (i1=i1idx1;i1<i1idx2;i1++)
          { 
             i=i1+i2*n1;
             ibeg=i1+i2idx1*n1;
             iend=i1+(i2idx2-1)*n1;
             velout[i]=(velin[ibeg]*(i2idx2-1.0-i2)+velin[iend]*(i2-i2idx1-0.0))/(i2idx2*1.0-i2idx1-1.0);
	  }
    }


    //change anomaly 5
    i2idx1=695;i2idx2=795;
    i1idx1=235;i1idx2=290;
    for (i2=i2idx1;i2<i2idx2;i2++)
    {
       if (i2>i2idx1 && i2<i2idx2-1 )
          for (i1=i1idx1;i1<i1idx2;i1++)
          { 
             i=i1+i2*n1;
             ibeg=i1+i2idx1*n1;
             iend=i1+(i2idx2-1)*n1;
             velout[i]=(velin[ibeg]*(i2idx2-1.0-i2)+velin[iend]*(i2-i2idx1-0.0))/(i2idx2*1.0-i2idx1-1.0);
	  }
    }


    //change anomaly 6
    i2idx1=1300;i2idx2=1600;
    i1idx1=75;i1idx2=245;
    for (i2=i2idx1;i2<i2idx2;i2++)
    {
       if (i2>i2idx1 && i2<i2idx2-1 )
          for (i1=i1idx1;i1<i1idx2;i1++)
          { 
             i=i1+i2*n1;
             ibeg=i1+i2idx1*n1;
             iend=i1+(i2idx2-1)*n1;
             velout[i]=(velin[ibeg]*(i2idx2-1.0-i2)+velin[iend]*(i2-i2idx1-0.0))/(i2idx2*1.0-i2idx1-1.0);
	  }
    }


    //change anomaly 7
    i2idx1=1630;i2idx2=1700;
    i1idx1=175;i1idx2=225;
    for (i2=i2idx1;i2<i2idx2;i2++)
    {
       if (i2>i2idx1 && i2<i2idx2-1 )
          for (i1=i1idx1;i1<i1idx2;i1++)
          { 
             i=i1+i2*n1;
             ibeg=i1+i2idx1*n1;
             iend=i1+(i2idx2-1)*n1;
             velout[i]=(velin[ibeg]*(i2idx2-1.0-i2)+velin[iend]*(i2-i2idx1-0.0))/(i2idx2*1.0-i2idx1-1.0);
	  }
    }

    //change anomaly 8
    i2idx1=830;i2idx2=950;
    i1idx1=230;i1idx2=290;
    for (i2=i2idx1;i2<i2idx2;i2++)
    {
       if (i2>i2idx1 && i2<i2idx2-1 )
          for (i1=i1idx1;i1<i1idx2;i1++)
          { 
             i=i1+i2*n1;
             ibeg=i1+i2idx1*n1;
             iend=i1+(i2idx2-1)*n1;
             velout[i]=(velin[ibeg]*(i2idx2-1.0-i2)+velin[iend]*(i2-i2idx1-0.0))/(i2idx2*1.0-i2idx1-1.0);
	  }
    }


    ndim=2;
    if(0!=init_sep3d_par(&outfile,"OUTPUT","FLOAT","REGULAR",ndim,0))
       seperr("unable to write outfile!\n");
    outfile.o[0]=o1;
    outfile.d[0]=d1;
    outfile.n[0]=n1;
    outfile.o[1]=o2;
    outfile.d[1]=d2;
    outfile.n[1]=n2;
    sep3d_set_sep3d(&outfile);
    if(0!=sep3dc_write_description("out",&outfile))
       seperr("unable to output parameters for out\n");

    if( (n1*n2*4)!=srite("out",velout,4*n1*n2) )
       seperr("trouble writing stdout \n");

    return 0;
}
