
// dimensional information ( t,x,z, note that x,z info are after tapering/padding)
int   XC2dVTIWaveprop_nt,XC2dVTIWaveprop_nx,XC2dVTIWaveprop_nz;
int   XC2dVTIWaveprop_nxtape,XC2dVTIWaveprop_nztape;
float *XC2dVTIWaveprop_veldtinvdx2;
float *XC2dVTIWaveprop_wavep1;
float *XC2dVTIWaveprop_wavep2;
float *XC2dVTIWaveprop_wavep6;
float *XC2dVTIWaveprop_waver1;
float *XC2dVTIWaveprop_waver2;
float *XC2dVTIWaveprop_waver6;
float *XC2dVTIWaveprop_wvmv;
fftwf_plan XC2dVTIWaveprop_srcftzfwd_plan, XC2dVTIWaveprop_srcftzbkwd_plan;
fftwf_plan XC2dVTIWaveprop_rcvftzfwd_plan, XC2dVTIWaveprop_rcvftzbkwd_plan;
fftwf_complex *XC2dVTIWaveprop_rcvftzin, *XC2dVTIWaveprop_rcvftzout;
fftwf_complex *XC2dVTIWaveprop_srcftzin, *XC2dVTIWaveprop_srcftzout;
fftwf_plan XC2dVTIWaveprop_srcftxfwd_plan, XC2dVTIWaveprop_srcftxbkwd_plan;
fftwf_plan XC2dVTIWaveprop_rcvftxfwd_plan, XC2dVTIWaveprop_rcvftxbkwd_plan;
fftwf_complex *XC2dVTIWaveprop_rcvftxin, *XC2dVTIWaveprop_rcvftxout;
fftwf_complex *XC2dVTIWaveprop_srcftxin, *XC2dVTIWaveprop_srcftxout;
    // needwvmvin equals 1 means the waveprop operator is for forwarding modeling with recording wave movie, then recorded data/wvmv/isdep/irdep is with tapering zone
// needwvmvin equals 2 means the waveprop operator is for waveform inversion, then recorded data/wvmv/isdep/irdep is without tapering zone
// in array wvp, fast axis is x 
// in array wvr, fast axis is z 
int  XC2dVTIWaveprop_needwvmv,XC2dVTIWaveprop_jtmv;
int  XC2dVTIWaveprop_needdat;
int  XC2dVTIWaveprop_freesurf;
#define Wpzxlocnopad(iz,ix) ((iz)+(ix)*(XC2dVTIWaveprop_nz-2*XC2dVTIWaveprop_nztape))
#define Wptxlocnopad(it,ix) ((it)+(ix)*XC2dVTIWaveprop_nt)
#define Wpzxloc(iz,ix) ((iz)+(ix)*XC2dVTIWaveprop_nz)
#define Wpxzloc(iz,ix) ((ix)+(iz)*XC2dVTIWaveprop_nx)
#define Wptxloc(it,ix) ((it)+(ix)*XC2dVTIWaveprop_nt)
#define WpErrmsg(str)  {fprintf(stderr,(str));return 1;}
#define max(x,y) (((x)>(y))?(x):(y))
#define min(x,y) (((x)<(y))?(x):(y))
//#define VerbMsg(str) fprintf(stderr,str);
//#define WpVerbMsg(str) fprintf(stderr,str);
#define WpVerbMsg(str) ;
#define VerbMsg(str) fprintf(stderr,str);
//#define VerbMsg1(str,str1) fprintf(stderr,str,str1);
#define VerbMsg2(str,str1,str2) fprintf(stderr,str,str1,str2);
#define VerbMsg3(str,str1,str2,str3) fprintf(stderr,str,str1,str2,str3);
//#define VerbMsg4(str,str1,str2,str3,str4) fprintf(stderr,str,str1,str2,str3,str4);
//#define VerbMsg(str) ;
//#define VerbMsg2(str,str1,str2) ;
#define VerbMsg1(str,str1) ;

#include "2dVTIstencil.h"

int XC2dVTIWaveprop_Init(int ntin,  int nxin,  int nzin, \
                      int nxtapein, int nztapein,  \
                      int needwvmvin, int jtmvin, int freesurf, long *memcnt);
//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC2dVTIWaveprop_op(int tsign, int *isdep, int *irdep, float *src, float *veldtinvdx2, float *epsf, float *deltaf, int izmax_inc, float *data, float *wvmv );
int XC2dVTIWaveprop_setrcddat(int needdat);
int XC2dVTIWaveprop_setwvmv(int needwvmvin);
int XC2dVTIWaveprop_injectp(int it, int *isdep, float *src, float *wvt);
int XC2dVTIWaveprop_injectr(int it, int *isdep, float *src, float *wvt, float *epsf, float *deltaf, float *veldtinvdx2);
int XC2dVTIWaveprop_injectnopad(int it, int *isdep, float *src, float *wvt);
int XC2dVTIWaveprop_injectderivnopad(int it, int *isdep, float *src, float *wvt);
int XC2dVTIWaveprop_rcdp(int it, int *irdep, float *data, float *wvt);
int XC2dVTIWaveprop_rcdr(int it, int *irdep, float *data, float *wvt);
int XC2dVTIWaveprop_rcdnopad(int it, int *irdep, float *data, float *wvt);
int XC2dVTIWaveprop_rcdpmv(int it, float *wvmv);
int XC2dVTIWaveprop_rcdrmv(int it, float *wvmv);
int XC2dVTIWaveprop_rcdmvnopad(int it, float *wvmv, float *wvt);
int XC2dVTIWaveprop_calgrad(float *srcwvt3, float *rcvwvt3, float dt, double *grad, double *precond, int needprecond );
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dVTIWaveprop_Init(int ntin,  int nxin, int nzin, \
                      int nxtapein, int nztapein,  \
                      int needwvmvin, int jtmvin, int freesurf, long *memcnt )
{
   int sizet;
   XC2dVTIWaveprop_nt=ntin;
   XC2dVTIWaveprop_nx=nxin;
   XC2dVTIWaveprop_nz=nzin;
   XC2dVTIWaveprop_nxtape=nxtapein;
   XC2dVTIWaveprop_nztape=nztapein;
   XC2dVTIWaveprop_needdat=1;
   XC2dVTIWaveprop_needwvmv=needwvmvin;
   XC2dVTIWaveprop_jtmv=jtmvin;
   XC2dVTIWaveprop_freesurf=freesurf;
 
   //VerbMsg1("needwvmv in Waveprop is %d\n",needwvmvin) 
   // determine if padded reigon is reasonable
   if (nxin<=2*nxtapein)
      WpErrmsg("Error, nx less or equal than twice of padded x reigon\n")
   if (nzin<=2*nztapein)
      WpErrmsg("Error, nz less or equal than twice of padded z reigon\n")


   sizet=nxin*nzin;
   XC2dVTIWaveprop_wavep1=(float*)malloc(sizet*sizeof(float));
   XC2dVTIWaveprop_wavep2=(float*)malloc(sizet*sizeof(float));
   XC2dVTIWaveprop_wavep6=(float*)malloc(sizet*sizeof(float));
   XC2dVTIWaveprop_waver1=(float*)malloc(sizet*sizeof(float));
   XC2dVTIWaveprop_waver2=(float*)malloc(sizet*sizeof(float));
   XC2dVTIWaveprop_waver6=(float*)malloc(sizet*sizeof(float));
   //XC2dVTIWaveprop_wavet13=(float*)malloc(sizet*sizeof(float));
   *memcnt+=sizet*sizeof(float)*6;

  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 wavefield snapshot size=%d \n",sizet) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nx=%d \n",nxin) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nz=%d \n",nzin) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nxtape=%d \n",nxtapein) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nztape=%d \n",nztapein) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 nt=%d \n",ntin) 
  VerbMsg1("!!!!!!!!!!!!!!!!!!! in Waveprop2 jt=%d \n",jtmvin) 
   //if (XC2dVTIWaveprop_needwvmv>0)
   //   XC2dVTIWaveprop_wvmv=(float*)malloc(sizet*sizeof(float)*(ntin/jtmvin));
   
  XC2dVTIWaveprop_rcvftzin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);
  XC2dVTIWaveprop_rcvftzout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);
  XC2dVTIWaveprop_srcftzin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);
  XC2dVTIWaveprop_srcftzout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nzin);

  XC2dVTIWaveprop_rcvftxin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  XC2dVTIWaveprop_rcvftxout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  XC2dVTIWaveprop_srcftxin=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  XC2dVTIWaveprop_srcftxout=(fftwf_complex*)fftwf_malloc(sizeof(fftwf_complex)*nxin);
  int zsign=1;
  int xsign=1;
  int stat;

   return 0;
}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
//izmax_inc : incremental z range of wavefield to be calculated as t increases
int XC2dVTIWaveprop_op(int tsign, int *isdep, int *irdep, float *src, float *veldtinvdx2, float *epsf, float *deltaf, int izmax_inc, float *data, float *wvmv )
{
  int ix,iz,it,jt;
  int nx,nz,nt;
  int stat;
  float *wvtmp;
  float tmpval;
  int izmin,izmax;
  time_t time1,time2;
  nt=XC2dVTIWaveprop_nt;
  jt=XC2dVTIWaveprop_jtmv;
  nx=XC2dVTIWaveprop_nx;
  nz=XC2dVTIWaveprop_nz;
  // zero out all the wavefield
  for (iz=0;iz<nz;iz++)
     for (ix=0;ix<nx;ix++)
        XC2dVTIWaveprop_wavep1[ Wpxzloc(iz,ix) ]=0.;
  
  for (iz=0;iz<nz;iz++)
     for (ix=0;ix<nx;ix++)
        XC2dVTIWaveprop_wavep2[ Wpxzloc(iz,ix) ]=0.;

  for (iz=0;iz<nz;iz++)
     for (ix=0;ix<nx;ix++)
        XC2dVTIWaveprop_wavep6[ Wpxzloc(iz,ix) ]=0.;

  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
        XC2dVTIWaveprop_waver1[ Wpzxloc(iz,ix) ]=0.;
  
  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
        XC2dVTIWaveprop_waver2[ Wpzxloc(iz,ix) ]=0.;

  for (ix=0;ix<nx;ix++)
     for (iz=0;iz<nz;iz++)
        XC2dVTIWaveprop_waver6[ Wpzxloc(iz,ix) ]=0.;

  float xval=0;
  for (ix=0;ix<nx*nz;ix++)
       xval+=sqrt(veldtinvdx2[ix]);
  fprintf(stderr,"before propagation, xval=%e\n",xval);


  //VerbMsg("start propagation in Waveprop_op with \n") 
  // start propagation
  time1=time(NULL);
  // determine z range for wave propagation    
  izmin=nz;
  izmax=0; 
  for(ix=0;ix<nx;ix++)
  {
     iz=isdep[ix];
     if (iz>izmax)
        izmax=iz;
     if (iz<izmin)
        izmin=iz;
  }

  if (XC2dVTIWaveprop_freesurf>0)
     izmin=XC2dVTIWaveprop_nztape;

  for (it=0;it<nt;it++)
  {   
     // inject source  
     //VerbMsg("start inject source Waveprop_op\n") 
     if (tsign>0)  
     {
        stat=XC2dVTIWaveprop_injectp(it,isdep, src, XC2dVTIWaveprop_wavep1);
        stat=XC2dVTIWaveprop_injectr(it,isdep, src, XC2dVTIWaveprop_waver1, epsf, deltaf, veldtinvdx2);
     }
     else  
     {
        stat=XC2dVTIWaveprop_injectp(nt-1-it,isdep, src, XC2dVTIWaveprop_wavep1);
        stat=XC2dVTIWaveprop_injectr(nt-1-it,isdep, src, XC2dVTIWaveprop_waver1, epsf, deltaf, veldtinvdx2);
     }
     if (stat==1) 
        WpErrmsg("Error in XC2dVTIWaveprop_inject, program teminated!\n");

     // record data  
     if (XC2dVTIWaveprop_needdat>0)
     {
        //VerbMsg("start record data in Waveprop_op\n") 
        if (tsign>0)  
        {
           if (it%100==0)
              fprintf(stderr,"rcd p data of it=%d!\n",it);
           //stat=XC2dVTIWaveprop_rcdp(it,irdep,data,XC2dVTIWaveprop_wavep1);
           stat=XC2dVTIWaveprop_rcdr(it,irdep,data,XC2dVTIWaveprop_waver1);
        }
        else  
        {
           //stat=XC2dVTIWaveprop_rcdp(nt-it-1,irdep,data,XC2dVTIWaveprop_wavep1);
           stat=XC2dVTIWaveprop_rcdr(nt-it-1,irdep,data,XC2dVTIWaveprop_waver1);
        } 
        if (stat==1) 
           WpErrmsg("Error in XC2dVTIWaveprop_rcd, program teminated!\n");
     }

     // record wave movie if necessary  
     if ( (XC2dVTIWaveprop_needwvmv>0) && (it%jt==0) ) 
     { 
        //VerbMsg("start record movie in Waveprop_op\n") 
        if (tsign>0)  
        {
           stat=XC2dVTIWaveprop_rcdrmv(it,wvmv);
           //stat=XC2dVTIWaveprop_rcdpmv(it,wvmv);
        }
        else
           stat=XC2dVTIWaveprop_rcdrmv(nt-it-1,wvmv);

        if (stat==1) 
           WpErrmsg("Error in XC2dVTIWaveprop_rcdpmv, program teminated!\n");
     }
     /*
     // determine z range for wave propagation    
     izmin=nz;
     izmax=0; 

     for(iy=1;iy<ny;iy++)
        for(ix=1;ix<nx;ix++)
        {
           iz=isdep[Wpxloc(ix)];
           if (iz>izmax)
              izmax=iz;
           if (iz<izmin)
              izmin=iz;
        }
     */
     if (XC2dVTIWaveprop_freesurf==0)
        izmin=izmin-izmax_inc;
     izmax=izmax+izmax_inc;
   
     // 1 step propagation
     //VerbMsg("start 1 step propagation in Waveprop_op \n") 
     stat=XC2dVTIWaveprop_1step4t10spacetest1opt(veldtinvdx2, epsf, deltaf, XC2dVTIWaveprop_wavep1, XC2dVTIWaveprop_wavep2, XC2dVTIWaveprop_wavep1,  XC2dVTIWaveprop_wavep6, XC2dVTIWaveprop_waver1, XC2dVTIWaveprop_waver2, XC2dVTIWaveprop_waver1,  XC2dVTIWaveprop_waver6, izmin,izmax);
     if (stat==1) 
        WpErrmsg("Error in XC2dVTIWaveprop_1step2t2space, program teminated!\n");

     // swap wavefield slices
     wvtmp=XC2dVTIWaveprop_wavep1;
     XC2dVTIWaveprop_wavep1=XC2dVTIWaveprop_wavep2;
     XC2dVTIWaveprop_wavep2=wvtmp;
     
     wvtmp=XC2dVTIWaveprop_waver1;
     XC2dVTIWaveprop_waver1=XC2dVTIWaveprop_waver2;
     XC2dVTIWaveprop_waver2=wvtmp;

     if ( (it%(nt/10))==0 ) 
     {
        time2=time(NULL);
        time1=time(NULL);
     }
  }

  return 0;
}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dVTIWaveprop_setrcddat(int needdat)
{
   XC2dVTIWaveprop_needdat=needdat;
   return 0;
}

int XC2dVTIWaveprop_setwvmv(int needwvmvin)
{
   XC2dVTIWaveprop_needwvmv=needwvmvin;
   return 0;
}
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dVTIWaveprop_injectp(int it, int *isdep, float *src, float *wvt)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dVTIWaveprop_nx;
   nxtape=XC2dVTIWaveprop_nxtape;
   for (ix=0;ix<nx;ix++)
   {
      iz=isdep[ix ];
      wvt[ Wpxzloc(iz,ix) ] +=src[ Wptxloc(it,ix) ];
   }
   
   return 0;
}
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dVTIWaveprop_injectr(int it, int *isdep, float *src, float *wvt, float *epsf, float *deltaf, float *veldtinvdx2)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dVTIWaveprop_nx;
   nxtape=XC2dVTIWaveprop_nxtape;
   for (ix=0;ix<nx;ix++)
   {
      iz=isdep[ix ];
      wvt[ Wpzxloc(iz,ix) ] +=src[ Wptxloc(it,ix) ]/(epsf[ Wpzxloc(iz,ix) ]+deltaf[ Wpzxloc(iz,ix) ])*(deltaf[ Wpzxloc(iz,ix) ]+veldtinvdx2[ Wpzxloc(iz,ix) ]) ;
   }
   return 0;
}

int XC2dVTIWaveprop_injectnopad(int it, int *isdep, float *src, float *wvt)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dVTIWaveprop_nx;
   nxtape=XC2dVTIWaveprop_nxtape;
   for (ix=0;ix<nx-2*nxtape;ix++)
   {
      iz=isdep[ ix ];
      wvt[ Wpzxloc(iz,ix+nxtape) ] +=src[ Wptxlocnopad(it,ix) ];
   }
   return 0;
}

int XC2dVTIWaveprop_injectderivnopad(int it, int *isdep, float *src, float *wvt)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dVTIWaveprop_nx;
   nxtape=XC2dVTIWaveprop_nxtape;
   for (ix=0;ix<nx-2*nxtape;ix++)
   {
      iz=isdep[ ix ];
      if ( (it<(XC2dVTIWaveprop_nt-2)) && (it>1) )
         wvt[ Wpzxloc(iz,ix+nxtape) ] += -1./12.*src[ Wptxlocnopad(it-2,ix) ] \
                                                    +4./3. *src[ Wptxlocnopad(it-1,ix) ] \
                                                    -2.5   *src[ Wptxlocnopad(it,ix) ]   \
                                                    +4./3. *src[ Wptxlocnopad(it+1,ix) ] \
                                                    -1./12.*src[ Wptxlocnopad(it+2,ix) ];
      else
         wvt[ Wpzxloc(iz,ix+nxtape) ] +=src[ Wptxlocnopad(it,ix) ];
   }
   return 0;
}

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dVTIWaveprop_rcdp(int it, int *irdep, float *data, float *wvt)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dVTIWaveprop_nx;
   nxtape=XC2dVTIWaveprop_nxtape;
   for (ix=0;ix<nx;ix++)
   {
      iz=irdep[ ix ];
      data[ Wptxloc(it,ix) ] = wvt[ Wpxzloc(iz,ix) ];
   }
   return 0;
}
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
int XC2dVTIWaveprop_rcdr(int it, int *irdep, float *data, float *wvt)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dVTIWaveprop_nx;
   nxtape=XC2dVTIWaveprop_nxtape;
   for (ix=0;ix<nx;ix++)
   {
      iz=irdep[ ix ];
      data[ Wptxloc(it,ix) ] = wvt[ Wpzxloc(iz,ix) ];
   }
   return 0;
}

int XC2dVTIWaveprop_rcdnopad(int it, int *irdep, float *data, float *wvt)
{
   int ix,iz;
   int nx;
   int nxtape;
   nx=XC2dVTIWaveprop_nx;
   nxtape=XC2dVTIWaveprop_nxtape;
   for (ix=0;ix<nx-2*nxtape;ix++)
   {
      iz=irdep[ ix ];
      data[ Wptxlocnopad(it,ix) ] = wvt[ Wpzxloc(iz,ix+nxtape) ];
   }
   return 0;
}
///////////////////////////////////////////////////////////////////////
int XC2dVTIWaveprop_rcdrmv(int it, float *wvmv)
{
   int ix,iz;
   int jt;
   int nx,nz;
   nx=XC2dVTIWaveprop_nx;
   nz=XC2dVTIWaveprop_nz;
   jt=XC2dVTIWaveprop_jtmv;
   for (ix=0;ix<nx;ix++)
      for (iz=0;iz<nz;iz++)
         wvmv[ Wpzxloc(iz,ix) + nx*nz*(it/jt) ] = XC2dVTIWaveprop_waver2[ Wpzxloc(iz,ix) ];
   return 0;
}
///////////////////////////////////////////////////////////////////////
int XC2dVTIWaveprop_rcdpmv(int it, float *wvmv)
{
   int ix,iz;
   int jt;
   int nx,nz;
   nx=XC2dVTIWaveprop_nx;
   nz=XC2dVTIWaveprop_nz;
   jt=XC2dVTIWaveprop_jtmv;
   for (ix=0;ix<nx;ix++)
      for (iz=0;iz<nz;iz++)
         wvmv[ Wpzxloc(iz,ix) + nx*nz*(it/jt) ] = XC2dVTIWaveprop_wavep2[ Wpxzloc(iz,ix) ];
   return 0;
}

int XC2dVTIWaveprop_rcdmvnopad(int it, float *wvmv, float *wvt)
{
   int ix,iz;
   int jt;
   int nx,nz;
   int nxtape,nztape;
   nx=XC2dVTIWaveprop_nx;
   nz=XC2dVTIWaveprop_nz;
   nxtape=XC2dVTIWaveprop_nxtape;
   nztape=XC2dVTIWaveprop_nztape;
   jt=XC2dVTIWaveprop_jtmv;
   for (ix=0;ix<nx-2*nxtape;ix++)
      for (iz=0;iz<nz-2*nztape;iz++)
         wvmv[ Wpzxlocnopad(iz,ix) + (nx-2*nxtape)*(nz-2*nztape)*(it/jt) ] = wvt[ Wpzxloc(iz+nztape,ix+nxtape) ];
   return 0;
}

int XC2dVTIWaveprop_calgrad(float *srcwvt3, float *rcvwvt3, float dt, double *grad, double *precond, int needprecond )
{
   int ix,iz;
   int jt;
   int nx,nz;
   int nxtape,nztape;
   float temp1,maxval;
   //maxval=-1000l;
   nx=XC2dVTIWaveprop_nx;
   nz=XC2dVTIWaveprop_nz;
   nxtape=XC2dVTIWaveprop_nxtape;
   nztape=XC2dVTIWaveprop_nztape;
   jt=XC2dVTIWaveprop_jtmv;
   for (ix=nxtape;ix<nx-nxtape;ix++)
      for (iz=nztape;iz<nz-nztape;iz++)
      {
         grad[ Wpzxloc(iz,ix) ] += -rcvwvt3[ Wpzxloc(iz,ix) ] * srcwvt3[Wpzxloc(iz,ix)];

         if (needprecond==1)
            precond[ Wpzxloc(iz,ix) ]+=srcwvt3[Wpzxloc(iz,ix)] * srcwvt3[Wpzxloc(iz,ix)];
      }
   return 0;
}




