module billgen
  use sep
! general subroutines for reading history, writing history, making a mask, spacing data, etc
  implicit none
  contains
  subroutine get_history(n,o,d,filename)
  integer, dimension(:)::n
  real,    dimension(:)::  o,d
  character (len=4)    ::      filename
  optional             ::      filename
  integer              ::              dim
  dim=size(n)
  !write(0,*)"dim",dim
  if (present(filename)) then 
  	call from_aux(filename,"n1",n(1));call from_aux(filename,"d1",d(1));call from_aux(filename,"o1",o(1))
  	if (dim>1) then 
  		call from_aux(filename,"n2",n(2)); call from_aux(filename,"d2",d(2));call from_aux(filename,"o2",o(2))
  	endif
  	if (dim>2) then 
  		call from_aux(filename,"n3",n(3));call from_aux(filename,"d3",d(3));call from_aux(filename,"o3",o(3))
  	endif
  	if (dim>3) then 
  		call from_aux(filename,"n4",n(4));call from_aux(filename,"d4",d(4));call from_aux(filename,"o4",o(4))
  	endif
  	if (dim>4) then
  		call from_aux(filename,"n5",n(5));call from_aux(filename,"d5",d(5));call from_aux(filename,"o5",o(5))
	endif
  	if (dim>5) then
  		call from_aux(filename,"n6",n(6));call from_aux(filename,"d6",d(6));call from_aux(filename,"o6",o(6))
	endif
  else
  	call from_history("n1",n(1));call from_history("d1",d(1));call from_history("o1",o(1))
  	if (dim>1) then
  		call from_history("n2",n(2));call from_history("d2",d(2));call from_history("o2",o(2))
  	endif
  	if (dim>2) then
  		call from_history("n3",n(3));call from_history("d3",d(3));call from_history("o3",o(3))
  	endif
  	if (dim>3) then
  		call from_history("n4",n(4));call from_history("d4",d(4));call from_history("o4",o(4))
  	endif
  	if (dim>4) then
  		call from_history("n5",n(5));call from_history("d5",d(5));call from_history("o5",o(5))
  	endif
  	if (dim>5) then
  		call from_history("n6",n(6));call from_history("d6",d(6));call from_history("o6",o(6))
  	endif
  endif
  end subroutine
  
  subroutine put_history(n,o,d,esize,filename)
  integer, dimension(:)::n
  real,    dimension(:)::  o,d
  character  (len=4)   ::      filename
  optional             ::      esize,filename
  integer              ::      esize,        dim
  dim=size(n)
  if (present(filename)) then
  	call to_history("n1",n(1),filename);call to_history("d1",d(1),filename);call to_history("o1",o(1),filename)
  	if (dim>1) then 
  		call to_history("n2",n(2),filename);call to_history("d2",d(2),filename);call to_history("o2",o(2),filename)
  	endif
  	if (dim>2) then 
  		call to_history("n3",n(3),filename);call to_history("d3",d(3),filename);call to_history("o3",o(3),filename)
  	endif
 	if (dim>3) then 
 		call to_history("n4",n(4),filename);call to_history("d4",d(4),filename);call to_history("o4",o(4),filename)
  	endif
  	if (dim>4) then 
  		call to_history("n5",n(5),filename);call to_history("d5",d(5),filename);call to_history("o5",o(5),filename)
  	endif
  	if (dim>5) then
  		call to_history("n6",n(6),filename);call to_history("d6",d(6),filename);call to_history("o6",o(6),filename)
	endif
    if (present(esize)) then
    	call to_history("esize",esize,filename)
	endif
  else
  	call to_history("n1",n(1));call to_history("d1",d(1));call to_history("o1",o(1))
  	if (dim>1) then 
  		call to_history("n2",n(2));call to_history("d2",d(2));call to_history("o2",o(2))
  	endif
  	if (dim>2) then 
  		call to_history("n3",n(3));call to_history("d3",d(3));call to_history("o3",o(3))
  	endif
  	if (dim>3) then 
  		call to_history("n4",n(4));call to_history("d4",d(4));call to_history("o4",o(4))
  	endif
  	if (dim>4) then 
  		call to_history("n5",n(5));call to_history("d5",d(5));call to_history("o5",o(5))
  	endif
  	if (dim>5) then
  		call to_history("n6",n(6));call to_history("d6",d(6));call to_history("o6",o(6))
	endif
    if (present(esize)) then
  	  call to_history("esize",esize)
	endif
  endif
  end subroutine
end module 
