/* convert standard C binary files to sep format */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "params.c"

int main(int argc, char *argv[]){
	printf("Converting to SEP format...\n");
	char *in, *out, *binout;
	char buf[100];
	if(!(
			cfrom_params(argc, argv, "in", &in, "_0_") &&
			cfrom_params(argc, argv, "out", &out, "_0_") &&
			cfrom_params(argc, argv, "binout", &binout, "_0_")) 
		){
			printf("ERROR: need in, out, and binout paramters!\n");
			exit(-1);
		}

	char *count;
	printf("Reading from headerfile %s \n",in);
	printf("Writing to headerfile %s binary %s \n",out, binout);
	FILE *fp1=fopen(in,"r");
	FILE *fp2=fopen(out,"w");
	char *temp=calloc(100, sizeof(char));
	while((count=fgets(buf,100,fp1))!=NULL){
		fprintf(fp2, "%s\n", buf);
	}
	fprintf(fp2, "in=%s\n", binout);
	fclose(fp1);
	fclose(fp2);
	int n1, n2, n3; float d1, d2, d3;
	ifrom_hdrs(in, "n1", &n1,0);
	ifrom_hdrs(in, "n2", &n2,0);
	ifrom_hdrs(in, "n3", &n3,1);

	float *buffer=malloc(n1*n2*sizeof(float));

	ffrom_hdrs(in, "d1", &d1,0.0);
	ffrom_hdrs(in, "d2", &d2,0.0);
	ffrom_hdrs(in, "d3", &d3,0.0);
	cfrom_hdrs(in, "in", &temp,"_0_");
	printf("in=%s, n1=%d, n2=%d, n3=%d, d1=%f, d2=%f, d3=%f\n",temp, n1,n2,n3,d1,d2,d3);
	fp1=fopen(temp,"r");
	fp2=fopen(binout,"w");
	char *a, b[4];
	printf("Begining transfer...\n");
	int r;
	int total=0;
	while(r=(fread(buffer,sizeof(float),n1*n2,fp1))){
		//printf("patch: %d/%d\n", r, n1*n2);
		total+=r;
		for(int t=0;t<r; t++){
			a=(char*)&buffer[t];
			b[0]=a[3];
			b[1]=a[2];
			b[2]=a[1];
			b[3]=a[0];
			float *bf=(float*) &b[0];
			buffer[t]=bf[0];
		}
		fwrite(buffer,sizeof(float),r,fp2);
	}
	printf("Done with the transfer (%d)...\n", total);
	fclose(fp1);
	fclose(fp2);
	return 0;
}

