#!/bin/tcsh
#PBS -N marm_4EAGE2012
#PBS -l nodes=11:ppn=8
#PBS -q Q35
#PBS -V
#PBS -m e
#PBS -W x="PARTITION:sw121"
#PBS -M xukaishen@gmail.com
#PBS -e /data/sep/xukai/data/test/marm_4EAGE2012/test21.err
#PBS -o /data/sep/xukai/data/test/marm_4EAGE2012/test21.out
#
cd $PBS_O_WORKDIR
#

set DATDIR=/data/sep/xukai/data/test/marm_4EAGE2012
set CBIN=/data/sep/xukai/Bin/c

cat ${PBS_NODEFILE} | sort | uniq > hostfile21
set NPROCS=`wc -l hostfile21 | gawk '//{print $1}'`
echo ${NPROCS}
set OMP_NUM_THREADS=8
#mpirun -machinefile ./hostfile2 -np ${NPROCS} ./test_mpi.x

set str=21

date

mpirun -machinefile ./hostfile21 -np ${NPROCS} ${CBIN}/XC2dWIMPIMain.x <tmprcd1.H nxtape=40 nztape=40 vmin=600 vmax=4600 vout=${DATDIR}/newvel${str}.H resd=${DATDIR}/resd${str}.H vupd=${DATDIR}/vup${str}.H rdful=${DATDIR}/rdful${str}.H newsrc=${DATDIR}/newsrc${str}.H needspline=0 niter=160 needprecond=0 dxspline=100 dzspline=100 vel=vel1s.H jrdful=9 jtmv=1 objtype=0 src=tmpsrc1.H thresd=0.0004 jnoderdful=1 rndbnd_type=2 j_rndbnd=5 alpha_mean=-0.0 alpha_sigma=0.0 alpha_maxV=0.0 sigma=0 rdfulpath=/data/sep/xukai/huo1/2dWI_marm_4EAGE2012/rdful${str}-inode- sdep=sdep1.H rdep=sdep1.H

date
